# DO NOT EDIT! This file is automatically generated

import re

import marshmallow
import marshmallow_enum

from commercetools import helpers, types


class LocalizedStringField(marshmallow.fields.Dict):
    def _deserialize(self, value, attr, data):
        result = super()._deserialize(value, attr, data)
        return types.LocalizedString(**result)


class CategoryOrderHintsField(marshmallow.fields.Dict):
    def _deserialize(self, value, attr, data):
        result = super()._deserialize(value, attr, data)
        return types.CategoryOrderHints(**result)


class FieldContainerField(marshmallow.fields.Dict):
    def _deserialize(self, value, attr, data):
        result = super()._deserialize(value, attr, data)
        return types.FieldContainer(**result)


class AddressSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Address`."
    id = marshmallow.fields.String(allow_none=True, missing=None)
    key = marshmallow.fields.String(allow_none=True, missing=None)
    title = marshmallow.fields.String(allow_none=True, missing=None)
    salutation = marshmallow.fields.String(allow_none=True, missing=None)
    first_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="firstName"
    )
    last_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="lastName"
    )
    street_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="streetName"
    )
    street_number = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="streetNumber"
    )
    additional_street_info = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="additionalStreetInfo"
    )
    postal_code = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="postalCode"
    )
    city = marshmallow.fields.String(allow_none=True, missing=None)
    region = marshmallow.fields.String(allow_none=True, missing=None)
    state = marshmallow.fields.String(allow_none=True, missing=None)
    country = marshmallow.fields.String()
    company = marshmallow.fields.String(allow_none=True, missing=None)
    department = marshmallow.fields.String(allow_none=True, missing=None)
    building = marshmallow.fields.String(allow_none=True, missing=None)
    apartment = marshmallow.fields.String(allow_none=True, missing=None)
    p_o_box = marshmallow.fields.String(allow_none=True, missing=None, data_key="pOBox")
    phone = marshmallow.fields.String(allow_none=True, missing=None)
    mobile = marshmallow.fields.String(allow_none=True, missing=None)
    email = marshmallow.fields.String(allow_none=True, missing=None)
    fax = marshmallow.fields.String(allow_none=True, missing=None)
    additional_address_info = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="additionalAddressInfo"
    )
    external_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="externalId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Address(**data)


class ApiClientDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ApiClientDraft`."
    name = marshmallow.fields.String(allow_none=True)
    scope = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ApiClientDraft(**data)


class ApiClientPagedQueryResponseSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ApiClientPagedQueryResponse`."
    count = marshmallow.fields.Integer(allow_none=True)
    total = marshmallow.fields.Integer(allow_none=True, missing=None)
    offset = marshmallow.fields.Integer(allow_none=True)
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.ApiClientSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ApiClientPagedQueryResponse(**data)


class ApiClientSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ApiClient`."
    id = marshmallow.fields.String(allow_none=True)
    name = marshmallow.fields.String(allow_none=True)
    scope = marshmallow.fields.String(allow_none=True)
    created_at = marshmallow.fields.DateTime(allow_none=True, data_key="createdAt")
    last_used_at = marshmallow.fields.Date(
        allow_none=True, missing=None, data_key="lastUsedAt"
    )
    secret = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ApiClient(**data)


class AssetDimensionsSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.AssetDimensions`."
    w = marshmallow.fields.Integer(allow_none=True)
    h = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.AssetDimensions(**data)


class AssetDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.AssetDraft`."
    sources = marshmallow.fields.Nested(
        nested="commercetools.schemas.AssetSourceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    name = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    tags = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True), missing=None
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.AssetDraft(**data)


class AssetSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Asset`."
    id = marshmallow.fields.String(allow_none=True)
    sources = marshmallow.fields.Nested(
        nested="commercetools.schemas.AssetSourceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    name = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    tags = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True), missing=None
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Asset(**data)


class AssetSourceSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.AssetSource`."
    uri = marshmallow.fields.String(allow_none=True)
    key = marshmallow.fields.String(allow_none=True, missing=None)
    dimensions = marshmallow.fields.Nested(
        nested="commercetools.schemas.AssetDimensionsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    content_type = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="contentType"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.AssetSource(**data)


class AttributeDefinitionDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.AttributeDefinitionDraft`."
    type = helpers.Discriminator(
        discriminator_field=("name", "name"),
        discriminator_schemas={
            "boolean": "commercetools.schemas.AttributeBooleanTypeSchema",
            "datetime": "commercetools.schemas.AttributeDateTimeTypeSchema",
            "date": "commercetools.schemas.AttributeDateTypeSchema",
            "enum": "commercetools.schemas.AttributeEnumTypeSchema",
            "ltext": "commercetools.schemas.AttributeLocalizableTextTypeSchema",
            "lenum": "commercetools.schemas.AttributeLocalizedEnumTypeSchema",
            "money": "commercetools.schemas.AttributeMoneyTypeSchema",
            "nested": "commercetools.schemas.AttributeNestedTypeSchema",
            "number": "commercetools.schemas.AttributeNumberTypeSchema",
            "reference": "commercetools.schemas.AttributeReferenceTypeSchema",
            "set": "commercetools.schemas.AttributeSetTypeSchema",
            "text": "commercetools.schemas.AttributeTextTypeSchema",
            "time": "commercetools.schemas.AttributeTimeTypeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    name = marshmallow.fields.String(allow_none=True)
    label = LocalizedStringField(allow_none=True)
    is_required = marshmallow.fields.Bool(allow_none=True, data_key="isRequired")
    attribute_constraint = marshmallow_enum.EnumField(
        types.AttributeConstraintEnum,
        by_value=True,
        missing=None,
        data_key="attributeConstraint",
    )
    input_tip = LocalizedStringField(allow_none=True, missing=None, data_key="inputTip")
    input_hint = marshmallow_enum.EnumField(
        types.TextInputHint, by_value=True, missing=None, data_key="inputHint"
    )
    is_searchable = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isSearchable"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.AttributeDefinitionDraft(**data)


class AttributeDefinitionSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.AttributeDefinition`."
    type = helpers.Discriminator(
        discriminator_field=("name", "name"),
        discriminator_schemas={
            "boolean": "commercetools.schemas.AttributeBooleanTypeSchema",
            "datetime": "commercetools.schemas.AttributeDateTimeTypeSchema",
            "date": "commercetools.schemas.AttributeDateTypeSchema",
            "enum": "commercetools.schemas.AttributeEnumTypeSchema",
            "ltext": "commercetools.schemas.AttributeLocalizableTextTypeSchema",
            "lenum": "commercetools.schemas.AttributeLocalizedEnumTypeSchema",
            "money": "commercetools.schemas.AttributeMoneyTypeSchema",
            "nested": "commercetools.schemas.AttributeNestedTypeSchema",
            "number": "commercetools.schemas.AttributeNumberTypeSchema",
            "reference": "commercetools.schemas.AttributeReferenceTypeSchema",
            "set": "commercetools.schemas.AttributeSetTypeSchema",
            "text": "commercetools.schemas.AttributeTextTypeSchema",
            "time": "commercetools.schemas.AttributeTimeTypeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    name = marshmallow.fields.String(allow_none=True)
    label = LocalizedStringField(allow_none=True)
    is_required = marshmallow.fields.Bool(allow_none=True, data_key="isRequired")
    attribute_constraint = marshmallow_enum.EnumField(
        types.AttributeConstraintEnum, by_value=True, data_key="attributeConstraint"
    )
    input_tip = LocalizedStringField(allow_none=True, missing=None, data_key="inputTip")
    input_hint = marshmallow_enum.EnumField(
        types.TextInputHint, by_value=True, data_key="inputHint"
    )
    is_searchable = marshmallow.fields.Bool(allow_none=True, data_key="isSearchable")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.AttributeDefinition(**data)


class AttributeLocalizedEnumValueSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.AttributeLocalizedEnumValue`."
    key = marshmallow.fields.String(allow_none=True)
    label = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.AttributeLocalizedEnumValue(**data)


class AttributePlainEnumValueSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.AttributePlainEnumValue`."
    key = marshmallow.fields.String(allow_none=True)
    label = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.AttributePlainEnumValue(**data)


class AttributeSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Attribute`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Attribute(**data)


class AttributeTypeSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.AttributeType`."
    name = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.AttributeType(**data)


class CartDiscountDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountDraft`."
    name = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    value = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "absolute": "commercetools.schemas.CartDiscountValueAbsoluteSchema",
            "giftLineItem": "commercetools.schemas.CartDiscountValueGiftLineItemSchema",
            "relative": "commercetools.schemas.CartDiscountValueRelativeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    cart_predicate = marshmallow.fields.String(
        allow_none=True, data_key="cartPredicate"
    )
    target = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "customLineItems": "commercetools.schemas.CartDiscountCustomLineItemsTargetSchema",
            "lineItems": "commercetools.schemas.CartDiscountLineItemsTargetSchema",
            "shipping": "commercetools.schemas.CartDiscountShippingCostTargetSchema",
            "multiBuyCustomLineItems": "commercetools.schemas.MultiBuyCustomLineItemsTargetSchema",
            "multiBuyLineItems": "commercetools.schemas.MultiBuyLineItemsTargetSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    sort_order = marshmallow.fields.String(allow_none=True, data_key="sortOrder")
    is_active = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isActive"
    )
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )
    requires_discount_code = marshmallow.fields.Bool(
        allow_none=True, data_key="requiresDiscountCode"
    )
    stacking_mode = marshmallow_enum.EnumField(
        types.StackingMode, by_value=True, missing=None, data_key="stackingMode"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CartDiscountDraft(**data)


class CartDiscountTargetSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountTarget`."
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CartDiscountTarget(**data)


class CartDiscountValueSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountValue`."
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CartDiscountValue(**data)


class CartDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CartDraft`."
    currency = marshmallow.fields.String()
    customer_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerId"
    )
    customer_email = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerEmail"
    )
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="customerGroup",
    )
    anonymous_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="anonymousId"
    )
    country = marshmallow.fields.String(allow_none=True, missing=None)
    inventory_mode = marshmallow_enum.EnumField(
        types.InventoryMode, by_value=True, missing=None, data_key="inventoryMode"
    )
    tax_mode = marshmallow_enum.EnumField(
        types.TaxMode, by_value=True, missing=None, data_key="taxMode"
    )
    tax_rounding_mode = marshmallow_enum.EnumField(
        types.RoundingMode, by_value=True, missing=None, data_key="taxRoundingMode"
    )
    tax_calculation_mode = marshmallow_enum.EnumField(
        types.TaxCalculationMode,
        by_value=True,
        missing=None,
        data_key="taxCalculationMode",
    )
    line_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.LineItemDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="lineItems",
    )
    custom_line_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomLineItemDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="customLineItems",
    )
    shipping_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingAddress",
    )
    billing_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="billingAddress",
    )
    shipping_method = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingMethodReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingMethod",
    )
    external_tax_rate_for_shipping_method = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRateForShippingMethod",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    locale = marshmallow.fields.String(allow_none=True, missing=None)
    delete_days_after_last_modification = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="deleteDaysAfterLastModification"
    )
    origin = marshmallow_enum.EnumField(types.CartOrigin, by_value=True, missing=None)
    shipping_rate_input = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "Classification": "commercetools.schemas.ClassificationShippingRateInputDraftSchema",
            "Score": "commercetools.schemas.ScoreShippingRateInputDraftSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingRateInput",
    )
    item_shipping_addresses = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="itemShippingAddresses",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CartDraft(**data)


class CategoryDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CategoryDraft`."
    name = LocalizedStringField(allow_none=True)
    slug = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    parent = marshmallow.fields.Nested(
        nested="commercetools.schemas.CategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    order_hint = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="orderHint"
    )
    external_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="externalId"
    )
    meta_title = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaTitle"
    )
    meta_description = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaDescription"
    )
    meta_keywords = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaKeywords"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    assets = marshmallow.fields.Nested(
        nested="commercetools.schemas.AssetDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CategoryDraft(**data)


class ChangeSubscriptionSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ChangeSubscription`."
    resource_type_id = marshmallow.fields.String(
        allow_none=True, data_key="resourceTypeId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ChangeSubscription(**data)


class ChannelDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ChannelDraft`."
    key = marshmallow.fields.String(allow_none=True)
    roles = marshmallow.fields.List(
        marshmallow_enum.EnumField(types.ChannelRoleEnum, by_value=True), missing=None
    )
    name = LocalizedStringField(allow_none=True, missing=None)
    description = LocalizedStringField(allow_none=True, missing=None)
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    geo_location = marshmallow.fields.Nested(
        nested="commercetools.schemas.GeoJsonPointSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="geoLocation",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ChannelDraft(**data)


class CustomFieldEnumValueSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldEnumValue`."
    key = marshmallow.fields.String(allow_none=True)
    label = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomFieldEnumValue(**data)


class CustomFieldLocalizedEnumValueSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldLocalizedEnumValue`."
    key = marshmallow.fields.String(allow_none=True)
    label = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomFieldLocalizedEnumValue(**data)


class CustomFieldsDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldsDraft`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.ResourceIdentifierSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomFieldsDraft(**data)


class CustomFieldsSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomFields`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    fields = FieldContainerField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomFields(**data)


class CustomLineItemDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomLineItemDraft`."
    name = LocalizedStringField(allow_none=True)
    quantity = marshmallow.fields.Integer(allow_none=True)
    money = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    slug = marshmallow.fields.String(allow_none=True)
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    shipping_details = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetails",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomLineItemDraft(**data)


class CustomLineItemSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomLineItem`."
    id = marshmallow.fields.String(allow_none=True)
    name = LocalizedStringField(allow_none=True)
    money = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    taxed_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxedItemPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxedPrice",
    )
    total_price = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalPrice",
    )
    slug = marshmallow.fields.String(allow_none=True)
    quantity = marshmallow.fields.Integer(allow_none=True)
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemStateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxRateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxRate",
    )
    discounted_price_per_quantity = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountedLineItemPriceForQuantitySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="discountedPricePerQuantity",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    shipping_details = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetails",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomLineItem(**data)


class CustomObjectDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomObjectDraft`."
    container = marshmallow.fields.String(allow_none=True)
    key = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True)
    version = marshmallow.fields.Integer(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomObjectDraft(**data)


class CustomerChangePasswordSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomerChangePassword`."
    id = marshmallow.fields.String(allow_none=True)
    version = marshmallow.fields.Integer(allow_none=True)
    current_password = marshmallow.fields.String(
        allow_none=True, data_key="currentPassword"
    )
    new_password = marshmallow.fields.String(allow_none=True, data_key="newPassword")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerChangePassword(**data)


class CustomerCreateEmailTokenSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomerCreateEmailToken`."
    id = marshmallow.fields.String(allow_none=True)
    version = marshmallow.fields.Integer(allow_none=True, missing=None)
    ttl_minutes = marshmallow.fields.Integer(allow_none=True, data_key="ttlMinutes")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerCreateEmailToken(**data)


class CustomerCreatePasswordResetTokenSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomerCreatePasswordResetToken`."
    email = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerCreatePasswordResetToken(**data)


class CustomerDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomerDraft`."
    customer_number = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerNumber"
    )
    email = marshmallow.fields.String(allow_none=True)
    password = marshmallow.fields.String(allow_none=True)
    first_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="firstName"
    )
    last_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="lastName"
    )
    middle_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="middleName"
    )
    title = marshmallow.fields.String(allow_none=True, missing=None)
    anonymous_cart_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="anonymousCartId"
    )
    anonymous_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="anonymousId"
    )
    date_of_birth = marshmallow.fields.Date(
        allow_none=True, missing=None, data_key="dateOfBirth"
    )
    company_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="companyName"
    )
    vat_id = marshmallow.fields.String(allow_none=True, missing=None, data_key="vatId")
    addresses = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    default_shipping_address = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="defaultShippingAddress"
    )
    shipping_addresses = marshmallow.fields.List(
        marshmallow.fields.Integer(allow_none=True),
        missing=None,
        data_key="shippingAddresses",
    )
    default_billing_address = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="defaultBillingAddress"
    )
    billing_addresses = marshmallow.fields.List(
        marshmallow.fields.Integer(allow_none=True),
        missing=None,
        data_key="billingAddresses",
    )
    is_email_verified = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isEmailVerified"
    )
    external_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="externalId"
    )
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="customerGroup",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    locale = marshmallow.fields.String(allow_none=True, missing=None)
    salutation = marshmallow.fields.String(allow_none=True, missing=None)
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerDraft(**data)


class CustomerEmailVerifySchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomerEmailVerify`."
    version = marshmallow.fields.Integer(allow_none=True, missing=None)
    token_value = marshmallow.fields.String(allow_none=True, data_key="tokenValue")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerEmailVerify(**data)


class CustomerGroupDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomerGroupDraft`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    group_name = marshmallow.fields.String(allow_none=True, data_key="groupName")
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerGroupDraft(**data)


class CustomerResetPasswordSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomerResetPassword`."
    token_value = marshmallow.fields.String(allow_none=True, data_key="tokenValue")
    new_password = marshmallow.fields.String(allow_none=True, data_key="newPassword")
    version = marshmallow.fields.Integer(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerResetPassword(**data)


class CustomerSignInResultSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSignInResult`."
    customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    cart = marshmallow.fields.Dict(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerSignInResult(**data)


class CustomerSigninSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSignin`."
    email = marshmallow.fields.String(allow_none=True)
    password = marshmallow.fields.String(allow_none=True)
    anonymous_cart_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="anonymousCartId"
    )
    anonymous_cart_sign_in_mode = marshmallow_enum.EnumField(
        types.AnonymousCartSignInMode,
        by_value=True,
        missing=None,
        data_key="anonymousCartSignInMode",
    )
    anonymous_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="anonymousId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerSignin(**data)


class CustomerTokenSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.CustomerToken`."
    id = marshmallow.fields.String(allow_none=True)
    created_at = marshmallow.fields.DateTime(allow_none=True, data_key="createdAt")
    last_modified_at = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="lastModifiedAt"
    )
    customer_id = marshmallow.fields.String(allow_none=True, data_key="customerId")
    expires_at = marshmallow.fields.DateTime(allow_none=True, data_key="expiresAt")
    value = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerToken(**data)


class DeliveryFormatSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.DeliveryFormat`."
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.DeliveryFormat(**data)


class DeliveryItemSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.DeliveryItem`."
    id = marshmallow.fields.String(allow_none=True)
    quantity = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DeliveryItem(**data)


class DeliverySchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Delivery`."
    id = marshmallow.fields.String(allow_none=True)
    created_at = marshmallow.fields.DateTime(allow_none=True, data_key="createdAt")
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    parcels = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Delivery(**data)


class DestinationSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Destination`."
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.Destination(**data)


class DiscountCodeDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeDraft`."
    name = LocalizedStringField(allow_none=True, missing=None)
    description = LocalizedStringField(allow_none=True, missing=None)
    code = marshmallow.fields.String(allow_none=True)
    cart_discounts = marshmallow.fields.Nested(
        nested="commercetools.schemas.CartDiscountReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="cartDiscounts",
    )
    cart_predicate = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="cartPredicate"
    )
    is_active = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isActive"
    )
    max_applications = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="maxApplications"
    )
    max_applications_per_customer = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="maxApplicationsPerCustomer"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    groups = marshmallow.fields.List(
        marshmallow.fields.Nested(
            nested="commercetools.schemas.stringSchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
        missing=None,
    )
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DiscountCodeDraft(**data)


class DiscountCodeInfoSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeInfo`."
    discount_code = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountCodeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="discountCode",
    )
    state = marshmallow_enum.EnumField(types.DiscountCodeState, by_value=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DiscountCodeInfo(**data)


class DiscountedLineItemPortionSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.DiscountedLineItemPortion`."
    discount = marshmallow.fields.Nested(
        nested="commercetools.schemas.CartDiscountReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    discounted_amount = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="discountedAmount",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DiscountedLineItemPortion(**data)


class DiscountedLineItemPriceDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.DiscountedLineItemPriceDraft`."
    value = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    included_discounts = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountedLineItemPortionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="includedDiscounts",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DiscountedLineItemPriceDraft(**data)


class DiscountedLineItemPriceForQuantitySchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.DiscountedLineItemPriceForQuantity`."
    quantity = marshmallow.fields.Integer(allow_none=True)
    discounted_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountedLineItemPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="discountedPrice",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DiscountedLineItemPriceForQuantity(**data)


class DiscountedLineItemPriceSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.DiscountedLineItemPrice`."
    value = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    included_discounts = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountedLineItemPortionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="includedDiscounts",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DiscountedLineItemPrice(**data)


class DiscountedPriceSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.DiscountedPrice`."
    value = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    discount = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductDiscountReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DiscountedPrice(**data)


class ErrorObjectSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ErrorObject`."
    code = marshmallow.fields.String(allow_none=True)
    message = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.ErrorObject(**data)


class ErrorResponseSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ErrorResponse`."
    status_code = marshmallow.fields.Integer(allow_none=True, data_key="statusCode")
    message = marshmallow.fields.String(allow_none=True)
    error = marshmallow.fields.String(allow_none=True, missing=None)
    error_description = marshmallow.fields.String(allow_none=True, missing=None)
    errors = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("code", "code"),
            discriminator_schemas={
                "access_denied": "commercetools.schemas.AccessDeniedErrorSchema",
                "ConcurrentModification": "commercetools.schemas.ConcurrentModificationErrorSchema",
                "DiscountCodeNonApplicable": "commercetools.schemas.DiscountCodeNonApplicableErrorSchema",
                "DuplicateAttributeValue": "commercetools.schemas.DuplicateAttributeValueErrorSchema",
                "DuplicateAttributeValues": "commercetools.schemas.DuplicateAttributeValuesErrorSchema",
                "DuplicateField": "commercetools.schemas.DuplicateFieldErrorSchema",
                "DuplicatePriceScope": "commercetools.schemas.DuplicatePriceScopeErrorSchema",
                "DuplicateVariantValues": "commercetools.schemas.DuplicateVariantValuesErrorSchema",
                "insufficient_scope": "commercetools.schemas.InsufficientScopeErrorSchema",
                "InvalidCredentials": "commercetools.schemas.InvalidCredentialsErrorSchema",
                "InvalidCurrentPassword": "commercetools.schemas.InvalidCurrentPasswordErrorSchema",
                "InvalidField": "commercetools.schemas.InvalidFieldErrorSchema",
                "InvalidInput": "commercetools.schemas.InvalidInputErrorSchema",
                "InvalidItemShippingDetails": "commercetools.schemas.InvalidItemShippingDetailsErrorSchema",
                "InvalidJsonInput": "commercetools.schemas.InvalidJsonInputErrorSchema",
                "InvalidOperation": "commercetools.schemas.InvalidOperationErrorSchema",
                "InvalidSubject": "commercetools.schemas.InvalidSubjectErrorSchema",
                "invalid_token": "commercetools.schemas.InvalidTokenErrorSchema",
                "MissingTaxRateForCountry": "commercetools.schemas.MissingTaxRateForCountryErrorSchema",
                "NoMatchingProductDiscountFound": "commercetools.schemas.NoMatchingProductDiscountFoundErrorSchema",
                "OutOfStock": "commercetools.schemas.OutOfStockErrorSchema",
                "PriceChanged": "commercetools.schemas.PriceChangedErrorSchema",
                "ReferenceExists": "commercetools.schemas.ReferenceExistsErrorSchema",
                "RequiredField": "commercetools.schemas.RequiredFieldErrorSchema",
                "ResourceNotFound": "commercetools.schemas.ResourceNotFoundErrorSchema",
                "ShippingMethodDoesNotMatchCart": "commercetools.schemas.ShippingMethodDoesNotMatchCartErrorSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ErrorResponse(**data)


class ExtensionDestinationSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ExtensionDestination`."
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ExtensionDestination(**data)


class ExtensionDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ExtensionDraft`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    destination = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "AWSLambda": "commercetools.schemas.ExtensionAWSLambdaDestinationSchema",
            "HTTP": "commercetools.schemas.ExtensionHttpDestinationSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    triggers = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExtensionTriggerSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ExtensionDraft(**data)


class ExtensionHttpDestinationAuthenticationSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ExtensionHttpDestinationAuthentication`."
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ExtensionHttpDestinationAuthentication(**data)


class ExtensionInputSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ExtensionInput`."
    action = marshmallow_enum.EnumField(types.ExtensionAction, by_value=True)
    resource = helpers.Discriminator(
        discriminator_field=("typeId", "type_id"),
        discriminator_schemas={
            "cart-discount": "commercetools.schemas.CartDiscountReferenceSchema",
            "cart": "commercetools.schemas.CartReferenceSchema",
            "category": "commercetools.schemas.CategoryReferenceSchema",
            "channel": "commercetools.schemas.ChannelReferenceSchema",
            "key-value-document": "commercetools.schemas.CustomObjectReferenceSchema",
            "customer-group": "commercetools.schemas.CustomerGroupReferenceSchema",
            "customer": "commercetools.schemas.CustomerReferenceSchema",
            "discount-code": "commercetools.schemas.DiscountCodeReferenceSchema",
            "inventory-entry": "commercetools.schemas.InventoryEntryReferenceSchema",
            "order-edit": "commercetools.schemas.OrderEditReferenceSchema",
            "order": "commercetools.schemas.OrderReferenceSchema",
            "payment": "commercetools.schemas.PaymentReferenceSchema",
            "product-discount": "commercetools.schemas.ProductDiscountReferenceSchema",
            "product-type": "commercetools.schemas.ProductTypeReferenceSchema",
            "product": "commercetools.schemas.ProductReferenceSchema",
            "review": "commercetools.schemas.ReviewReferenceSchema",
            "shipping-method": "commercetools.schemas.ShippingMethodReferenceSchema",
            "shopping-list": "commercetools.schemas.ShoppingListReferenceSchema",
            "state": "commercetools.schemas.StateReferenceSchema",
            "tax-category": "commercetools.schemas.TaxCategoryReferenceSchema",
            "type": "commercetools.schemas.TypeReferenceSchema",
            "zone": "commercetools.schemas.ZoneReferenceSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ExtensionInput(**data)


class ExtensionTriggerSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ExtensionTrigger`."
    resource_type_id = marshmallow_enum.EnumField(
        types.ExtensionResourceTypeId, by_value=True, data_key="resourceTypeId"
    )
    actions = marshmallow.fields.List(
        marshmallow_enum.EnumField(types.ExtensionAction, by_value=True)
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ExtensionTrigger(**data)


class ExternalLineItemTotalPriceSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ExternalLineItemTotalPrice`."
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalPrice",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ExternalLineItemTotalPrice(**data)


class ExternalTaxAmountDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ExternalTaxAmountDraft`."
    total_gross = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalGross",
    )
    tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="taxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ExternalTaxAmountDraft(**data)


class ExternalTaxRateDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ExternalTaxRateDraft`."
    name = marshmallow.fields.String(allow_none=True)
    amount = marshmallow.fields.Integer(allow_none=True, missing=None)
    country = marshmallow.fields.String(allow_none=True)
    state = marshmallow.fields.String(allow_none=True, missing=None)
    sub_rates = marshmallow.fields.Nested(
        nested="commercetools.schemas.SubRateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="subRates",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ExternalTaxRateDraft(**data)


class FacetResultRangeSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.FacetResultRange`."
    from_ = marshmallow.fields.Integer(allow_none=True, data_key="from")
    from_str = marshmallow.fields.String(allow_none=True, data_key="fromStr")
    to = marshmallow.fields.Integer(allow_none=True)
    to_str = marshmallow.fields.String(allow_none=True, data_key="toStr")
    count = marshmallow.fields.Integer(allow_none=True)
    product_count = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="productCount"
    )
    total = marshmallow.fields.Integer(allow_none=True)
    min = marshmallow.fields.Integer(allow_none=True)
    max = marshmallow.fields.Integer(allow_none=True)
    mean = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.FacetResultRange(**data)


class FacetResultSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.FacetResult`."
    type = marshmallow_enum.EnumField(types.FacetTypes, by_value=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.FacetResult(**data)


class FacetResultTermSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.FacetResultTerm`."
    term = marshmallow.fields.Raw(allow_none=True)
    count = marshmallow.fields.Integer(allow_none=True)
    product_count = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="productCount"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.FacetResultTerm(**data)


class FacetResultsSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.FacetResults`."
    _regex = helpers.RegexField(
        unknown=marshmallow.EXCLUDE,
        pattern=re.compile("^[a-z].*$"),
        type=helpers.Discriminator(
            discriminator_field=("type", "type"),
            discriminator_schemas={
                "filter": "commercetools.schemas.FilteredFacetResultSchema",
                "range": "commercetools.schemas.RangeFacetResultSchema",
                "terms": "commercetools.schemas.TermFacetResultSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        data = self.fields["_regex"].postprocess(data)
        return types.FacetResults(**data)

    @marshmallow.pre_load
    def pre_load(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.pre_dump
    def pre_dump(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.post_dump
    def post_dump(self, data):
        data = self.fields["_regex"].postprocess(data)
        return data


class FieldDefinitionSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.FieldDefinition`."
    type = marshmallow.fields.Dict(allow_none=True)
    name = marshmallow.fields.String(allow_none=True)
    label = LocalizedStringField(allow_none=True)
    required = marshmallow.fields.Bool(allow_none=True)
    input_hint = marshmallow_enum.EnumField(
        types.TypeTextInputHint, by_value=True, missing=None, data_key="inputHint"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.FieldDefinition(**data)


class FieldTypeSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.FieldType`."
    name = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.FieldType(**data)


class GeoJsonSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.GeoJson`."
    type = marshmallow.fields.String(allow_none=True)
    coordinates = marshmallow.fields.List(
        marshmallow.fields.Nested(
            nested="commercetools.schemas.anySchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.GeoJson(**data)


class ImageDimensionsSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ImageDimensions`."
    w = marshmallow.fields.Integer(allow_none=True)
    h = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ImageDimensions(**data)


class ImageSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Image`."
    url = marshmallow.fields.String(allow_none=True)
    dimensions = marshmallow.fields.Nested(
        nested="commercetools.schemas.ImageDimensionsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    label = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Image(**data)


class InventoryEntryDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.InventoryEntryDraft`."
    sku = marshmallow.fields.String(allow_none=True)
    supply_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="supplyChannel",
    )
    quantity_on_stock = marshmallow.fields.Integer(
        allow_none=True, data_key="quantityOnStock"
    )
    restockable_in_days = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="restockableInDays"
    )
    expected_delivery = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="expectedDelivery"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.InventoryEntryDraft(**data)


class ItemShippingDetailsDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ItemShippingDetailsDraft`."
    targets = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingTargetSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ItemShippingDetailsDraft(**data)


class ItemShippingDetailsSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ItemShippingDetails`."
    targets = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingTargetSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    valid = marshmallow.fields.Bool(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ItemShippingDetails(**data)


class ItemShippingTargetSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ItemShippingTarget`."
    address_key = marshmallow.fields.String(allow_none=True, data_key="addressKey")
    quantity = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ItemShippingTarget(**data)


class ItemStateSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ItemState`."
    quantity = marshmallow.fields.Integer(allow_none=True)
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ItemState(**data)


class LineItemDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.LineItemDraft`."
    product_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="productId"
    )
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    quantity = marshmallow.fields.Integer(allow_none=True, missing=None)
    supply_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="supplyChannel",
    )
    distribution_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="distributionChannel",
    )
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    external_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalPrice",
    )
    external_total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalLineItemTotalPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTotalPrice",
    )
    shipping_details = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetails",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.LineItemDraft(**data)


class LineItemImportDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.LineItemImportDraft`."
    product_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="productId"
    )
    name = LocalizedStringField(allow_none=True)
    variant = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductVariantImportDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    quantity = marshmallow.fields.Integer(allow_none=True)
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemStateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    supply_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="supplyChannel",
    )
    tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxRateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxRate",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    shipping_details = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetails",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.LineItemImportDraft(**data)


class LineItemSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.LineItem`."
    id = marshmallow.fields.String(allow_none=True)
    product_id = marshmallow.fields.String(allow_none=True, data_key="productId")
    name = LocalizedStringField(allow_none=True)
    product_slug = LocalizedStringField(
        allow_none=True, missing=None, data_key="productSlug"
    )
    product_type = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductTypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="productType",
    )
    variant = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductVariantSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    taxed_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxedItemPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxedPrice",
    )
    total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalPrice",
    )
    quantity = marshmallow.fields.Integer(allow_none=True)
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemStateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxRateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxRate",
    )
    supply_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="supplyChannel",
    )
    distribution_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="distributionChannel",
    )
    discounted_price_per_quantity = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountedLineItemPriceForQuantitySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="discountedPricePerQuantity",
    )
    price_mode = marshmallow_enum.EnumField(
        types.LineItemPriceMode, by_value=True, data_key="priceMode"
    )
    line_item_mode = marshmallow_enum.EnumField(
        types.LineItemMode, by_value=True, data_key="lineItemMode"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    shipping_details = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetails",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.LineItem(**data)


class LocationSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Location`."
    country = marshmallow.fields.String()
    state = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Location(**data)


class MessageConfigurationDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.MessageConfigurationDraft`."
    enabled = marshmallow.fields.Bool(allow_none=True)
    delete_days_after_creation = marshmallow.fields.Integer(
        allow_none=True, data_key="deleteDaysAfterCreation"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.MessageConfigurationDraft(**data)


class MessageConfigurationSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.MessageConfiguration`."
    enabled = marshmallow.fields.Bool(allow_none=True)
    delete_days_after_creation = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="deleteDaysAfterCreation"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.MessageConfiguration(**data)


class MessagePayloadSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.MessagePayload`."
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.MessagePayload(**data)


class MessageSubscriptionSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.MessageSubscription`."
    resource_type_id = marshmallow.fields.String(
        allow_none=True, data_key="resourceTypeId"
    )
    types = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True), missing=None
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.MessageSubscription(**data)


class MoneySchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Money`."
    cent_amount = marshmallow.fields.Integer(allow_none=True, data_key="centAmount")
    currency_code = marshmallow.fields.String(data_key="currencyCode")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Money(**data)


class MyCartDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.MyCartDraft`."
    currency = marshmallow.fields.String()
    customer_email = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerEmail"
    )
    country = marshmallow.fields.String(allow_none=True, missing=None)
    inventory_mode = marshmallow_enum.EnumField(
        types.InventoryMode, by_value=True, missing=None, data_key="inventoryMode"
    )
    line_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.MyLineItemDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="lineItems",
    )
    shipping_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingAddress",
    )
    billing_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="billingAddress",
    )
    shipping_method = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingMethodReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingMethod",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    locale = marshmallow.fields.String(allow_none=True, missing=None)
    tax_mode = marshmallow_enum.EnumField(
        types.TaxMode, by_value=True, missing=None, data_key="taxMode"
    )
    delete_days_after_last_modification = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="deleteDaysAfterLastModification"
    )
    item_shipping_addresses = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="itemShippingAddresses",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.MyCartDraft(**data)


class MyCustomerDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.MyCustomerDraft`."
    email = marshmallow.fields.String(allow_none=True)
    password = marshmallow.fields.String(allow_none=True)
    first_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="firstName"
    )
    last_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="lastName"
    )
    middle_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="middleName"
    )
    title = marshmallow.fields.String(allow_none=True, missing=None)
    date_of_birth = marshmallow.fields.Date(
        allow_none=True, missing=None, data_key="dateOfBirth"
    )
    company_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="companyName"
    )
    vat_id = marshmallow.fields.String(allow_none=True, missing=None, data_key="vatId")
    addresses = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    default_shipping_address = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="defaultShippingAddress"
    )
    default_billing_address = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="defaultBillingAddress"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    locale = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.MyCustomerDraft(**data)


class MyLineItemDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.MyLineItemDraft`."
    product_id = marshmallow.fields.String(allow_none=True, data_key="productId")
    variant_id = marshmallow.fields.Integer(allow_none=True, data_key="variantId")
    quantity = marshmallow.fields.Integer(allow_none=True)
    supply_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="supplyChannel",
    )
    distribution_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="distributionChannel",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    shipping_details = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetails",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.MyLineItemDraft(**data)


class MyOrderFromCartDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.MyOrderFromCartDraft`."
    id = marshmallow.fields.String(allow_none=True)
    version = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.MyOrderFromCartDraft(**data)


class OrderEditApplySchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditApply`."
    edit_version = marshmallow.fields.Integer(allow_none=True, data_key="editVersion")
    resource_version = marshmallow.fields.Integer(
        allow_none=True, data_key="resourceVersion"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderEditApply(**data)


class OrderEditDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditDraft`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    resource = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    staged_actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addCustomLineItem": "commercetools.schemas.StagedOrderAddCustomLineItemActionSchema",
                "addDelivery": "commercetools.schemas.StagedOrderAddDeliveryActionSchema",
                "addDiscountCode": "commercetools.schemas.StagedOrderAddDiscountCodeActionSchema",
                "addItemShippingAddress": "commercetools.schemas.StagedOrderAddItemShippingAddressActionSchema",
                "addLineItem": "commercetools.schemas.StagedOrderAddLineItemActionSchema",
                "addParcelToDelivery": "commercetools.schemas.StagedOrderAddParcelToDeliveryActionSchema",
                "addPayment": "commercetools.schemas.StagedOrderAddPaymentActionSchema",
                "addReturnInfo": "commercetools.schemas.StagedOrderAddReturnInfoActionSchema",
                "addShoppingList": "commercetools.schemas.StagedOrderAddShoppingListActionSchema",
                "changeCustomLineItemMoney": "commercetools.schemas.StagedOrderChangeCustomLineItemMoneyActionSchema",
                "changeCustomLineItemQuantity": "commercetools.schemas.StagedOrderChangeCustomLineItemQuantityActionSchema",
                "changeLineItemQuantity": "commercetools.schemas.StagedOrderChangeLineItemQuantityActionSchema",
                "changeOrderState": "commercetools.schemas.StagedOrderChangeOrderStateActionSchema",
                "changePaymentState": "commercetools.schemas.StagedOrderChangePaymentStateActionSchema",
                "changeShipmentState": "commercetools.schemas.StagedOrderChangeShipmentStateActionSchema",
                "changeTaxCalculationMode": "commercetools.schemas.StagedOrderChangeTaxCalculationModeActionSchema",
                "changeTaxMode": "commercetools.schemas.StagedOrderChangeTaxModeActionSchema",
                "changeTaxRoundingMode": "commercetools.schemas.StagedOrderChangeTaxRoundingModeActionSchema",
                "importCustomLineItemState": "commercetools.schemas.StagedOrderImportCustomLineItemStateActionSchema",
                "importLineItemState": "commercetools.schemas.StagedOrderImportLineItemStateActionSchema",
                "removeCustomLineItem": "commercetools.schemas.StagedOrderRemoveCustomLineItemActionSchema",
                "removeDelivery": "commercetools.schemas.StagedOrderRemoveDeliveryActionSchema",
                "removeDiscountCode": "commercetools.schemas.StagedOrderRemoveDiscountCodeActionSchema",
                "removeItemShippingAddress": "commercetools.schemas.StagedOrderRemoveItemShippingAddressActionSchema",
                "removeLineItem": "commercetools.schemas.StagedOrderRemoveLineItemActionSchema",
                "removeParcelFromDelivery": "commercetools.schemas.StagedOrderRemoveParcelFromDeliveryActionSchema",
                "removePayment": "commercetools.schemas.StagedOrderRemovePaymentActionSchema",
                "setBillingAddress": "commercetools.schemas.StagedOrderSetBillingAddressActionSchema",
                "setCountry": "commercetools.schemas.StagedOrderSetCountryActionSchema",
                "setCustomField": "commercetools.schemas.StagedOrderSetCustomFieldActionSchema",
                "setCustomLineItemCustomField": "commercetools.schemas.StagedOrderSetCustomLineItemCustomFieldActionSchema",
                "setCustomLineItemCustomType": "commercetools.schemas.StagedOrderSetCustomLineItemCustomTypeActionSchema",
                "setCustomLineItemShippingDetails": "commercetools.schemas.StagedOrderSetCustomLineItemShippingDetailsActionSchema",
                "setCustomLineItemTaxAmount": "commercetools.schemas.StagedOrderSetCustomLineItemTaxAmountActionSchema",
                "setCustomLineItemTaxRate": "commercetools.schemas.StagedOrderSetCustomLineItemTaxRateActionSchema",
                "setCustomShippingMethod": "commercetools.schemas.StagedOrderSetCustomShippingMethodActionSchema",
                "setCustomType": "commercetools.schemas.StagedOrderSetCustomTypeActionSchema",
                "setCustomerEmail": "commercetools.schemas.StagedOrderSetCustomerEmailActionSchema",
                "setCustomerGroup": "commercetools.schemas.StagedOrderSetCustomerGroupActionSchema",
                "setCustomerId": "commercetools.schemas.StagedOrderSetCustomerIdActionSchema",
                "setDeliveryAddress": "commercetools.schemas.StagedOrderSetDeliveryAddressActionSchema",
                "setDeliveryItems": "commercetools.schemas.StagedOrderSetDeliveryItemsActionSchema",
                "setLineItemCustomField": "commercetools.schemas.StagedOrderSetLineItemCustomFieldActionSchema",
                "setLineItemCustomType": "commercetools.schemas.StagedOrderSetLineItemCustomTypeActionSchema",
                "setLineItemPrice": "commercetools.schemas.StagedOrderSetLineItemPriceActionSchema",
                "setLineItemShippingDetails": "commercetools.schemas.StagedOrderSetLineItemShippingDetailsActionSchema",
                "setLineItemTaxAmount": "commercetools.schemas.StagedOrderSetLineItemTaxAmountActionSchema",
                "setLineItemTaxRate": "commercetools.schemas.StagedOrderSetLineItemTaxRateActionSchema",
                "setLineItemTotalPrice": "commercetools.schemas.StagedOrderSetLineItemTotalPriceActionSchema",
                "setLocale": "commercetools.schemas.StagedOrderSetLocaleActionSchema",
                "setOrderNumber": "commercetools.schemas.StagedOrderSetOrderNumberActionSchema",
                "setOrderTotalTax": "commercetools.schemas.StagedOrderSetOrderTotalTaxActionSchema",
                "setParcelItems": "commercetools.schemas.StagedOrderSetParcelItemsActionSchema",
                "setParcelMeasurements": "commercetools.schemas.StagedOrderSetParcelMeasurementsActionSchema",
                "setParcelTrackingData": "commercetools.schemas.StagedOrderSetParcelTrackingDataActionSchema",
                "setReturnPaymentState": "commercetools.schemas.StagedOrderSetReturnPaymentStateActionSchema",
                "setReturnShipmentState": "commercetools.schemas.StagedOrderSetReturnShipmentStateActionSchema",
                "setShippingAddress": "commercetools.schemas.StagedOrderSetShippingAddressActionSchema",
                "setShippingAddressAndCustomShippingMethod": "commercetools.schemas.StagedOrderSetShippingAddressAndCustomShippingMethodActionSchema",
                "setShippingAddressAndShippingMethod": "commercetools.schemas.StagedOrderSetShippingAddressAndShippingMethodActionSchema",
                "setShippingMethod": "commercetools.schemas.StagedOrderSetShippingMethodActionSchema",
                "setShippingMethodTaxAmount": "commercetools.schemas.StagedOrderSetShippingMethodTaxAmountActionSchema",
                "setShippingMethodTaxRate": "commercetools.schemas.StagedOrderSetShippingMethodTaxRateActionSchema",
                "setShippingRateInput": "commercetools.schemas.StagedOrderSetShippingRateInputActionSchema",
                "transitionCustomLineItemState": "commercetools.schemas.StagedOrderTransitionCustomLineItemStateActionSchema",
                "transitionLineItemState": "commercetools.schemas.StagedOrderTransitionLineItemStateActionSchema",
                "transitionState": "commercetools.schemas.StagedOrderTransitionStateActionSchema",
                "updateItemShippingAddress": "commercetools.schemas.StagedOrderUpdateItemShippingAddressActionSchema",
                "updateSyncInfo": "commercetools.schemas.StagedOrderUpdateSyncInfoActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        missing=None,
        data_key="stagedActions",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    comment = marshmallow.fields.String(allow_none=True, missing=None)
    dry_run = marshmallow.fields.Bool(allow_none=True, missing=None, data_key="dryRun")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderEditDraft(**data)


class OrderEditResultSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditResult`."
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderEditResult(**data)


class OrderExcerptSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.OrderExcerpt`."
    total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalPrice",
    )
    taxed_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxedPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxedPrice",
    )
    version = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderExcerpt(**data)


class OrderFromCartDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.OrderFromCartDraft`."
    id = marshmallow.fields.String(allow_none=True)
    version = marshmallow.fields.Integer(allow_none=True)
    order_number = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="orderNumber"
    )
    payment_state = marshmallow_enum.EnumField(
        types.PaymentState, by_value=True, missing=None, data_key="paymentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderFromCartDraft(**data)


class OrderImportDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.OrderImportDraft`."
    order_number = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="orderNumber"
    )
    customer_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerId"
    )
    customer_email = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerEmail"
    )
    line_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.LineItemImportDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="lineItems",
    )
    custom_line_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomLineItemDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="customLineItems",
    )
    total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalPrice",
    )
    taxed_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxedPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxedPrice",
    )
    shipping_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingAddress",
    )
    billing_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="billingAddress",
    )
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="customerGroup",
    )
    country = marshmallow.fields.String(allow_none=True, missing=None)
    order_state = marshmallow_enum.EnumField(
        types.OrderState, by_value=True, missing=None, data_key="orderState"
    )
    shipment_state = marshmallow_enum.EnumField(
        types.ShipmentState, by_value=True, missing=None, data_key="shipmentState"
    )
    payment_state = marshmallow_enum.EnumField(
        types.PaymentState, by_value=True, missing=None, data_key="paymentState"
    )
    shipping_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingInfoDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingInfo",
    )
    completed_at = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="completedAt"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    inventory_mode = marshmallow_enum.EnumField(
        types.InventoryMode, by_value=True, missing=None, data_key="inventoryMode"
    )
    tax_rounding_mode = marshmallow_enum.EnumField(
        types.RoundingMode, by_value=True, missing=None, data_key="taxRoundingMode"
    )
    item_shipping_addresses = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="itemShippingAddresses",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderImportDraft(**data)


class PagedQueryResponseSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.PagedQueryResponse`."
    count = marshmallow.fields.Integer(allow_none=True)
    total = marshmallow.fields.Integer(allow_none=True, missing=None)
    offset = marshmallow.fields.Integer(allow_none=True)
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.ResourceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PagedQueryResponse(**data)


class ParcelDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ParcelDraft`."
    measurements = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelMeasurementsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    tracking_data = marshmallow.fields.Nested(
        nested="commercetools.schemas.TrackingDataSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="trackingData",
    )
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ParcelDraft(**data)


class ParcelMeasurementsSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ParcelMeasurements`."
    height_in_millimeter = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="heightInMillimeter"
    )
    length_in_millimeter = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="lengthInMillimeter"
    )
    width_in_millimeter = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="widthInMillimeter"
    )
    weight_in_gram = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="weightInGram"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ParcelMeasurements(**data)


class ParcelSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Parcel`."
    id = marshmallow.fields.String(allow_none=True)
    created_at = marshmallow.fields.DateTime(allow_none=True, data_key="createdAt")
    measurements = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelMeasurementsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    tracking_data = marshmallow.fields.Nested(
        nested="commercetools.schemas.TrackingDataSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="trackingData",
    )
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Parcel(**data)


class PayloadNotIncludedSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.PayloadNotIncluded`."
    reason = marshmallow.fields.String(allow_none=True)
    payload_type = marshmallow.fields.String(allow_none=True, data_key="payloadType")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PayloadNotIncluded(**data)


class PaymentDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.PaymentDraft`."
    customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    anonymous_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="anonymousId"
    )
    external_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="externalId"
    )
    interface_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="interfaceId"
    )
    amount_planned = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="amountPlanned",
    )
    amount_authorized = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="amountAuthorized",
    )
    authorized_until = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="authorizedUntil"
    )
    amount_paid = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="amountPaid",
    )
    amount_refunded = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="amountRefunded",
    )
    payment_method_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentMethodInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="paymentMethodInfo",
    )
    payment_status = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentStatusSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="paymentStatus",
    )
    transactions = marshmallow.fields.Nested(
        nested="commercetools.schemas.TransactionDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    interface_interactions = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="interfaceInteractions",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PaymentDraft(**data)


class PaymentInfoSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.PaymentInfo`."
    payments = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PaymentInfo(**data)


class PaymentMethodInfoSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.PaymentMethodInfo`."
    payment_interface = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="paymentInterface"
    )
    method = marshmallow.fields.String(allow_none=True, missing=None)
    name = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PaymentMethodInfo(**data)


class PaymentStatusSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.PaymentStatus`."
    interface_code = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="interfaceCode"
    )
    interface_text = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="interfaceText"
    )
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PaymentStatus(**data)


class PriceDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.PriceDraft`."
    value = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    country = marshmallow.fields.String(missing=None)
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="customerGroup",
    )
    channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    tiers = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceTierSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PriceDraft(**data)


class PriceFunctionSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.PriceFunction`."
    currency_code = marshmallow.fields.String(data_key="currencyCode")
    function = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PriceFunction(**data)


class PriceSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Price`."
    id = marshmallow.fields.String(allow_none=True, missing=None)
    value = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    country = marshmallow.fields.String(missing=None)
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="customerGroup",
    )
    channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )
    discounted = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountedPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    tiers = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceTierSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Price(**data)


class PriceTierSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.PriceTier`."
    minimum_quantity = marshmallow.fields.Integer(
        allow_none=True, data_key="minimumQuantity"
    )
    value = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PriceTier(**data)


class ProductCatalogDataSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductCatalogData`."
    published = marshmallow.fields.Bool(allow_none=True)
    current = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductDataSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    staged = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductDataSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    has_staged_changes = marshmallow.fields.Bool(
        allow_none=True, data_key="hasStagedChanges"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductCatalogData(**data)


class ProductDataSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductData`."
    name = LocalizedStringField(allow_none=True)
    categories = marshmallow.fields.Nested(
        nested="commercetools.schemas.CategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    category_order_hints = CategoryOrderHintsField(
        allow_none=True, missing=None, data_key="categoryOrderHints"
    )
    description = LocalizedStringField(allow_none=True, missing=None)
    slug = LocalizedStringField(allow_none=True)
    meta_title = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaTitle"
    )
    meta_description = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaDescription"
    )
    meta_keywords = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaKeywords"
    )
    master_variant = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductVariantSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="masterVariant",
    )
    variants = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductVariantSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    search_keywords = marshmallow.fields.Nested(
        nested="commercetools.schemas.SearchKeywordsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="searchKeywords",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductData(**data)


class ProductDiscountDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountDraft`."
    name = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    value = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "absolute": "commercetools.schemas.ProductDiscountValueAbsoluteSchema",
            "external": "commercetools.schemas.ProductDiscountValueExternalSchema",
            "relative": "commercetools.schemas.ProductDiscountValueRelativeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    predicate = marshmallow.fields.String(allow_none=True)
    sort_order = marshmallow.fields.String(allow_none=True, data_key="sortOrder")
    is_active = marshmallow.fields.Bool(allow_none=True, data_key="isActive")
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductDiscountDraft(**data)


class ProductDiscountMatchQuerySchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountMatchQuery`."
    product_id = marshmallow.fields.String(allow_none=True, data_key="productId")
    variant_id = marshmallow.fields.Integer(allow_none=True, data_key="variantId")
    staged = marshmallow.fields.Bool(allow_none=True)
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductDiscountMatchQuery(**data)


class ProductDiscountValueSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountValue`."
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductDiscountValue(**data)


class ProductDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductDraft`."
    product_type = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductTypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="productType",
    )
    name = LocalizedStringField(allow_none=True)
    slug = LocalizedStringField(allow_none=True)
    key = marshmallow.fields.String(allow_none=True, missing=None)
    description = LocalizedStringField(allow_none=True, missing=None)
    categories = marshmallow.fields.Nested(
        nested="commercetools.schemas.CategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    category_order_hints = CategoryOrderHintsField(
        allow_none=True, missing=None, data_key="categoryOrderHints"
    )
    meta_title = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaTitle"
    )
    meta_description = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaDescription"
    )
    meta_keywords = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaKeywords"
    )
    master_variant = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductVariantDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="masterVariant",
    )
    variants = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductVariantDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    search_keywords = marshmallow.fields.Nested(
        nested="commercetools.schemas.SearchKeywordsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="searchKeywords",
    )
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    publish = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductDraft(**data)


class ProductTypeDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeDraft`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    name = marshmallow.fields.String(allow_none=True)
    description = marshmallow.fields.String(allow_none=True)
    attributes = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeDefinitionDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductTypeDraft(**data)


class ProductVariantAvailabilitySchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductVariantAvailability`."
    is_on_stock = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isOnStock"
    )
    restockable_in_days = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="restockableInDays"
    )
    available_quantity = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="availableQuantity"
    )
    channels = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductVariantChannelAvailabilityMapSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductVariantAvailability(**data)


class ProductVariantChannelAvailabilityMapSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductVariantChannelAvailabilityMap`."
    _regex = helpers.RegexField(
        unknown=marshmallow.EXCLUDE,
        pattern=re.compile(""),
        type=marshmallow.fields.Nested(
            nested="commercetools.schemas.ProductVariantChannelAvailabilitySchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        data = self.fields["_regex"].postprocess(data)
        return types.ProductVariantChannelAvailabilityMap(**data)

    @marshmallow.pre_load
    def pre_load(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.pre_dump
    def pre_dump(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.post_dump
    def post_dump(self, data):
        data = self.fields["_regex"].postprocess(data)
        return data


class ProductVariantChannelAvailabilitySchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductVariantChannelAvailability`."
    is_on_stock = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isOnStock"
    )
    restockable_in_days = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="restockableInDays"
    )
    available_quantity = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="availableQuantity"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductVariantChannelAvailability(**data)


class ProductVariantDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductVariantDraft`."
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    key = marshmallow.fields.String(allow_none=True, missing=None)
    prices = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    attributes = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    images = marshmallow.fields.Nested(
        nested="commercetools.schemas.ImageSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    assets = marshmallow.fields.Nested(
        nested="commercetools.schemas.AssetDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductVariantDraft(**data)


class ProductVariantImportDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductVariantImportDraft`."
    id = marshmallow.fields.Integer(allow_none=True, missing=None)
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    prices = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    attributes = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    images = marshmallow.fields.Nested(
        nested="commercetools.schemas.ImageSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductVariantImportDraft(**data)


class ProductVariantSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductVariant`."
    id = marshmallow.fields.Integer(allow_none=True)
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    key = marshmallow.fields.String(allow_none=True, missing=None)
    prices = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    attributes = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    images = marshmallow.fields.Nested(
        nested="commercetools.schemas.ImageSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    assets = marshmallow.fields.Nested(
        nested="commercetools.schemas.AssetSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    availability = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductVariantAvailabilitySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    is_matching_variant = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isMatchingVariant"
    )
    scoped_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.ScopedPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="scopedPrice",
    )
    scoped_price_discounted = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="scopedPriceDiscounted"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductVariant(**data)


class ProjectSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Project`."
    version = marshmallow.fields.Integer(allow_none=True)
    key = marshmallow.fields.String(allow_none=True)
    name = marshmallow.fields.String(allow_none=True)
    countries = marshmallow.fields.List(marshmallow.fields.String())
    currencies = marshmallow.fields.List(marshmallow.fields.String())
    languages = marshmallow.fields.List(marshmallow.fields.String())
    created_at = marshmallow.fields.DateTime(allow_none=True, data_key="createdAt")
    trial_until = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="trialUntil"
    )
    messages = marshmallow.fields.Nested(
        nested="commercetools.schemas.MessageConfigurationSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    shipping_rate_input_type = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "CartClassification": "commercetools.schemas.CartClassificationTypeSchema",
            "CartScore": "commercetools.schemas.CartScoreTypeSchema",
            "CartValue": "commercetools.schemas.CartValueTypeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingRateInputType",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Project(**data)


class ReplicaCartDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ReplicaCartDraft`."
    reference = helpers.Discriminator(
        discriminator_field=("typeId", "type_id"),
        discriminator_schemas={
            "cart-discount": "commercetools.schemas.CartDiscountReferenceSchema",
            "cart": "commercetools.schemas.CartReferenceSchema",
            "category": "commercetools.schemas.CategoryReferenceSchema",
            "channel": "commercetools.schemas.ChannelReferenceSchema",
            "key-value-document": "commercetools.schemas.CustomObjectReferenceSchema",
            "customer-group": "commercetools.schemas.CustomerGroupReferenceSchema",
            "customer": "commercetools.schemas.CustomerReferenceSchema",
            "discount-code": "commercetools.schemas.DiscountCodeReferenceSchema",
            "inventory-entry": "commercetools.schemas.InventoryEntryReferenceSchema",
            "order-edit": "commercetools.schemas.OrderEditReferenceSchema",
            "order": "commercetools.schemas.OrderReferenceSchema",
            "payment": "commercetools.schemas.PaymentReferenceSchema",
            "product-discount": "commercetools.schemas.ProductDiscountReferenceSchema",
            "product-type": "commercetools.schemas.ProductTypeReferenceSchema",
            "product": "commercetools.schemas.ProductReferenceSchema",
            "review": "commercetools.schemas.ReviewReferenceSchema",
            "shipping-method": "commercetools.schemas.ShippingMethodReferenceSchema",
            "shopping-list": "commercetools.schemas.ShoppingListReferenceSchema",
            "state": "commercetools.schemas.StateReferenceSchema",
            "tax-category": "commercetools.schemas.TaxCategoryReferenceSchema",
            "type": "commercetools.schemas.TypeReferenceSchema",
            "zone": "commercetools.schemas.ZoneReferenceSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ReplicaCartDraft(**data)


class ResourceIdentifierSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ResourceIdentifier`."
    type_id = marshmallow_enum.EnumField(
        types.ReferenceTypeId, by_value=True, missing=None, data_key="typeId"
    )
    id = marshmallow.fields.String(allow_none=True, missing=None)
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ResourceIdentifier(**data)


class ResourceSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Resource`."
    id = marshmallow.fields.String(allow_none=True)
    version = marshmallow.fields.Integer(allow_none=True)
    created_at = marshmallow.fields.DateTime(allow_none=True, data_key="createdAt")
    last_modified_at = marshmallow.fields.DateTime(
        allow_none=True, data_key="lastModifiedAt"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Resource(**data)


class ReturnInfoSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ReturnInfo`."
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.ReturnItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    return_tracking_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="returnTrackingId"
    )
    return_date = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="returnDate"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ReturnInfo(**data)


class ReturnItemDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ReturnItemDraft`."
    quantity = marshmallow.fields.Integer(allow_none=True)
    line_item_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="lineItemId"
    )
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customLineItemId"
    )
    comment = marshmallow.fields.String(allow_none=True, missing=None)
    shipment_state = marshmallow_enum.EnumField(
        types.ReturnShipmentState, by_value=True, data_key="shipmentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ReturnItemDraft(**data)


class ReturnItemSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ReturnItem`."
    id = marshmallow.fields.String(allow_none=True)
    quantity = marshmallow.fields.Integer(allow_none=True)
    type = marshmallow.fields.String(allow_none=True)
    comment = marshmallow.fields.String(allow_none=True, missing=None)
    shipment_state = marshmallow_enum.EnumField(
        types.ReturnShipmentState, by_value=True, data_key="shipmentState"
    )
    payment_state = marshmallow_enum.EnumField(
        types.ReturnPaymentState, by_value=True, data_key="paymentState"
    )
    last_modified_at = marshmallow.fields.DateTime(
        allow_none=True, data_key="lastModifiedAt"
    )
    created_at = marshmallow.fields.DateTime(allow_none=True, data_key="createdAt")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ReturnItem(**data)


class ReviewDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ReviewDraft`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    uniqueness_value = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="uniquenessValue"
    )
    locale = marshmallow.fields.String(allow_none=True, missing=None)
    author_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="authorName"
    )
    title = marshmallow.fields.String(allow_none=True, missing=None)
    text = marshmallow.fields.String(allow_none=True, missing=None)
    target = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.ResourceIdentifierSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    rating = marshmallow.fields.Float(allow_none=True, missing=None)
    customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ReviewDraft(**data)


class ReviewRatingStatisticsSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ReviewRatingStatistics`."
    average_rating = marshmallow.fields.Integer(
        allow_none=True, data_key="averageRating"
    )
    highest_rating = marshmallow.fields.Integer(
        allow_none=True, data_key="highestRating"
    )
    lowest_rating = marshmallow.fields.Integer(allow_none=True, data_key="lowestRating")
    count = marshmallow.fields.Integer(allow_none=True)
    ratings_distribution = marshmallow.fields.Dict(
        allow_none=True, data_key="ratingsDistribution"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ReviewRatingStatistics(**data)


class ScopedPriceSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ScopedPrice`."
    id = marshmallow.fields.String(allow_none=True)
    value = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    current_value = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="currentValue",
    )
    country = marshmallow.fields.String(missing=None)
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="customerGroup",
    )
    channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )
    discounted = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountedPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ScopedPrice(**data)


class SearchKeywordSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.SearchKeyword`."
    text = marshmallow.fields.String(allow_none=True)
    suggest_tokenizer = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "custom": "commercetools.schemas.CustomTokenizerSchema",
            "whitespace": "commercetools.schemas.WhitespaceTokenizerSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="suggestTokenizer",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.SearchKeyword(**data)


class SearchKeywordsSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.SearchKeywords`."
    _regex = helpers.RegexField(
        unknown=marshmallow.EXCLUDE,
        pattern=re.compile("^[a-z]{2}(-[A-Z]{2})?$"),
        type=marshmallow.fields.Nested(
            nested="commercetools.schemas.SearchKeywordSchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
            many=True,
        ),
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        data = self.fields["_regex"].postprocess(data)
        return types.SearchKeywords(**data)

    @marshmallow.pre_load
    def pre_load(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.pre_dump
    def pre_dump(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.post_dump
    def post_dump(self, data):
        data = self.fields["_regex"].postprocess(data)
        return data


class ShippingInfoDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ShippingInfoDraft`."
    shipping_method_name = marshmallow.fields.String(
        allow_none=True, data_key="shippingMethodName"
    )
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    shipping_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="shippingRate",
    )
    taxed_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxedItemPriceDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxedPrice",
    )
    tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxRateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxRate",
    )
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    shipping_method = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingMethodReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingMethod",
    )
    deliveries = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliverySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    discounted_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountedLineItemPriceDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="discountedPrice",
    )
    shipping_method_state = marshmallow_enum.EnumField(
        types.ShippingMethodState,
        by_value=True,
        missing=None,
        data_key="shippingMethodState",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ShippingInfoDraft(**data)


class ShippingInfoSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ShippingInfo`."
    shipping_method_name = marshmallow.fields.String(
        allow_none=True, data_key="shippingMethodName"
    )
    price = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    shipping_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingRateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="shippingRate",
    )
    taxed_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxedItemPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxedPrice",
    )
    tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxRateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxRate",
    )
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    shipping_method = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingMethodReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingMethod",
    )
    deliveries = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliverySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    discounted_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountedLineItemPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="discountedPrice",
    )
    shipping_method_state = marshmallow_enum.EnumField(
        types.ShippingMethodState, by_value=True, data_key="shippingMethodState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ShippingInfo(**data)


class ShippingMethodDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodDraft`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    name = marshmallow.fields.String(allow_none=True)
    description = marshmallow.fields.String(allow_none=True, missing=None)
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="taxCategory",
    )
    zone_rates = marshmallow.fields.Nested(
        nested="commercetools.schemas.ZoneRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="zoneRates",
    )
    is_default = marshmallow.fields.Bool(allow_none=True, data_key="isDefault")
    predicate = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ShippingMethodDraft(**data)


class ShippingRateDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ShippingRateDraft`."
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    free_above = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="freeAbove",
    )
    tiers = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("type", "type"),
            discriminator_schemas={
                "CartClassification": "commercetools.schemas.CartClassificationTierSchema",
                "CartScore": "commercetools.schemas.CartScoreTierSchema",
                "CartValue": "commercetools.schemas.CartValueTierSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ShippingRateDraft(**data)


class ShippingRateInputDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ShippingRateInputDraft`."
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ShippingRateInputDraft(**data)


class ShippingRateInputSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ShippingRateInput`."
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ShippingRateInput(**data)


class ShippingRateInputTypeSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ShippingRateInputType`."
    type = marshmallow_enum.EnumField(types.ShippingRateTierType, by_value=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ShippingRateInputType(**data)


class ShippingRatePriceTierSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ShippingRatePriceTier`."
    type = marshmallow_enum.EnumField(types.ShippingRateTierType, by_value=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ShippingRatePriceTier(**data)


class ShippingRateSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ShippingRate`."
    price = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    free_above = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="freeAbove",
    )
    is_matching = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isMatching"
    )
    tiers = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("type", "type"),
            discriminator_schemas={
                "CartClassification": "commercetools.schemas.CartClassificationTierSchema",
                "CartScore": "commercetools.schemas.CartScoreTierSchema",
                "CartValue": "commercetools.schemas.CartValueTierSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        )
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ShippingRate(**data)


class ShoppingListDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListDraft`."
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    delete_days_after_last_modification = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="deleteDaysAfterLastModification"
    )
    description = LocalizedStringField(allow_none=True, missing=None)
    key = marshmallow.fields.String(allow_none=True, missing=None)
    line_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShoppingListLineItemDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="lineItems",
    )
    name = LocalizedStringField(allow_none=True)
    slug = LocalizedStringField(allow_none=True, missing=None)
    text_line_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.TextLineItemDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="textLineItems",
    )
    anonymous_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="anonymousId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ShoppingListDraft(**data)


class ShoppingListLineItemDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListLineItemDraft`."
    added_at = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="addedAt"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    product_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="productId"
    )
    quantity = marshmallow.fields.Integer(allow_none=True, missing=None)
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ShoppingListLineItemDraft(**data)


class ShoppingListLineItemSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListLineItem`."
    added_at = marshmallow.fields.DateTime(allow_none=True, data_key="addedAt")
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    deactivated_at = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="deactivatedAt"
    )
    id = marshmallow.fields.String(allow_none=True)
    name = LocalizedStringField(allow_none=True)
    product_id = marshmallow.fields.String(allow_none=True, data_key="productId")
    product_slug = LocalizedStringField(
        allow_none=True, missing=None, data_key="productSlug"
    )
    product_type = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductTypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="productType",
    )
    quantity = marshmallow.fields.Integer(allow_none=True)
    variant = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductVariantSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ShoppingListLineItem(**data)


class StagedOrderUpdateActionSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderUpdateAction`."
    action = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderUpdateAction(**data)


class StateDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.StateDraft`."
    key = marshmallow.fields.String(allow_none=True)
    type = marshmallow_enum.EnumField(types.StateTypeEnum, by_value=True)
    name = LocalizedStringField(allow_none=True, missing=None)
    description = LocalizedStringField(allow_none=True, missing=None)
    initial = marshmallow.fields.Bool(allow_none=True, missing=None)
    roles = marshmallow.fields.List(
        marshmallow_enum.EnumField(types.StateRoleEnum, by_value=True), missing=None
    )
    transitions = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.StateDraft(**data)


class SubRateSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.SubRate`."
    name = marshmallow.fields.String(allow_none=True)
    amount = marshmallow.fields.Float(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.SubRate(**data)


class SubscriptionDeliverySchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.SubscriptionDelivery`."
    project_key = marshmallow.fields.String(allow_none=True, data_key="projectKey")
    notification_type = marshmallow.fields.String(
        allow_none=True, data_key="notificationType"
    )
    resource = helpers.Discriminator(
        discriminator_field=("typeId", "type_id"),
        discriminator_schemas={
            "cart-discount": "commercetools.schemas.CartDiscountReferenceSchema",
            "cart": "commercetools.schemas.CartReferenceSchema",
            "category": "commercetools.schemas.CategoryReferenceSchema",
            "channel": "commercetools.schemas.ChannelReferenceSchema",
            "key-value-document": "commercetools.schemas.CustomObjectReferenceSchema",
            "customer-group": "commercetools.schemas.CustomerGroupReferenceSchema",
            "customer": "commercetools.schemas.CustomerReferenceSchema",
            "discount-code": "commercetools.schemas.DiscountCodeReferenceSchema",
            "inventory-entry": "commercetools.schemas.InventoryEntryReferenceSchema",
            "order-edit": "commercetools.schemas.OrderEditReferenceSchema",
            "order": "commercetools.schemas.OrderReferenceSchema",
            "payment": "commercetools.schemas.PaymentReferenceSchema",
            "product-discount": "commercetools.schemas.ProductDiscountReferenceSchema",
            "product-type": "commercetools.schemas.ProductTypeReferenceSchema",
            "product": "commercetools.schemas.ProductReferenceSchema",
            "review": "commercetools.schemas.ReviewReferenceSchema",
            "shipping-method": "commercetools.schemas.ShippingMethodReferenceSchema",
            "shopping-list": "commercetools.schemas.ShoppingListReferenceSchema",
            "state": "commercetools.schemas.StateReferenceSchema",
            "tax-category": "commercetools.schemas.TaxCategoryReferenceSchema",
            "type": "commercetools.schemas.TypeReferenceSchema",
            "zone": "commercetools.schemas.ZoneReferenceSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["notification_type"]
        return types.SubscriptionDelivery(**data)


class SubscriptionDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.SubscriptionDraft`."
    changes = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChangeSubscriptionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    destination = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "EventGrid": "commercetools.schemas.AzureEventGridDestinationSchema",
            "AzureServiceBus": "commercetools.schemas.AzureServiceBusDestinationSchema",
            "GoogleCloudPubSub": "commercetools.schemas.GoogleCloudPubSubDestinationSchema",
            "IronMQ": "commercetools.schemas.IronMqDestinationSchema",
            "SNS": "commercetools.schemas.SnsDestinationSchema",
            "SQS": "commercetools.schemas.SqsDestinationSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    key = marshmallow.fields.String(allow_none=True, missing=None)
    messages = marshmallow.fields.Nested(
        nested="commercetools.schemas.MessageSubscriptionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    format = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "CloudEvents": "commercetools.schemas.DeliveryCloudEventsFormatSchema",
            "Platform": "commercetools.schemas.DeliveryPlatformFormatSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.SubscriptionDraft(**data)


class SuggestTokenizerSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.SuggestTokenizer`."
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.SuggestTokenizer(**data)


class SuggestionResultSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.SuggestionResult`."
    _regex = helpers.RegexField(
        unknown=marshmallow.EXCLUDE,
        pattern=re.compile("searchKeywords.[a-z]{2}(-[A-Z]{2})?"),
        type=marshmallow.fields.List(
            marshmallow.fields.Nested(
                nested="commercetools.schemas.SuggestionSchema",
                unknown=marshmallow.EXCLUDE,
                allow_none=True,
            ),
            allow_none=True,
        ),
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        data = self.fields["_regex"].postprocess(data)
        return types.SuggestionResult(**data)

    @marshmallow.pre_load
    def pre_load(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.pre_dump
    def pre_dump(self, data):
        data = self.fields["_regex"].preprocess(data)
        return data

    @marshmallow.post_dump
    def post_dump(self, data):
        data = self.fields["_regex"].postprocess(data)
        return data


class SuggestionSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Suggestion`."
    text = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Suggestion(**data)


class SyncInfoSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.SyncInfo`."
    channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    external_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="externalId"
    )
    synced_at = marshmallow.fields.DateTime(allow_none=True, data_key="syncedAt")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.SyncInfo(**data)


class TaxCategoryDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.TaxCategoryDraft`."
    name = marshmallow.fields.String(allow_none=True)
    description = marshmallow.fields.String(allow_none=True, missing=None)
    rates = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TaxCategoryDraft(**data)


class TaxPortionSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.TaxPortion`."
    name = marshmallow.fields.String(allow_none=True, missing=None)
    rate = marshmallow.fields.Float(allow_none=True)
    amount = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TaxPortion(**data)


class TaxRateDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.TaxRateDraft`."
    name = marshmallow.fields.String(allow_none=True)
    amount = marshmallow.fields.Float(allow_none=True, missing=None)
    included_in_price = marshmallow.fields.Bool(
        allow_none=True, data_key="includedInPrice"
    )
    country = marshmallow.fields.String()
    state = marshmallow.fields.String(allow_none=True, missing=None)
    sub_rates = marshmallow.fields.Nested(
        nested="commercetools.schemas.SubRateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="subRates",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TaxRateDraft(**data)


class TaxRateSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.TaxRate`."
    id = marshmallow.fields.String(allow_none=True, missing=None)
    name = marshmallow.fields.String(allow_none=True)
    amount = marshmallow.fields.Float(allow_none=True)
    included_in_price = marshmallow.fields.Bool(
        allow_none=True, data_key="includedInPrice"
    )
    country = marshmallow.fields.String()
    state = marshmallow.fields.String(allow_none=True, missing=None)
    sub_rates = marshmallow.fields.Nested(
        nested="commercetools.schemas.SubRateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="subRates",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TaxRate(**data)


class TaxedItemPriceDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.TaxedItemPriceDraft`."
    total_net = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalNet",
    )
    total_gross = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalGross",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TaxedItemPriceDraft(**data)


class TaxedItemPriceSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.TaxedItemPrice`."
    total_net = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalNet",
    )
    total_gross = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalGross",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TaxedItemPrice(**data)


class TaxedPriceSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.TaxedPrice`."
    total_net = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalNet",
    )
    total_gross = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalGross",
    )
    tax_portions = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxPortionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="taxPortions",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TaxedPrice(**data)


class TextLineItemDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.TextLineItemDraft`."
    added_at = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="addedAt"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    description = LocalizedStringField(allow_none=True, missing=None)
    name = LocalizedStringField(allow_none=True)
    quantity = marshmallow.fields.Integer(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TextLineItemDraft(**data)


class TextLineItemSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.TextLineItem`."
    added_at = marshmallow.fields.DateTime(allow_none=True, data_key="addedAt")
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    description = LocalizedStringField(allow_none=True, missing=None)
    id = marshmallow.fields.String(allow_none=True)
    name = LocalizedStringField(allow_none=True)
    quantity = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TextLineItem(**data)


class TrackingDataSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.TrackingData`."
    tracking_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="trackingId"
    )
    carrier = marshmallow.fields.String(allow_none=True, missing=None)
    provider = marshmallow.fields.String(allow_none=True, missing=None)
    provider_transaction = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="providerTransaction"
    )
    is_return = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isReturn"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TrackingData(**data)


class TransactionDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.TransactionDraft`."
    timestamp = marshmallow.fields.DateTime(allow_none=True, missing=None)
    type = marshmallow_enum.EnumField(types.TransactionType, by_value=True)
    amount = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    interaction_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="interactionId"
    )
    state = marshmallow_enum.EnumField(
        types.TransactionState, by_value=True, missing=None
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TransactionDraft(**data)


class TransactionSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Transaction`."
    id = marshmallow.fields.String(allow_none=True)
    timestamp = marshmallow.fields.DateTime(allow_none=True, missing=None)
    type = marshmallow_enum.EnumField(types.TransactionType, by_value=True)
    amount = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    interaction_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="interactionId"
    )
    state = marshmallow_enum.EnumField(
        types.TransactionState, by_value=True, missing=None
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Transaction(**data)


class TypeDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.TypeDraft`."
    key = marshmallow.fields.String(allow_none=True)
    name = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    resource_type_ids = marshmallow.fields.List(
        marshmallow_enum.EnumField(types.ResourceTypeId, by_value=True),
        data_key="resourceTypeIds",
    )
    field_definitions = marshmallow.fields.Nested(
        nested="commercetools.schemas.FieldDefinitionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="fieldDefinitions",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TypeDraft(**data)


class UpdateActionSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.UpdateAction`."
    action = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.UpdateAction(**data)


class UpdateSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Update`."
    version = marshmallow.fields.Integer(allow_none=True)
    actions = marshmallow.fields.List(
        marshmallow.fields.Nested(
            nested="commercetools.schemas.UpdateActionSchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Update(**data)


class VariantValuesSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.VariantValues`."
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    prices = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    attributes = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.VariantValues(**data)


class ZoneDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ZoneDraft`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    name = marshmallow.fields.String(allow_none=True)
    description = marshmallow.fields.String(allow_none=True, missing=None)
    locations = marshmallow.fields.Nested(
        nested="commercetools.schemas.LocationSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ZoneDraft(**data)


class ZoneRateDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ZoneRateDraft`."
    zone = marshmallow.fields.Nested(
        nested="commercetools.schemas.ZoneReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    shipping_rates = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="shippingRates",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ZoneRateDraft(**data)


class ZoneRateSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ZoneRate`."
    zone = marshmallow.fields.Nested(
        nested="commercetools.schemas.ZoneReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    shipping_rates = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingRateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="shippingRates",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ZoneRate(**data)


class AccessDeniedErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.AccessDeniedError`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.AccessDeniedError(**data)


class AttributeBooleanTypeSchema(AttributeTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.AttributeBooleanType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.AttributeBooleanType(**data)


class AttributeDateTimeTypeSchema(AttributeTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.AttributeDateTimeType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.AttributeDateTimeType(**data)


class AttributeDateTypeSchema(AttributeTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.AttributeDateType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.AttributeDateType(**data)


class AttributeEnumTypeSchema(AttributeTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.AttributeEnumType`."
    values = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributePlainEnumValueSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.AttributeEnumType(**data)


class AttributeLocalizableTextTypeSchema(AttributeTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.AttributeLocalizableTextType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.AttributeLocalizableTextType(**data)


class AttributeLocalizedEnumTypeSchema(AttributeTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.AttributeLocalizedEnumType`."
    values = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeLocalizedEnumValueSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.AttributeLocalizedEnumType(**data)


class AttributeMoneyTypeSchema(AttributeTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.AttributeMoneyType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.AttributeMoneyType(**data)


class AttributeNestedTypeSchema(AttributeTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.AttributeNestedType`."
    type_reference = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductTypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="typeReference",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.AttributeNestedType(**data)


class AttributeNumberTypeSchema(AttributeTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.AttributeNumberType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.AttributeNumberType(**data)


class AttributeReferenceTypeSchema(AttributeTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.AttributeReferenceType`."
    reference_type_id = marshmallow_enum.EnumField(
        types.ReferenceTypeId, by_value=True, data_key="referenceTypeId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.AttributeReferenceType(**data)


class AttributeSetTypeSchema(AttributeTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.AttributeSetType`."
    element_type = helpers.Discriminator(
        discriminator_field=("name", "name"),
        discriminator_schemas={
            "boolean": "commercetools.schemas.AttributeBooleanTypeSchema",
            "datetime": "commercetools.schemas.AttributeDateTimeTypeSchema",
            "date": "commercetools.schemas.AttributeDateTypeSchema",
            "enum": "commercetools.schemas.AttributeEnumTypeSchema",
            "ltext": "commercetools.schemas.AttributeLocalizableTextTypeSchema",
            "lenum": "commercetools.schemas.AttributeLocalizedEnumTypeSchema",
            "money": "commercetools.schemas.AttributeMoneyTypeSchema",
            "nested": "commercetools.schemas.AttributeNestedTypeSchema",
            "number": "commercetools.schemas.AttributeNumberTypeSchema",
            "reference": "commercetools.schemas.AttributeReferenceTypeSchema",
            "set": "commercetools.schemas.AttributeSetTypeSchema",
            "text": "commercetools.schemas.AttributeTextTypeSchema",
            "time": "commercetools.schemas.AttributeTimeTypeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="elementType",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.AttributeSetType(**data)


class AttributeTextTypeSchema(AttributeTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.AttributeTextType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.AttributeTextType(**data)


class AttributeTimeTypeSchema(AttributeTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.AttributeTimeType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.AttributeTimeType(**data)


class AzureEventGridDestinationSchema(DestinationSchema):
    "Marshmallow schema for :class:`commercetools.types.AzureEventGridDestination`."
    uri = marshmallow.fields.String(allow_none=True)
    access_key = marshmallow.fields.String(allow_none=True, data_key="accessKey")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.AzureEventGridDestination(**data)


class AzureServiceBusDestinationSchema(DestinationSchema):
    "Marshmallow schema for :class:`commercetools.types.AzureServiceBusDestination`."
    connection_string = marshmallow.fields.String(
        allow_none=True, data_key="connectionString"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.AzureServiceBusDestination(**data)


class CartClassificationTierSchema(ShippingRatePriceTierSchema):
    "Marshmallow schema for :class:`commercetools.types.CartClassificationTier`."
    value = marshmallow.fields.String(allow_none=True)
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    is_matching = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isMatching"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CartClassificationTier(**data)


class CartClassificationTypeSchema(ShippingRateInputTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CartClassificationType`."
    values = marshmallow.fields.List(
        marshmallow.fields.Nested(
            nested="commercetools.schemas.CustomFieldLocalizedEnumValueSchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CartClassificationType(**data)


class CartDiscountCustomLineItemsTargetSchema(CartDiscountTargetSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountCustomLineItemsTarget`."
    predicate = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CartDiscountCustomLineItemsTarget(**data)


class CartDiscountLineItemsTargetSchema(CartDiscountTargetSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountLineItemsTarget`."
    predicate = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CartDiscountLineItemsTarget(**data)


class CartDiscountPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.CartDiscountSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CartDiscountPagedQueryResponse(**data)


class CartDiscountSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscount`."
    name = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    value = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "absolute": "commercetools.schemas.CartDiscountValueAbsoluteSchema",
            "giftLineItem": "commercetools.schemas.CartDiscountValueGiftLineItemSchema",
            "relative": "commercetools.schemas.CartDiscountValueRelativeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    cart_predicate = marshmallow.fields.String(
        allow_none=True, data_key="cartPredicate"
    )
    target = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "customLineItems": "commercetools.schemas.CartDiscountCustomLineItemsTargetSchema",
            "lineItems": "commercetools.schemas.CartDiscountLineItemsTargetSchema",
            "shipping": "commercetools.schemas.CartDiscountShippingCostTargetSchema",
            "multiBuyCustomLineItems": "commercetools.schemas.MultiBuyCustomLineItemsTargetSchema",
            "multiBuyLineItems": "commercetools.schemas.MultiBuyLineItemsTargetSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    sort_order = marshmallow.fields.String(allow_none=True, data_key="sortOrder")
    is_active = marshmallow.fields.Bool(allow_none=True, data_key="isActive")
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )
    requires_discount_code = marshmallow.fields.Bool(
        allow_none=True, data_key="requiresDiscountCode"
    )
    references = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("typeId", "type_id"),
            discriminator_schemas={
                "cart-discount": "commercetools.schemas.CartDiscountReferenceSchema",
                "cart": "commercetools.schemas.CartReferenceSchema",
                "category": "commercetools.schemas.CategoryReferenceSchema",
                "channel": "commercetools.schemas.ChannelReferenceSchema",
                "key-value-document": "commercetools.schemas.CustomObjectReferenceSchema",
                "customer-group": "commercetools.schemas.CustomerGroupReferenceSchema",
                "customer": "commercetools.schemas.CustomerReferenceSchema",
                "discount-code": "commercetools.schemas.DiscountCodeReferenceSchema",
                "inventory-entry": "commercetools.schemas.InventoryEntryReferenceSchema",
                "order-edit": "commercetools.schemas.OrderEditReferenceSchema",
                "order": "commercetools.schemas.OrderReferenceSchema",
                "payment": "commercetools.schemas.PaymentReferenceSchema",
                "product-discount": "commercetools.schemas.ProductDiscountReferenceSchema",
                "product-type": "commercetools.schemas.ProductTypeReferenceSchema",
                "product": "commercetools.schemas.ProductReferenceSchema",
                "review": "commercetools.schemas.ReviewReferenceSchema",
                "shipping-method": "commercetools.schemas.ShippingMethodReferenceSchema",
                "shopping-list": "commercetools.schemas.ShoppingListReferenceSchema",
                "state": "commercetools.schemas.StateReferenceSchema",
                "tax-category": "commercetools.schemas.TaxCategoryReferenceSchema",
                "type": "commercetools.schemas.TypeReferenceSchema",
                "zone": "commercetools.schemas.ZoneReferenceSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        )
    )
    stacking_mode = marshmallow_enum.EnumField(
        types.StackingMode, by_value=True, data_key="stackingMode"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CartDiscount(**data)


class CartDiscountShippingCostTargetSchema(CartDiscountTargetSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountShippingCostTarget`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CartDiscountShippingCostTarget(**data)


class CartDiscountUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountUpdateAction(**data)


class CartDiscountUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "changeCartPredicate": "commercetools.schemas.CartDiscountChangeCartPredicateActionSchema",
                "changeIsActive": "commercetools.schemas.CartDiscountChangeIsActiveActionSchema",
                "changeName": "commercetools.schemas.CartDiscountChangeNameActionSchema",
                "changeRequiresDiscountCode": "commercetools.schemas.CartDiscountChangeRequiresDiscountCodeActionSchema",
                "changeSortOrder": "commercetools.schemas.CartDiscountChangeSortOrderActionSchema",
                "changeStackingMode": "commercetools.schemas.CartDiscountChangeStackingModeActionSchema",
                "changeTarget": "commercetools.schemas.CartDiscountChangeTargetActionSchema",
                "changeValue": "commercetools.schemas.CartDiscountChangeValueActionSchema",
                "setCustomField": "commercetools.schemas.CartDiscountSetCustomFieldActionSchema",
                "setCustomType": "commercetools.schemas.CartDiscountSetCustomTypeActionSchema",
                "setDescription": "commercetools.schemas.CartDiscountSetDescriptionActionSchema",
                "setValidFrom": "commercetools.schemas.CartDiscountSetValidFromActionSchema",
                "setValidFromAndUntil": "commercetools.schemas.CartDiscountSetValidFromAndUntilActionSchema",
                "setValidUntil": "commercetools.schemas.CartDiscountSetValidUntilActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CartDiscountUpdate(**data)


class CartDiscountValueAbsoluteSchema(CartDiscountValueSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountValueAbsolute`."
    money = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CartDiscountValueAbsolute(**data)


class CartDiscountValueGiftLineItemSchema(CartDiscountValueSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountValueGiftLineItem`."
    product = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    variant_id = marshmallow.fields.Integer(allow_none=True, data_key="variantId")
    supply_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="supplyChannel",
    )
    distribution_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="distributionChannel",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CartDiscountValueGiftLineItem(**data)


class CartDiscountValueRelativeSchema(CartDiscountValueSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountValueRelative`."
    permyriad = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CartDiscountValueRelative(**data)


class CartPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.CartPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.CartSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CartPagedQueryResponse(**data)


class CartSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Cart`."
    customer_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerId"
    )
    customer_email = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerEmail"
    )
    anonymous_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="anonymousId"
    )
    line_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.LineItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="lineItems",
    )
    custom_line_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomLineItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="customLineItems",
    )
    total_price = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalPrice",
    )
    taxed_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxedPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxedPrice",
    )
    cart_state = marshmallow_enum.EnumField(
        types.CartState, by_value=True, data_key="cartState"
    )
    shipping_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingAddress",
    )
    billing_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="billingAddress",
    )
    inventory_mode = marshmallow_enum.EnumField(
        types.InventoryMode, by_value=True, missing=None, data_key="inventoryMode"
    )
    tax_mode = marshmallow_enum.EnumField(
        types.TaxMode, by_value=True, data_key="taxMode"
    )
    tax_rounding_mode = marshmallow_enum.EnumField(
        types.RoundingMode, by_value=True, data_key="taxRoundingMode"
    )
    tax_calculation_mode = marshmallow_enum.EnumField(
        types.TaxCalculationMode, by_value=True, data_key="taxCalculationMode"
    )
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="customerGroup",
    )
    country = marshmallow.fields.String(missing=None)
    shipping_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingInfo",
    )
    discount_codes = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountCodeInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="discountCodes",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    payment_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="paymentInfo",
    )
    locale = marshmallow.fields.String(allow_none=True, missing=None)
    delete_days_after_last_modification = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="deleteDaysAfterLastModification"
    )
    refused_gifts = marshmallow.fields.Nested(
        nested="commercetools.schemas.CartDiscountReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="refusedGifts",
    )
    origin = marshmallow_enum.EnumField(types.CartOrigin, by_value=True)
    shipping_rate_input = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "Classification": "commercetools.schemas.ClassificationShippingRateInputSchema",
            "Score": "commercetools.schemas.ScoreShippingRateInputSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingRateInput",
    )
    item_shipping_addresses = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="itemShippingAddresses",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Cart(**data)


class CartScoreTierSchema(ShippingRatePriceTierSchema):
    "Marshmallow schema for :class:`commercetools.types.CartScoreTier`."
    score = marshmallow.fields.Integer(allow_none=True)
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    price_function = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceFunctionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="priceFunction",
    )
    is_matching = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isMatching"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CartScoreTier(**data)


class CartScoreTypeSchema(ShippingRateInputTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CartScoreType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CartScoreType(**data)


class CartUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartUpdateAction(**data)


class CartUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.CartUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addCustomLineItem": "commercetools.schemas.CartAddCustomLineItemActionSchema",
                "addDiscountCode": "commercetools.schemas.CartAddDiscountCodeActionSchema",
                "addItemShippingAddress": "commercetools.schemas.CartAddItemShippingAddressActionSchema",
                "addLineItem": "commercetools.schemas.CartAddLineItemActionSchema",
                "addPayment": "commercetools.schemas.CartAddPaymentActionSchema",
                "addShoppingList": "commercetools.schemas.CartAddShoppingListActionSchema",
                "applyDeltaToCustomLineItemShippingDetailsTargets": "commercetools.schemas.CartApplyDeltaToCustomLineItemShippingDetailsTargetsActionSchema",
                "applyDeltaToLineItemShippingDetailsTargets": "commercetools.schemas.CartApplyDeltaToLineItemShippingDetailsTargetsActionSchema",
                "changeCustomLineItemMoney": "commercetools.schemas.CartChangeCustomLineItemMoneyActionSchema",
                "changeCustomLineItemQuantity": "commercetools.schemas.CartChangeCustomLineItemQuantityActionSchema",
                "changeLineItemQuantity": "commercetools.schemas.CartChangeLineItemQuantityActionSchema",
                "changeTaxCalculationMode": "commercetools.schemas.CartChangeTaxCalculationModeActionSchema",
                "changeTaxMode": "commercetools.schemas.CartChangeTaxModeActionSchema",
                "changeTaxRoundingMode": "commercetools.schemas.CartChangeTaxRoundingModeActionSchema",
                "recalculate": "commercetools.schemas.CartRecalculateActionSchema",
                "removeCustomLineItem": "commercetools.schemas.CartRemoveCustomLineItemActionSchema",
                "removeDiscountCode": "commercetools.schemas.CartRemoveDiscountCodeActionSchema",
                "removeItemShippingAddress": "commercetools.schemas.CartRemoveItemShippingAddressActionSchema",
                "removeLineItem": "commercetools.schemas.CartRemoveLineItemActionSchema",
                "removePayment": "commercetools.schemas.CartRemovePaymentActionSchema",
                "setAnonymousId": "commercetools.schemas.CartSetAnonymousIdActionSchema",
                "setBillingAddress": "commercetools.schemas.CartSetBillingAddressActionSchema",
                "setCartTotalTax": "commercetools.schemas.CartSetCartTotalTaxActionSchema",
                "setCountry": "commercetools.schemas.CartSetCountryActionSchema",
                "setCustomField": "commercetools.schemas.CartSetCustomFieldActionSchema",
                "setCustomLineItemCustomField": "commercetools.schemas.CartSetCustomLineItemCustomFieldActionSchema",
                "setCustomLineItemCustomType": "commercetools.schemas.CartSetCustomLineItemCustomTypeActionSchema",
                "setCustomLineItemShippingDetails": "commercetools.schemas.CartSetCustomLineItemShippingDetailsActionSchema",
                "setCustomLineItemTaxAmount": "commercetools.schemas.CartSetCustomLineItemTaxAmountActionSchema",
                "setCustomLineItemTaxRate": "commercetools.schemas.CartSetCustomLineItemTaxRateActionSchema",
                "setCustomShippingMethod": "commercetools.schemas.CartSetCustomShippingMethodActionSchema",
                "setCustomType": "commercetools.schemas.CartSetCustomTypeActionSchema",
                "setCustomerEmail": "commercetools.schemas.CartSetCustomerEmailActionSchema",
                "setCustomerGroup": "commercetools.schemas.CartSetCustomerGroupActionSchema",
                "setCustomerId": "commercetools.schemas.CartSetCustomerIdActionSchema",
                "setDeleteDaysAfterLastModification": "commercetools.schemas.CartSetDeleteDaysAfterLastModificationActionSchema",
                "setLineItemCustomField": "commercetools.schemas.CartSetLineItemCustomFieldActionSchema",
                "setLineItemCustomType": "commercetools.schemas.CartSetLineItemCustomTypeActionSchema",
                "setLineItemPrice": "commercetools.schemas.CartSetLineItemPriceActionSchema",
                "setLineItemShippingDetails": "commercetools.schemas.CartSetLineItemShippingDetailsActionSchema",
                "setLineItemTaxAmount": "commercetools.schemas.CartSetLineItemTaxAmountActionSchema",
                "setLineItemTaxRate": "commercetools.schemas.CartSetLineItemTaxRateActionSchema",
                "setLineItemTotalPrice": "commercetools.schemas.CartSetLineItemTotalPriceActionSchema",
                "setLocale": "commercetools.schemas.CartSetLocaleActionSchema",
                "setShippingAddress": "commercetools.schemas.CartSetShippingAddressActionSchema",
                "setShippingMethod": "commercetools.schemas.CartSetShippingMethodActionSchema",
                "setShippingMethodTaxAmount": "commercetools.schemas.CartSetShippingMethodTaxAmountActionSchema",
                "setShippingMethodTaxRate": "commercetools.schemas.CartSetShippingMethodTaxRateActionSchema",
                "setShippingRateInput": "commercetools.schemas.CartSetShippingRateInputActionSchema",
                "updateItemShippingAddress": "commercetools.schemas.CartUpdateItemShippingAddressActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CartUpdate(**data)


class CartValueTierSchema(ShippingRatePriceTierSchema):
    "Marshmallow schema for :class:`commercetools.types.CartValueTier`."
    minimum_cent_amount = marshmallow.fields.Integer(
        allow_none=True, data_key="minimumCentAmount"
    )
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    is_matching = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="isMatching"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CartValueTier(**data)


class CartValueTypeSchema(ShippingRateInputTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CartValueType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CartValueType(**data)


class CategoryCreatedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.CategoryCreatedMessagePayload`."
    category = marshmallow.fields.Nested(
        nested="commercetools.schemas.CategorySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CategoryCreatedMessagePayload(**data)


class CategoryPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.CategoryPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.CategorySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CategoryPagedQueryResponse(**data)


class CategorySchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Category`."
    name = LocalizedStringField(allow_none=True)
    slug = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    ancestors = marshmallow.fields.Nested(
        nested="commercetools.schemas.CategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    parent = marshmallow.fields.Nested(
        nested="commercetools.schemas.CategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    order_hint = marshmallow.fields.String(allow_none=True, data_key="orderHint")
    external_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="externalId"
    )
    meta_title = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaTitle"
    )
    meta_description = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaDescription"
    )
    meta_keywords = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaKeywords"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    assets = marshmallow.fields.Nested(
        nested="commercetools.schemas.AssetSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Category(**data)


class CategorySlugChangedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySlugChangedMessagePayload`."
    slug = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CategorySlugChangedMessagePayload(**data)


class CategoryUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategoryUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategoryUpdateAction(**data)


class CategoryUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.CategoryUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addAsset": "commercetools.schemas.CategoryAddAssetActionSchema",
                "changeAssetName": "commercetools.schemas.CategoryChangeAssetNameActionSchema",
                "changeAssetOrder": "commercetools.schemas.CategoryChangeAssetOrderActionSchema",
                "changeName": "commercetools.schemas.CategoryChangeNameActionSchema",
                "changeOrderHint": "commercetools.schemas.CategoryChangeOrderHintActionSchema",
                "changeParent": "commercetools.schemas.CategoryChangeParentActionSchema",
                "changeSlug": "commercetools.schemas.CategoryChangeSlugActionSchema",
                "removeAsset": "commercetools.schemas.CategoryRemoveAssetActionSchema",
                "setAssetCustomField": "commercetools.schemas.CategorySetAssetCustomFieldActionSchema",
                "setAssetCustomType": "commercetools.schemas.CategorySetAssetCustomTypeActionSchema",
                "setAssetDescription": "commercetools.schemas.CategorySetAssetDescriptionActionSchema",
                "setAssetKey": "commercetools.schemas.CategorySetAssetKeyActionSchema",
                "setAssetSources": "commercetools.schemas.CategorySetAssetSourcesActionSchema",
                "setAssetTags": "commercetools.schemas.CategorySetAssetTagsActionSchema",
                "setCustomField": "commercetools.schemas.CategorySetCustomFieldActionSchema",
                "setCustomType": "commercetools.schemas.CategorySetCustomTypeActionSchema",
                "setDescription": "commercetools.schemas.CategorySetDescriptionActionSchema",
                "setExternalId": "commercetools.schemas.CategorySetExternalIdActionSchema",
                "setKey": "commercetools.schemas.CategorySetKeyActionSchema",
                "setMetaDescription": "commercetools.schemas.CategorySetMetaDescriptionActionSchema",
                "setMetaKeywords": "commercetools.schemas.CategorySetMetaKeywordsActionSchema",
                "setMetaTitle": "commercetools.schemas.CategorySetMetaTitleActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CategoryUpdate(**data)


class ChannelPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ChannelPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ChannelPagedQueryResponse(**data)


class ChannelSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Channel`."
    key = marshmallow.fields.String(allow_none=True)
    roles = marshmallow.fields.List(
        marshmallow_enum.EnumField(types.ChannelRoleEnum, by_value=True)
    )
    name = LocalizedStringField(allow_none=True, missing=None)
    description = LocalizedStringField(allow_none=True, missing=None)
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    review_rating_statistics = marshmallow.fields.Nested(
        nested="commercetools.schemas.ReviewRatingStatisticsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="reviewRatingStatistics",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    geo_location = marshmallow.fields.Nested(
        nested="commercetools.schemas.GeoJsonPointSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="geoLocation",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Channel(**data)


class ChannelUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ChannelUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ChannelUpdateAction(**data)


class ChannelUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.ChannelUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addRoles": "commercetools.schemas.ChannelAddRolesActionSchema",
                "changeDescription": "commercetools.schemas.ChannelChangeDescriptionActionSchema",
                "changeKey": "commercetools.schemas.ChannelChangeKeyActionSchema",
                "changeName": "commercetools.schemas.ChannelChangeNameActionSchema",
                "removeRoles": "commercetools.schemas.ChannelRemoveRolesActionSchema",
                "setAddress": "commercetools.schemas.ChannelSetAddressActionSchema",
                "setCustomField": "commercetools.schemas.ChannelSetCustomFieldActionSchema",
                "setCustomType": "commercetools.schemas.ChannelSetCustomTypeActionSchema",
                "setGeoLocation": "commercetools.schemas.ChannelSetGeoLocationActionSchema",
                "setRoles": "commercetools.schemas.ChannelSetRolesActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ChannelUpdate(**data)


class ClassificationShippingRateInputDraftSchema(ShippingRateInputDraftSchema):
    "Marshmallow schema for :class:`commercetools.types.ClassificationShippingRateInputDraft`."
    key = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ClassificationShippingRateInputDraft(**data)


class ClassificationShippingRateInputSchema(ShippingRateInputSchema):
    "Marshmallow schema for :class:`commercetools.types.ClassificationShippingRateInput`."
    key = marshmallow.fields.String(allow_none=True)
    label = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ClassificationShippingRateInput(**data)


class ConcurrentModificationErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.ConcurrentModificationError`."
    current_version = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="currentVersion"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.ConcurrentModificationError(**data)


class CustomFieldBooleanTypeSchema(FieldTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldBooleanType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.CustomFieldBooleanType(**data)


class CustomFieldDateTimeTypeSchema(FieldTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldDateTimeType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.CustomFieldDateTimeType(**data)


class CustomFieldDateTypeSchema(FieldTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldDateType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.CustomFieldDateType(**data)


class CustomFieldEnumTypeSchema(FieldTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldEnumType`."
    values = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldEnumValueSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.CustomFieldEnumType(**data)


class CustomFieldLocalizedEnumTypeSchema(FieldTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldLocalizedEnumType`."
    values = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldLocalizedEnumValueSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.CustomFieldLocalizedEnumType(**data)


class CustomFieldLocalizedStringTypeSchema(FieldTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldLocalizedStringType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.CustomFieldLocalizedStringType(**data)


class CustomFieldMoneyTypeSchema(FieldTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldMoneyType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.CustomFieldMoneyType(**data)


class CustomFieldNumberTypeSchema(FieldTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldNumberType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.CustomFieldNumberType(**data)


class CustomFieldReferenceTypeSchema(FieldTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldReferenceType`."
    reference_type_id = marshmallow_enum.EnumField(
        types.ReferenceTypeId, by_value=True, data_key="referenceTypeId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.CustomFieldReferenceType(**data)


class CustomFieldSetTypeSchema(FieldTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldSetType`."
    element_type = helpers.Discriminator(
        discriminator_field=("name", "name"),
        discriminator_schemas={
            "Boolean": "commercetools.schemas.CustomFieldBooleanTypeSchema",
            "DateTime": "commercetools.schemas.CustomFieldDateTimeTypeSchema",
            "Date": "commercetools.schemas.CustomFieldDateTypeSchema",
            "Enum": "commercetools.schemas.CustomFieldEnumTypeSchema",
            "LocalizedEnum": "commercetools.schemas.CustomFieldLocalizedEnumTypeSchema",
            "LocalizedString": "commercetools.schemas.CustomFieldLocalizedStringTypeSchema",
            "Money": "commercetools.schemas.CustomFieldMoneyTypeSchema",
            "Number": "commercetools.schemas.CustomFieldNumberTypeSchema",
            "Reference": "commercetools.schemas.CustomFieldReferenceTypeSchema",
            "Set": "commercetools.schemas.CustomFieldSetTypeSchema",
            "String": "commercetools.schemas.CustomFieldStringTypeSchema",
            "Time": "commercetools.schemas.CustomFieldTimeTypeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="elementType",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.CustomFieldSetType(**data)


class CustomFieldStringTypeSchema(FieldTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldStringType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.CustomFieldStringType(**data)


class CustomFieldTimeTypeSchema(FieldTypeSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomFieldTimeType`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["name"]
        return types.CustomFieldTimeType(**data)


class CustomLineItemReturnItemSchema(ReturnItemSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomLineItemReturnItem`."
    customline_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customlineItemId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomLineItemReturnItem(**data)


class CustomLineItemStateTransitionMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomLineItemStateTransitionMessagePayload`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    transition_date = marshmallow.fields.DateTime(
        allow_none=True, data_key="transitionDate"
    )
    quantity = marshmallow.fields.Integer(allow_none=True)
    from_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="fromState",
    )
    to_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="toState",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CustomLineItemStateTransitionMessagePayload(**data)


class CustomObjectPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomObjectPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomObjectSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomObjectPagedQueryResponse(**data)


class CustomObjectSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomObject`."
    container = marshmallow.fields.String(allow_none=True)
    key = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomObject(**data)


class CustomTokenizerSchema(SuggestTokenizerSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomTokenizer`."
    inputs = marshmallow.fields.List(marshmallow.fields.String(allow_none=True))

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CustomTokenizer(**data)


class CustomerAddressAddedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerAddressAddedMessagePayload`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CustomerAddressAddedMessagePayload(**data)


class CustomerAddressChangedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerAddressChangedMessagePayload`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CustomerAddressChangedMessagePayload(**data)


class CustomerAddressRemovedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerAddressRemovedMessagePayload`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CustomerAddressRemovedMessagePayload(**data)


class CustomerCompanyNameSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerCompanyNameSetMessagePayload`."
    company_name = marshmallow.fields.String(allow_none=True, data_key="companyName")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CustomerCompanyNameSetMessagePayload(**data)


class CustomerCreatedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerCreatedMessagePayload`."
    customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CustomerCreatedMessagePayload(**data)


class CustomerDateOfBirthSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerDateOfBirthSetMessagePayload`."
    date_of_birth = marshmallow.fields.Date(allow_none=True, data_key="dateOfBirth")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CustomerDateOfBirthSetMessagePayload(**data)


class CustomerEmailChangedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerEmailChangedMessagePayload`."
    email = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CustomerEmailChangedMessagePayload(**data)


class CustomerEmailVerifiedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerEmailVerifiedMessagePayload`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CustomerEmailVerifiedMessagePayload(**data)


class CustomerGroupPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerGroupPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerGroupPagedQueryResponse(**data)


class CustomerGroupSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerGroup`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    name = marshmallow.fields.String(allow_none=True)
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerGroup(**data)


class CustomerGroupSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerGroupSetMessagePayload`."
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="customerGroup",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CustomerGroupSetMessagePayload(**data)


class CustomerGroupUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerGroupUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerGroupUpdateAction(**data)


class CustomerGroupUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerGroupUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "changeName": "commercetools.schemas.CustomerGroupChangeNameActionSchema",
                "setCustomField": "commercetools.schemas.CustomerGroupSetCustomFieldActionSchema",
                "setCustomType": "commercetools.schemas.CustomerGroupSetCustomTypeActionSchema",
                "setKey": "commercetools.schemas.CustomerGroupSetKeyActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerGroupUpdate(**data)


class CustomerPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerPagedQueryResponse(**data)


class CustomerSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Customer`."
    customer_number = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerNumber"
    )
    email = marshmallow.fields.String(allow_none=True)
    password = marshmallow.fields.String(allow_none=True)
    first_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="firstName"
    )
    last_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="lastName"
    )
    middle_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="middleName"
    )
    title = marshmallow.fields.String(allow_none=True, missing=None)
    date_of_birth = marshmallow.fields.Date(
        allow_none=True, missing=None, data_key="dateOfBirth"
    )
    company_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="companyName"
    )
    vat_id = marshmallow.fields.String(allow_none=True, missing=None, data_key="vatId")
    addresses = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    default_shipping_address_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="defaultShippingAddressId"
    )
    shipping_address_ids = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True),
        missing=None,
        data_key="shippingAddressIds",
    )
    default_billing_address_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="defaultBillingAddressId"
    )
    billing_address_ids = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True),
        missing=None,
        data_key="billingAddressIds",
    )
    is_email_verified = marshmallow.fields.Bool(
        allow_none=True, data_key="isEmailVerified"
    )
    external_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="externalId"
    )
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="customerGroup",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    locale = marshmallow.fields.String(allow_none=True, missing=None)
    salutation = marshmallow.fields.String(allow_none=True, missing=None)
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Customer(**data)


class CustomerUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerUpdateAction(**data)


class CustomerUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addAddress": "commercetools.schemas.CustomerAddAddressActionSchema",
                "addBillingAddressId": "commercetools.schemas.CustomerAddBillingAddressIdActionSchema",
                "addShippingAddressId": "commercetools.schemas.CustomerAddShippingAddressIdActionSchema",
                "changeAddress": "commercetools.schemas.CustomerChangeAddressActionSchema",
                "changeEmail": "commercetools.schemas.CustomerChangeEmailActionSchema",
                "removeAddress": "commercetools.schemas.CustomerRemoveAddressActionSchema",
                "removeBillingAddressId": "commercetools.schemas.CustomerRemoveBillingAddressIdActionSchema",
                "removeShippingAddressId": "commercetools.schemas.CustomerRemoveShippingAddressIdActionSchema",
                "setCompanyName": "commercetools.schemas.CustomerSetCompanyNameActionSchema",
                "setCustomField": "commercetools.schemas.CustomerSetCustomFieldActionSchema",
                "setCustomType": "commercetools.schemas.CustomerSetCustomTypeActionSchema",
                "setCustomerGroup": "commercetools.schemas.CustomerSetCustomerGroupActionSchema",
                "setCustomerNumber": "commercetools.schemas.CustomerSetCustomerNumberActionSchema",
                "setDateOfBirth": "commercetools.schemas.CustomerSetDateOfBirthActionSchema",
                "setDefaultBillingAddress": "commercetools.schemas.CustomerSetDefaultBillingAddressActionSchema",
                "setDefaultShippingAddress": "commercetools.schemas.CustomerSetDefaultShippingAddressActionSchema",
                "setExternalId": "commercetools.schemas.CustomerSetExternalIdActionSchema",
                "setFirstName": "commercetools.schemas.CustomerSetFirstNameActionSchema",
                "setKey": "commercetools.schemas.CustomerSetKeyActionSchema",
                "setLastName": "commercetools.schemas.CustomerSetLastNameActionSchema",
                "setLocale": "commercetools.schemas.CustomerSetLocaleActionSchema",
                "setMiddleName": "commercetools.schemas.CustomerSetMiddleNameActionSchema",
                "setSalutation": "commercetools.schemas.CustomerSetSalutationActionSchema",
                "setTitle": "commercetools.schemas.CustomerSetTitleActionSchema",
                "setVatId": "commercetools.schemas.CustomerSetVatIdActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerUpdate(**data)


class DeliveryAddedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.DeliveryAddedMessagePayload`."
    delivery = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliverySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.DeliveryAddedMessagePayload(**data)


class DeliveryAddressSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.DeliveryAddressSetMessagePayload`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    old_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="oldAddress",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.DeliveryAddressSetMessagePayload(**data)


class DeliveryCloudEventsFormatSchema(DeliveryFormatSchema):
    "Marshmallow schema for :class:`commercetools.types.DeliveryCloudEventsFormat`."
    cloud_events_version = marshmallow.fields.String(
        allow_none=True, data_key="cloudEventsVersion"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.DeliveryCloudEventsFormat(**data)


class DeliveryItemsUpdatedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.DeliveryItemsUpdatedMessagePayload`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    old_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="oldItems",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.DeliveryItemsUpdatedMessagePayload(**data)


class DeliveryPlatformFormatSchema(DeliveryFormatSchema):
    "Marshmallow schema for :class:`commercetools.types.DeliveryPlatformFormat`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.DeliveryPlatformFormat(**data)


class DeliveryRemovedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.DeliveryRemovedMessagePayload`."
    delivery = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliverySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.DeliveryRemovedMessagePayload(**data)


class DiscountCodeNonApplicableErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeNonApplicableError`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.DiscountCodeNonApplicableError(**data)


class DiscountCodePagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodePagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountCodeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DiscountCodePagedQueryResponse(**data)


class DiscountCodeSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCode`."
    name = LocalizedStringField(allow_none=True, missing=None)
    description = LocalizedStringField(allow_none=True, missing=None)
    code = marshmallow.fields.String(allow_none=True)
    cart_discounts = marshmallow.fields.Nested(
        nested="commercetools.schemas.CartDiscountReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="cartDiscounts",
    )
    cart_predicate = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="cartPredicate"
    )
    is_active = marshmallow.fields.Bool(allow_none=True, data_key="isActive")
    references = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("typeId", "type_id"),
            discriminator_schemas={
                "cart-discount": "commercetools.schemas.CartDiscountReferenceSchema",
                "cart": "commercetools.schemas.CartReferenceSchema",
                "category": "commercetools.schemas.CategoryReferenceSchema",
                "channel": "commercetools.schemas.ChannelReferenceSchema",
                "key-value-document": "commercetools.schemas.CustomObjectReferenceSchema",
                "customer-group": "commercetools.schemas.CustomerGroupReferenceSchema",
                "customer": "commercetools.schemas.CustomerReferenceSchema",
                "discount-code": "commercetools.schemas.DiscountCodeReferenceSchema",
                "inventory-entry": "commercetools.schemas.InventoryEntryReferenceSchema",
                "order-edit": "commercetools.schemas.OrderEditReferenceSchema",
                "order": "commercetools.schemas.OrderReferenceSchema",
                "payment": "commercetools.schemas.PaymentReferenceSchema",
                "product-discount": "commercetools.schemas.ProductDiscountReferenceSchema",
                "product-type": "commercetools.schemas.ProductTypeReferenceSchema",
                "product": "commercetools.schemas.ProductReferenceSchema",
                "review": "commercetools.schemas.ReviewReferenceSchema",
                "shipping-method": "commercetools.schemas.ShippingMethodReferenceSchema",
                "shopping-list": "commercetools.schemas.ShoppingListReferenceSchema",
                "state": "commercetools.schemas.StateReferenceSchema",
                "tax-category": "commercetools.schemas.TaxCategoryReferenceSchema",
                "type": "commercetools.schemas.TypeReferenceSchema",
                "zone": "commercetools.schemas.ZoneReferenceSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        )
    )
    max_applications = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="maxApplications"
    )
    max_applications_per_customer = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="maxApplicationsPerCustomer"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    groups = marshmallow.fields.List(marshmallow.fields.String(allow_none=True))
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DiscountCode(**data)


class DiscountCodeUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.DiscountCodeUpdateAction(**data)


class DiscountCodeUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "changeCartDiscounts": "commercetools.schemas.DiscountCodeChangeCartDiscountsActionSchema",
                "changeGroups": "commercetools.schemas.DiscountCodeChangeGroupsActionSchema",
                "changeIsActive": "commercetools.schemas.DiscountCodeChangeIsActiveActionSchema",
                "setCartPredicate": "commercetools.schemas.DiscountCodeSetCartPredicateActionSchema",
                "setCustomField": "commercetools.schemas.DiscountCodeSetCustomFieldActionSchema",
                "setCustomType": "commercetools.schemas.DiscountCodeSetCustomTypeActionSchema",
                "setDescription": "commercetools.schemas.DiscountCodeSetDescriptionActionSchema",
                "setMaxApplications": "commercetools.schemas.DiscountCodeSetMaxApplicationsActionSchema",
                "setMaxApplicationsPerCustomer": "commercetools.schemas.DiscountCodeSetMaxApplicationsPerCustomerActionSchema",
                "setName": "commercetools.schemas.DiscountCodeSetNameActionSchema",
                "setValidFrom": "commercetools.schemas.DiscountCodeSetValidFromActionSchema",
                "setValidFromAndUntil": "commercetools.schemas.DiscountCodeSetValidFromAndUntilActionSchema",
                "setValidUntil": "commercetools.schemas.DiscountCodeSetValidUntilActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DiscountCodeUpdate(**data)


class DuplicateAttributeValueErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.DuplicateAttributeValueError`."
    attribute = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.DuplicateAttributeValueError(**data)


class DuplicateAttributeValuesErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.DuplicateAttributeValuesError`."
    attributes = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.DuplicateAttributeValuesError(**data)


class DuplicateFieldErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.DuplicateFieldError`."
    field = marshmallow.fields.String(allow_none=True, missing=None)
    duplicate_value = marshmallow.fields.Raw(
        allow_none=True, missing=None, data_key="duplicateValue"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.DuplicateFieldError(**data)


class DuplicatePriceScopeErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.DuplicatePriceScopeError`."
    conflicting_prices = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="conflictingPrices",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.DuplicatePriceScopeError(**data)


class DuplicateVariantValuesErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.DuplicateVariantValuesError`."
    variant_values = marshmallow.fields.Nested(
        nested="commercetools.schemas.VariantValuesSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="variantValues",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.DuplicateVariantValuesError(**data)


class ExtensionAWSLambdaDestinationSchema(ExtensionDestinationSchema):
    "Marshmallow schema for :class:`commercetools.types.ExtensionAWSLambdaDestination`."
    arn = marshmallow.fields.String(allow_none=True)
    access_key = marshmallow.fields.String(allow_none=True, data_key="accessKey")
    access_secret = marshmallow.fields.String(allow_none=True, data_key="accessSecret")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ExtensionAWSLambdaDestination(**data)


class ExtensionAuthorizationHeaderAuthenticationSchema(
    ExtensionHttpDestinationAuthenticationSchema
):
    "Marshmallow schema for :class:`commercetools.types.ExtensionAuthorizationHeaderAuthentication`."
    header_value = marshmallow.fields.String(allow_none=True, data_key="headerValue")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ExtensionAuthorizationHeaderAuthentication(**data)


class ExtensionAzureFunctionsAuthenticationSchema(
    ExtensionHttpDestinationAuthenticationSchema
):
    "Marshmallow schema for :class:`commercetools.types.ExtensionAzureFunctionsAuthentication`."
    key = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ExtensionAzureFunctionsAuthentication(**data)


class ExtensionHttpDestinationSchema(ExtensionDestinationSchema):
    "Marshmallow schema for :class:`commercetools.types.ExtensionHttpDestination`."
    url = marshmallow.fields.String(allow_none=True)
    authentication = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "AuthorizationHeader": "commercetools.schemas.ExtensionAuthorizationHeaderAuthenticationSchema",
            "AzureFunctions": "commercetools.schemas.ExtensionAzureFunctionsAuthenticationSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ExtensionHttpDestination(**data)


class ExtensionPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ExtensionPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExtensionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ExtensionPagedQueryResponse(**data)


class ExtensionSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Extension`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    destination = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "AWSLambda": "commercetools.schemas.ExtensionAWSLambdaDestinationSchema",
            "HTTP": "commercetools.schemas.ExtensionHttpDestinationSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    triggers = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExtensionTriggerSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Extension(**data)


class ExtensionUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ExtensionUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ExtensionUpdateAction(**data)


class ExtensionUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.ExtensionUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "changeDestination": "commercetools.schemas.ExtensionChangeDestinationActionSchema",
                "changeTriggers": "commercetools.schemas.ExtensionChangeTriggersActionSchema",
                "setKey": "commercetools.schemas.ExtensionSetKeyActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ExtensionUpdate(**data)


class FilteredFacetResultSchema(FacetResultSchema):
    "Marshmallow schema for :class:`commercetools.types.FilteredFacetResult`."
    count = marshmallow.fields.Integer(allow_none=True)
    product_count = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="productCount"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.FilteredFacetResult(**data)


class GeoJsonPointSchema(GeoJsonSchema):
    "Marshmallow schema for :class:`commercetools.types.GeoJsonPoint`."
    coordinates = marshmallow.fields.List(
        marshmallow.fields.Nested(
            nested="commercetools.schemas.numberSchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.GeoJsonPoint(**data)


class GoogleCloudPubSubDestinationSchema(DestinationSchema):
    "Marshmallow schema for :class:`commercetools.types.GoogleCloudPubSubDestination`."
    project_id = marshmallow.fields.String(allow_none=True, data_key="projectId")
    topic = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.GoogleCloudPubSubDestination(**data)


class InsufficientScopeErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.InsufficientScopeError`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.InsufficientScopeError(**data)


class InvalidCredentialsErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.InvalidCredentialsError`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.InvalidCredentialsError(**data)


class InvalidCurrentPasswordErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.InvalidCurrentPasswordError`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.InvalidCurrentPasswordError(**data)


class InvalidFieldErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.InvalidFieldError`."
    field = marshmallow.fields.String(allow_none=True)
    invalid_value = marshmallow.fields.Raw(allow_none=True, data_key="invalidValue")
    allowed_values = marshmallow.fields.List(
        marshmallow.fields.Nested(
            nested="commercetools.schemas.anySchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
        missing=None,
        data_key="allowedValues",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.InvalidFieldError(**data)


class InvalidInputErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.InvalidInputError`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.InvalidInputError(**data)


class InvalidItemShippingDetailsErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.InvalidItemShippingDetailsError`."
    subject = marshmallow.fields.String(allow_none=True)
    item_id = marshmallow.fields.String(allow_none=True, data_key="itemId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.InvalidItemShippingDetailsError(**data)


class InvalidJsonInputErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.InvalidJsonInputError`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.InvalidJsonInputError(**data)


class InvalidOperationErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.InvalidOperationError`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.InvalidOperationError(**data)


class InvalidSubjectErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.InvalidSubjectError`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.InvalidSubjectError(**data)


class InvalidTokenErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.InvalidTokenError`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.InvalidTokenError(**data)


class InventoryEntryDeletedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.InventoryEntryDeletedMessagePayload`."
    sku = marshmallow.fields.String(allow_none=True)
    supply_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="supplyChannel",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.InventoryEntryDeletedMessagePayload(**data)


class InventoryEntrySchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.InventoryEntry`."
    sku = marshmallow.fields.String(allow_none=True)
    supply_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="supplyChannel",
    )
    quantity_on_stock = marshmallow.fields.Integer(
        allow_none=True, data_key="quantityOnStock"
    )
    available_quantity = marshmallow.fields.Integer(
        allow_none=True, data_key="availableQuantity"
    )
    restockable_in_days = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="restockableInDays"
    )
    expected_delivery = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="expectedDelivery"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.InventoryEntry(**data)


class InventoryPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.InventoryPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.InventoryEntrySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.InventoryPagedQueryResponse(**data)


class InventoryUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.InventoryUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.InventoryUpdateAction(**data)


class InventoryUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.InventoryUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addQuantity": "commercetools.schemas.InventoryAddQuantityActionSchema",
                "changeQuantity": "commercetools.schemas.InventoryChangeQuantityActionSchema",
                "removeQuantity": "commercetools.schemas.InventoryRemoveQuantityActionSchema",
                "setCustomField": "commercetools.schemas.InventorySetCustomFieldActionSchema",
                "setCustomType": "commercetools.schemas.InventorySetCustomTypeActionSchema",
                "setExpectedDelivery": "commercetools.schemas.InventorySetExpectedDeliveryActionSchema",
                "setRestockableInDays": "commercetools.schemas.InventorySetRestockableInDaysActionSchema",
                "setSupplyChannel": "commercetools.schemas.InventorySetSupplyChannelActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.InventoryUpdate(**data)


class IronMqDestinationSchema(DestinationSchema):
    "Marshmallow schema for :class:`commercetools.types.IronMqDestination`."
    uri = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.IronMqDestination(**data)


class LineItemReturnItemSchema(ReturnItemSchema):
    "Marshmallow schema for :class:`commercetools.types.LineItemReturnItem`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.LineItemReturnItem(**data)


class LineItemStateTransitionMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.LineItemStateTransitionMessagePayload`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    transition_date = marshmallow.fields.DateTime(
        allow_none=True, data_key="transitionDate"
    )
    quantity = marshmallow.fields.Integer(allow_none=True)
    from_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="fromState",
    )
    to_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="toState",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.LineItemStateTransitionMessagePayload(**data)


class MessageDeliverySchema(SubscriptionDeliverySchema):
    "Marshmallow schema for :class:`commercetools.types.MessageDelivery`."
    id = marshmallow.fields.String(allow_none=True)
    version = marshmallow.fields.Integer(allow_none=True)
    created_at = marshmallow.fields.DateTime(allow_none=True, data_key="createdAt")
    last_modified_at = marshmallow.fields.DateTime(
        allow_none=True, data_key="lastModifiedAt"
    )
    sequence_number = marshmallow.fields.Integer(
        allow_none=True, data_key="sequenceNumber"
    )
    resource_version = marshmallow.fields.Integer(
        allow_none=True, data_key="resourceVersion"
    )
    payload_not_included = marshmallow.fields.Nested(
        nested="commercetools.schemas.PayloadNotIncludedSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="payloadNotIncluded",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["notification_type"]
        return types.MessageDelivery(**data)


class MessagePagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.MessagePagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.MessageSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.MessagePagedQueryResponse(**data)


class MessageSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Message`."
    sequence_number = marshmallow.fields.Integer(
        allow_none=True, data_key="sequenceNumber"
    )
    resource = helpers.Discriminator(
        discriminator_field=("typeId", "type_id"),
        discriminator_schemas={
            "cart-discount": "commercetools.schemas.CartDiscountReferenceSchema",
            "cart": "commercetools.schemas.CartReferenceSchema",
            "category": "commercetools.schemas.CategoryReferenceSchema",
            "channel": "commercetools.schemas.ChannelReferenceSchema",
            "key-value-document": "commercetools.schemas.CustomObjectReferenceSchema",
            "customer-group": "commercetools.schemas.CustomerGroupReferenceSchema",
            "customer": "commercetools.schemas.CustomerReferenceSchema",
            "discount-code": "commercetools.schemas.DiscountCodeReferenceSchema",
            "inventory-entry": "commercetools.schemas.InventoryEntryReferenceSchema",
            "order-edit": "commercetools.schemas.OrderEditReferenceSchema",
            "order": "commercetools.schemas.OrderReferenceSchema",
            "payment": "commercetools.schemas.PaymentReferenceSchema",
            "product-discount": "commercetools.schemas.ProductDiscountReferenceSchema",
            "product-type": "commercetools.schemas.ProductTypeReferenceSchema",
            "product": "commercetools.schemas.ProductReferenceSchema",
            "review": "commercetools.schemas.ReviewReferenceSchema",
            "shipping-method": "commercetools.schemas.ShippingMethodReferenceSchema",
            "shopping-list": "commercetools.schemas.ShoppingListReferenceSchema",
            "state": "commercetools.schemas.StateReferenceSchema",
            "tax-category": "commercetools.schemas.TaxCategoryReferenceSchema",
            "type": "commercetools.schemas.TypeReferenceSchema",
            "zone": "commercetools.schemas.ZoneReferenceSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    resource_version = marshmallow.fields.Integer(
        allow_none=True, data_key="resourceVersion"
    )
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Message(**data)


class MissingTaxRateForCountryErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.MissingTaxRateForCountryError`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.MissingTaxRateForCountryError(**data)


class MultiBuyCustomLineItemsTargetSchema(CartDiscountTargetSchema):
    "Marshmallow schema for :class:`commercetools.types.MultiBuyCustomLineItemsTarget`."
    predicate = marshmallow.fields.String(allow_none=True)
    trigger_quantity = marshmallow.fields.Integer(
        allow_none=True, data_key="triggerQuantity"
    )
    discounted_quantity = marshmallow.fields.Integer(
        allow_none=True, data_key="discountedQuantity"
    )
    max_occurrence = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="maxOccurrence"
    )
    selection_mode = marshmallow_enum.EnumField(
        types.SelectionMode, by_value=True, data_key="selectionMode"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.MultiBuyCustomLineItemsTarget(**data)


class MultiBuyLineItemsTargetSchema(CartDiscountTargetSchema):
    "Marshmallow schema for :class:`commercetools.types.MultiBuyLineItemsTarget`."
    predicate = marshmallow.fields.String(allow_none=True)
    trigger_quantity = marshmallow.fields.Integer(
        allow_none=True, data_key="triggerQuantity"
    )
    discounted_quantity = marshmallow.fields.Integer(
        allow_none=True, data_key="discountedQuantity"
    )
    max_occurrence = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="maxOccurrence"
    )
    selection_mode = marshmallow_enum.EnumField(
        types.SelectionMode, by_value=True, data_key="selectionMode"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.MultiBuyLineItemsTarget(**data)


class NoMatchingProductDiscountFoundErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.NoMatchingProductDiscountFoundError`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.NoMatchingProductDiscountFoundError(**data)


class OrderBillingAddressSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderBillingAddressSetMessagePayload`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    old_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="oldAddress",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderBillingAddressSetMessagePayload(**data)


class OrderCreatedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderCreatedMessagePayload`."
    order = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderCreatedMessagePayload(**data)


class OrderCustomLineItemDiscountSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderCustomLineItemDiscountSetMessagePayload`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    discounted_price_per_quantity = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountedLineItemPriceForQuantitySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="discountedPricePerQuantity",
    )
    taxed_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxedItemPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxedPrice",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderCustomLineItemDiscountSetMessagePayload(**data)


class OrderCustomerEmailSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderCustomerEmailSetMessagePayload`."
    email = marshmallow.fields.String(allow_none=True, missing=None)
    old_email = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="oldEmail"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderCustomerEmailSetMessagePayload(**data)


class OrderCustomerSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderCustomerSetMessagePayload`."
    customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="customerGroup",
    )
    old_customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="oldCustomer",
    )
    old_customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="oldCustomerGroup",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderCustomerSetMessagePayload(**data)


class OrderDeletedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderDeletedMessagePayload`."
    order = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderDeletedMessagePayload(**data)


class OrderDiscountCodeAddedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderDiscountCodeAddedMessagePayload`."
    discount_code = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountCodeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="discountCode",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderDiscountCodeAddedMessagePayload(**data)


class OrderDiscountCodeRemovedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderDiscountCodeRemovedMessagePayload`."
    discount_code = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountCodeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="discountCode",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderDiscountCodeRemovedMessagePayload(**data)


class OrderDiscountCodeStateSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderDiscountCodeStateSetMessagePayload`."
    discount_code = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountCodeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="discountCode",
    )
    state = marshmallow_enum.EnumField(types.DiscountCodeState, by_value=True)
    old_state = marshmallow_enum.EnumField(
        types.DiscountCodeState, by_value=True, missing=None, data_key="oldState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderDiscountCodeStateSetMessagePayload(**data)


class OrderEditAppliedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditAppliedMessagePayload`."
    edit = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderEditReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    result = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderEditAppliedSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderEditAppliedMessagePayload(**data)


class OrderEditAppliedSchema(OrderEditResultSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditApplied`."
    applied_at = marshmallow.fields.DateTime(allow_none=True, data_key="appliedAt")
    excerpt_before_edit = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderExcerptSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="excerptBeforeEdit",
    )
    excerpt_after_edit = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderExcerptSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="excerptAfterEdit",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderEditApplied(**data)


class OrderEditNotProcessedSchema(OrderEditResultSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditNotProcessed`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderEditNotProcessed(**data)


class OrderEditPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderEditSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderEditPagedQueryResponse(**data)


class OrderEditPreviewFailureSchema(OrderEditResultSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditPreviewFailure`."
    errors = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("code", "code"),
            discriminator_schemas={
                "access_denied": "commercetools.schemas.AccessDeniedErrorSchema",
                "ConcurrentModification": "commercetools.schemas.ConcurrentModificationErrorSchema",
                "DiscountCodeNonApplicable": "commercetools.schemas.DiscountCodeNonApplicableErrorSchema",
                "DuplicateAttributeValue": "commercetools.schemas.DuplicateAttributeValueErrorSchema",
                "DuplicateAttributeValues": "commercetools.schemas.DuplicateAttributeValuesErrorSchema",
                "DuplicateField": "commercetools.schemas.DuplicateFieldErrorSchema",
                "DuplicatePriceScope": "commercetools.schemas.DuplicatePriceScopeErrorSchema",
                "DuplicateVariantValues": "commercetools.schemas.DuplicateVariantValuesErrorSchema",
                "insufficient_scope": "commercetools.schemas.InsufficientScopeErrorSchema",
                "InvalidCredentials": "commercetools.schemas.InvalidCredentialsErrorSchema",
                "InvalidCurrentPassword": "commercetools.schemas.InvalidCurrentPasswordErrorSchema",
                "InvalidField": "commercetools.schemas.InvalidFieldErrorSchema",
                "InvalidInput": "commercetools.schemas.InvalidInputErrorSchema",
                "InvalidItemShippingDetails": "commercetools.schemas.InvalidItemShippingDetailsErrorSchema",
                "InvalidJsonInput": "commercetools.schemas.InvalidJsonInputErrorSchema",
                "InvalidOperation": "commercetools.schemas.InvalidOperationErrorSchema",
                "InvalidSubject": "commercetools.schemas.InvalidSubjectErrorSchema",
                "invalid_token": "commercetools.schemas.InvalidTokenErrorSchema",
                "MissingTaxRateForCountry": "commercetools.schemas.MissingTaxRateForCountryErrorSchema",
                "NoMatchingProductDiscountFound": "commercetools.schemas.NoMatchingProductDiscountFoundErrorSchema",
                "OutOfStock": "commercetools.schemas.OutOfStockErrorSchema",
                "PriceChanged": "commercetools.schemas.PriceChangedErrorSchema",
                "ReferenceExists": "commercetools.schemas.ReferenceExistsErrorSchema",
                "RequiredField": "commercetools.schemas.RequiredFieldErrorSchema",
                "ResourceNotFound": "commercetools.schemas.ResourceNotFoundErrorSchema",
                "ShippingMethodDoesNotMatchCart": "commercetools.schemas.ShippingMethodDoesNotMatchCartErrorSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        )
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderEditPreviewFailure(**data)


class OrderEditPreviewSuccessSchema(OrderEditResultSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditPreviewSuccess`."
    preview = marshmallow.fields.Nested(
        nested="commercetools.schemas.StagedOrderSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    message_payloads = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("type", "type"),
            discriminator_schemas={
                "CategoryCreated": "commercetools.schemas.CategoryCreatedMessagePayloadSchema",
                "CategorySlugChanged": "commercetools.schemas.CategorySlugChangedMessagePayloadSchema",
                "CustomLineItemStateTransition": "commercetools.schemas.CustomLineItemStateTransitionMessagePayloadSchema",
                "CustomerAddressAdded": "commercetools.schemas.CustomerAddressAddedMessagePayloadSchema",
                "CustomerAddressChanged": "commercetools.schemas.CustomerAddressChangedMessagePayloadSchema",
                "CustomerAddressRemoved": "commercetools.schemas.CustomerAddressRemovedMessagePayloadSchema",
                "CustomerCompanyNameSet": "commercetools.schemas.CustomerCompanyNameSetMessagePayloadSchema",
                "CustomerCreated": "commercetools.schemas.CustomerCreatedMessagePayloadSchema",
                "CustomerDateOfBirthSet": "commercetools.schemas.CustomerDateOfBirthSetMessagePayloadSchema",
                "CustomerEmailChanged": "commercetools.schemas.CustomerEmailChangedMessagePayloadSchema",
                "CustomerEmailVerified": "commercetools.schemas.CustomerEmailVerifiedMessagePayloadSchema",
                "CustomerGroupSet": "commercetools.schemas.CustomerGroupSetMessagePayloadSchema",
                "DeliveryAdded": "commercetools.schemas.DeliveryAddedMessagePayloadSchema",
                "DeliveryAddressSet": "commercetools.schemas.DeliveryAddressSetMessagePayloadSchema",
                "DeliveryItemsUpdated": "commercetools.schemas.DeliveryItemsUpdatedMessagePayloadSchema",
                "DeliveryRemoved": "commercetools.schemas.DeliveryRemovedMessagePayloadSchema",
                "InventoryEntryDeleted": "commercetools.schemas.InventoryEntryDeletedMessagePayloadSchema",
                "LineItemStateTransition": "commercetools.schemas.LineItemStateTransitionMessagePayloadSchema",
                "OrderBillingAddressSet": "commercetools.schemas.OrderBillingAddressSetMessagePayloadSchema",
                "OrderCreated": "commercetools.schemas.OrderCreatedMessagePayloadSchema",
                "OrderCustomLineItemDiscountSet": "commercetools.schemas.OrderCustomLineItemDiscountSetMessagePayloadSchema",
                "OrderCustomerEmailSet": "commercetools.schemas.OrderCustomerEmailSetMessagePayloadSchema",
                "OrderCustomerSet": "commercetools.schemas.OrderCustomerSetMessagePayloadSchema",
                "OrderDeleted": "commercetools.schemas.OrderDeletedMessagePayloadSchema",
                "OrderDiscountCodeAdded": "commercetools.schemas.OrderDiscountCodeAddedMessagePayloadSchema",
                "OrderDiscountCodeRemoved": "commercetools.schemas.OrderDiscountCodeRemovedMessagePayloadSchema",
                "OrderDiscountCodeStateSet": "commercetools.schemas.OrderDiscountCodeStateSetMessagePayloadSchema",
                "OrderEditApplied": "commercetools.schemas.OrderEditAppliedMessagePayloadSchema",
                "OrderImported": "commercetools.schemas.OrderImportedMessagePayloadSchema",
                "OrderLineItemDiscountSet": "commercetools.schemas.OrderLineItemDiscountSetMessagePayloadSchema",
                "OrderPaymentStateChanged": "commercetools.schemas.OrderPaymentStateChangedMessagePayloadSchema",
                "ReturnInfoAdded": "commercetools.schemas.OrderReturnInfoAddedMessagePayloadSchema",
                "OrderReturnShipmentStateChanged": "commercetools.schemas.OrderReturnShipmentStateChangedMessagePayloadSchema",
                "OrderShipmentStateChanged": "commercetools.schemas.OrderShipmentStateChangedMessagePayloadSchema",
                "OrderShippingAddressSet": "commercetools.schemas.OrderShippingAddressSetMessagePayloadSchema",
                "OrderShippingInfoSet": "commercetools.schemas.OrderShippingInfoSetMessagePayloadSchema",
                "OrderShippingRateInputSet": "commercetools.schemas.OrderShippingRateInputSetMessagePayloadSchema",
                "OrderStateChanged": "commercetools.schemas.OrderStateChangedMessagePayloadSchema",
                "OrderStateTransition": "commercetools.schemas.OrderStateTransitionMessagePayloadSchema",
                "ParcelAddedToDelivery": "commercetools.schemas.ParcelAddedToDeliveryMessagePayloadSchema",
                "ParcelItemsUpdated": "commercetools.schemas.ParcelItemsUpdatedMessagePayloadSchema",
                "ParcelMeasurementsUpdated": "commercetools.schemas.ParcelMeasurementsUpdatedMessagePayloadSchema",
                "ParcelRemovedFromDelivery": "commercetools.schemas.ParcelRemovedFromDeliveryMessagePayloadSchema",
                "ParcelTrackingDataUpdated": "commercetools.schemas.ParcelTrackingDataUpdatedMessagePayloadSchema",
                "PaymentCreated": "commercetools.schemas.PaymentCreatedMessagePayloadSchema",
                "PaymentInteractionAdded": "commercetools.schemas.PaymentInteractionAddedMessagePayloadSchema",
                "PaymentStatusInterfaceCodeSet": "commercetools.schemas.PaymentStatusInterfaceCodeSetMessagePayloadSchema",
                "PaymentStatusStateTransition": "commercetools.schemas.PaymentStatusStateTransitionMessagePayloadSchema",
                "PaymentTransactionAdded": "commercetools.schemas.PaymentTransactionAddedMessagePayloadSchema",
                "PaymentTransactionStateChanged": "commercetools.schemas.PaymentTransactionStateChangedMessagePayloadSchema",
                "ProductCreated": "commercetools.schemas.ProductCreatedMessagePayloadSchema",
                "ProductDeleted": "commercetools.schemas.ProductDeletedMessagePayloadSchema",
                "ProductImageAdded": "commercetools.schemas.ProductImageAddedMessagePayloadSchema",
                "ProductPublished": "commercetools.schemas.ProductPublishedMessagePayloadSchema",
                "ProductRevertedStagedChanges": "commercetools.schemas.ProductRevertedStagedChangesMessagePayloadSchema",
                "ProductSlugChanged": "commercetools.schemas.ProductSlugChangedMessagePayloadSchema",
                "ProductStateTransition": "commercetools.schemas.ProductStateTransitionMessagePayloadSchema",
                "ProductUnpublished": "commercetools.schemas.ProductUnpublishedMessagePayloadSchema",
                "ProductVariantDeleted": "commercetools.schemas.ProductVariantDeletedMessagePayloadSchema",
                "ReviewCreated": "commercetools.schemas.ReviewCreatedMessagePayloadSchema",
                "ReviewRatingSet": "commercetools.schemas.ReviewRatingSetMessagePayloadSchema",
                "ReviewStateTransition": "commercetools.schemas.ReviewStateTransitionMessagePayloadSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        data_key="messagePayloads",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderEditPreviewSuccess(**data)


class OrderEditSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEdit`."
    created_at = marshmallow.fields.DateTime(allow_none=True, data_key="createdAt")
    last_modified_at = marshmallow.fields.DateTime(
        allow_none=True, data_key="lastModifiedAt"
    )
    key = marshmallow.fields.String(allow_none=True, missing=None)
    resource = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    staged_actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addCustomLineItem": "commercetools.schemas.StagedOrderAddCustomLineItemActionSchema",
                "addDelivery": "commercetools.schemas.StagedOrderAddDeliveryActionSchema",
                "addDiscountCode": "commercetools.schemas.StagedOrderAddDiscountCodeActionSchema",
                "addItemShippingAddress": "commercetools.schemas.StagedOrderAddItemShippingAddressActionSchema",
                "addLineItem": "commercetools.schemas.StagedOrderAddLineItemActionSchema",
                "addParcelToDelivery": "commercetools.schemas.StagedOrderAddParcelToDeliveryActionSchema",
                "addPayment": "commercetools.schemas.StagedOrderAddPaymentActionSchema",
                "addReturnInfo": "commercetools.schemas.StagedOrderAddReturnInfoActionSchema",
                "addShoppingList": "commercetools.schemas.StagedOrderAddShoppingListActionSchema",
                "changeCustomLineItemMoney": "commercetools.schemas.StagedOrderChangeCustomLineItemMoneyActionSchema",
                "changeCustomLineItemQuantity": "commercetools.schemas.StagedOrderChangeCustomLineItemQuantityActionSchema",
                "changeLineItemQuantity": "commercetools.schemas.StagedOrderChangeLineItemQuantityActionSchema",
                "changeOrderState": "commercetools.schemas.StagedOrderChangeOrderStateActionSchema",
                "changePaymentState": "commercetools.schemas.StagedOrderChangePaymentStateActionSchema",
                "changeShipmentState": "commercetools.schemas.StagedOrderChangeShipmentStateActionSchema",
                "changeTaxCalculationMode": "commercetools.schemas.StagedOrderChangeTaxCalculationModeActionSchema",
                "changeTaxMode": "commercetools.schemas.StagedOrderChangeTaxModeActionSchema",
                "changeTaxRoundingMode": "commercetools.schemas.StagedOrderChangeTaxRoundingModeActionSchema",
                "importCustomLineItemState": "commercetools.schemas.StagedOrderImportCustomLineItemStateActionSchema",
                "importLineItemState": "commercetools.schemas.StagedOrderImportLineItemStateActionSchema",
                "removeCustomLineItem": "commercetools.schemas.StagedOrderRemoveCustomLineItemActionSchema",
                "removeDelivery": "commercetools.schemas.StagedOrderRemoveDeliveryActionSchema",
                "removeDiscountCode": "commercetools.schemas.StagedOrderRemoveDiscountCodeActionSchema",
                "removeItemShippingAddress": "commercetools.schemas.StagedOrderRemoveItemShippingAddressActionSchema",
                "removeLineItem": "commercetools.schemas.StagedOrderRemoveLineItemActionSchema",
                "removeParcelFromDelivery": "commercetools.schemas.StagedOrderRemoveParcelFromDeliveryActionSchema",
                "removePayment": "commercetools.schemas.StagedOrderRemovePaymentActionSchema",
                "setBillingAddress": "commercetools.schemas.StagedOrderSetBillingAddressActionSchema",
                "setCountry": "commercetools.schemas.StagedOrderSetCountryActionSchema",
                "setCustomField": "commercetools.schemas.StagedOrderSetCustomFieldActionSchema",
                "setCustomLineItemCustomField": "commercetools.schemas.StagedOrderSetCustomLineItemCustomFieldActionSchema",
                "setCustomLineItemCustomType": "commercetools.schemas.StagedOrderSetCustomLineItemCustomTypeActionSchema",
                "setCustomLineItemShippingDetails": "commercetools.schemas.StagedOrderSetCustomLineItemShippingDetailsActionSchema",
                "setCustomLineItemTaxAmount": "commercetools.schemas.StagedOrderSetCustomLineItemTaxAmountActionSchema",
                "setCustomLineItemTaxRate": "commercetools.schemas.StagedOrderSetCustomLineItemTaxRateActionSchema",
                "setCustomShippingMethod": "commercetools.schemas.StagedOrderSetCustomShippingMethodActionSchema",
                "setCustomType": "commercetools.schemas.StagedOrderSetCustomTypeActionSchema",
                "setCustomerEmail": "commercetools.schemas.StagedOrderSetCustomerEmailActionSchema",
                "setCustomerGroup": "commercetools.schemas.StagedOrderSetCustomerGroupActionSchema",
                "setCustomerId": "commercetools.schemas.StagedOrderSetCustomerIdActionSchema",
                "setDeliveryAddress": "commercetools.schemas.StagedOrderSetDeliveryAddressActionSchema",
                "setDeliveryItems": "commercetools.schemas.StagedOrderSetDeliveryItemsActionSchema",
                "setLineItemCustomField": "commercetools.schemas.StagedOrderSetLineItemCustomFieldActionSchema",
                "setLineItemCustomType": "commercetools.schemas.StagedOrderSetLineItemCustomTypeActionSchema",
                "setLineItemPrice": "commercetools.schemas.StagedOrderSetLineItemPriceActionSchema",
                "setLineItemShippingDetails": "commercetools.schemas.StagedOrderSetLineItemShippingDetailsActionSchema",
                "setLineItemTaxAmount": "commercetools.schemas.StagedOrderSetLineItemTaxAmountActionSchema",
                "setLineItemTaxRate": "commercetools.schemas.StagedOrderSetLineItemTaxRateActionSchema",
                "setLineItemTotalPrice": "commercetools.schemas.StagedOrderSetLineItemTotalPriceActionSchema",
                "setLocale": "commercetools.schemas.StagedOrderSetLocaleActionSchema",
                "setOrderNumber": "commercetools.schemas.StagedOrderSetOrderNumberActionSchema",
                "setOrderTotalTax": "commercetools.schemas.StagedOrderSetOrderTotalTaxActionSchema",
                "setParcelItems": "commercetools.schemas.StagedOrderSetParcelItemsActionSchema",
                "setParcelMeasurements": "commercetools.schemas.StagedOrderSetParcelMeasurementsActionSchema",
                "setParcelTrackingData": "commercetools.schemas.StagedOrderSetParcelTrackingDataActionSchema",
                "setReturnPaymentState": "commercetools.schemas.StagedOrderSetReturnPaymentStateActionSchema",
                "setReturnShipmentState": "commercetools.schemas.StagedOrderSetReturnShipmentStateActionSchema",
                "setShippingAddress": "commercetools.schemas.StagedOrderSetShippingAddressActionSchema",
                "setShippingAddressAndCustomShippingMethod": "commercetools.schemas.StagedOrderSetShippingAddressAndCustomShippingMethodActionSchema",
                "setShippingAddressAndShippingMethod": "commercetools.schemas.StagedOrderSetShippingAddressAndShippingMethodActionSchema",
                "setShippingMethod": "commercetools.schemas.StagedOrderSetShippingMethodActionSchema",
                "setShippingMethodTaxAmount": "commercetools.schemas.StagedOrderSetShippingMethodTaxAmountActionSchema",
                "setShippingMethodTaxRate": "commercetools.schemas.StagedOrderSetShippingMethodTaxRateActionSchema",
                "setShippingRateInput": "commercetools.schemas.StagedOrderSetShippingRateInputActionSchema",
                "transitionCustomLineItemState": "commercetools.schemas.StagedOrderTransitionCustomLineItemStateActionSchema",
                "transitionLineItemState": "commercetools.schemas.StagedOrderTransitionLineItemStateActionSchema",
                "transitionState": "commercetools.schemas.StagedOrderTransitionStateActionSchema",
                "updateItemShippingAddress": "commercetools.schemas.StagedOrderUpdateItemShippingAddressActionSchema",
                "updateSyncInfo": "commercetools.schemas.StagedOrderUpdateSyncInfoActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        data_key="stagedActions",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    result = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "Applied": "commercetools.schemas.OrderEditAppliedSchema",
            "NotProcessed": "commercetools.schemas.OrderEditNotProcessedSchema",
            "PreviewFailure": "commercetools.schemas.OrderEditPreviewFailureSchema",
            "PreviewSuccess": "commercetools.schemas.OrderEditPreviewSuccessSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    comment = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderEdit(**data)


class OrderEditUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderEditUpdateAction(**data)


class OrderEditUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addStagedAction": "commercetools.schemas.OrderEditAddStagedActionActionSchema",
                "setComment": "commercetools.schemas.OrderEditSetCommentActionSchema",
                "setCustomField": "commercetools.schemas.OrderEditSetCustomFieldActionSchema",
                "setCustomType": "commercetools.schemas.OrderEditSetCustomTypeActionSchema",
                "setKey": "commercetools.schemas.OrderEditSetKeyActionSchema",
                "setStagedActions": "commercetools.schemas.OrderEditSetStagedActionsActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        )
    )
    dry_run = marshmallow.fields.Bool(allow_none=True, data_key="dryRun")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderEditUpdate(**data)


class OrderImportedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderImportedMessagePayload`."
    order = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderImportedMessagePayload(**data)


class OrderLineItemDiscountSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderLineItemDiscountSetMessagePayload`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    discounted_price_per_quantity = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountedLineItemPriceForQuantitySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="discountedPricePerQuantity",
    )
    total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalPrice",
    )
    taxed_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxedItemPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxedPrice",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderLineItemDiscountSetMessagePayload(**data)


class OrderPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderPagedQueryResponse(**data)


class OrderPaymentStateChangedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderPaymentStateChangedMessagePayload`."
    payment_state = marshmallow_enum.EnumField(
        types.PaymentState, by_value=True, data_key="paymentState"
    )
    old_payment_state = marshmallow_enum.EnumField(
        types.PaymentState, by_value=True, data_key="oldPaymentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderPaymentStateChangedMessagePayload(**data)


class OrderReturnInfoAddedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderReturnInfoAddedMessagePayload`."
    return_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.ReturnInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="returnInfo",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderReturnInfoAddedMessagePayload(**data)


class OrderReturnShipmentStateChangedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderReturnShipmentStateChangedMessagePayload`."
    return_item_id = marshmallow.fields.String(allow_none=True, data_key="returnItemId")
    return_shipment_state = marshmallow_enum.EnumField(
        types.ReturnShipmentState, by_value=True, data_key="returnShipmentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderReturnShipmentStateChangedMessagePayload(**data)


class OrderSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Order`."
    completed_at = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="completedAt"
    )
    order_number = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="orderNumber"
    )
    customer_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerId"
    )
    customer_email = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerEmail"
    )
    anonymous_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="anonymousId"
    )
    line_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.LineItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="lineItems",
    )
    custom_line_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomLineItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="customLineItems",
    )
    total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalPrice",
    )
    taxed_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxedPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxedPrice",
    )
    shipping_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingAddress",
    )
    billing_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="billingAddress",
    )
    tax_mode = marshmallow_enum.EnumField(
        types.TaxMode, by_value=True, missing=None, data_key="taxMode"
    )
    tax_rounding_mode = marshmallow_enum.EnumField(
        types.RoundingMode, by_value=True, missing=None, data_key="taxRoundingMode"
    )
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="customerGroup",
    )
    country = marshmallow.fields.String(allow_none=True, missing=None)
    order_state = marshmallow_enum.EnumField(
        types.OrderState, by_value=True, data_key="orderState"
    )
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    shipment_state = marshmallow_enum.EnumField(
        types.ShipmentState, by_value=True, missing=None, data_key="shipmentState"
    )
    payment_state = marshmallow_enum.EnumField(
        types.PaymentState, by_value=True, missing=None, data_key="paymentState"
    )
    shipping_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingInfo",
    )
    sync_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.SyncInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="syncInfo",
    )
    return_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.ReturnInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="returnInfo",
    )
    discount_codes = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountCodeInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="discountCodes",
    )
    last_message_sequence_number = marshmallow.fields.Integer(
        allow_none=True, data_key="lastMessageSequenceNumber"
    )
    cart = marshmallow.fields.Nested(
        nested="commercetools.schemas.CartReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    payment_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="paymentInfo",
    )
    locale = marshmallow.fields.String(allow_none=True, missing=None)
    inventory_mode = marshmallow_enum.EnumField(
        types.InventoryMode, by_value=True, missing=None, data_key="inventoryMode"
    )
    origin = marshmallow_enum.EnumField(types.CartOrigin, by_value=True)
    tax_calculation_mode = marshmallow_enum.EnumField(
        types.TaxCalculationMode,
        by_value=True,
        missing=None,
        data_key="taxCalculationMode",
    )
    shipping_rate_input = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "Classification": "commercetools.schemas.ClassificationShippingRateInputSchema",
            "Score": "commercetools.schemas.ScoreShippingRateInputSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingRateInput",
    )
    item_shipping_addresses = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="itemShippingAddresses",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Order(**data)


class OrderShipmentStateChangedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderShipmentStateChangedMessagePayload`."
    shipment_state = marshmallow_enum.EnumField(
        types.ShipmentState, by_value=True, data_key="shipmentState"
    )
    old_shipment_state = marshmallow_enum.EnumField(
        types.ShipmentState, by_value=True, data_key="oldShipmentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderShipmentStateChangedMessagePayload(**data)


class OrderShippingAddressSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderShippingAddressSetMessagePayload`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    old_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="oldAddress",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderShippingAddressSetMessagePayload(**data)


class OrderShippingInfoSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderShippingInfoSetMessagePayload`."
    shipping_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingInfo",
    )
    old_shipping_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="oldShippingInfo",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderShippingInfoSetMessagePayload(**data)


class OrderShippingRateInputSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderShippingRateInputSetMessagePayload`."
    shipping_rate_input = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "Classification": "commercetools.schemas.ClassificationShippingRateInputSchema",
            "Score": "commercetools.schemas.ScoreShippingRateInputSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingRateInput",
    )
    old_shipping_rate_input = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "Classification": "commercetools.schemas.ClassificationShippingRateInputSchema",
            "Score": "commercetools.schemas.ScoreShippingRateInputSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="oldShippingRateInput",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderShippingRateInputSetMessagePayload(**data)


class OrderStateChangedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderStateChangedMessagePayload`."
    order_state = marshmallow_enum.EnumField(
        types.OrderState, by_value=True, data_key="orderState"
    )
    old_order_state = marshmallow_enum.EnumField(
        types.OrderState, by_value=True, data_key="oldOrderState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderStateChangedMessagePayload(**data)


class OrderStateTransitionMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderStateTransitionMessagePayload`."
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    force = marshmallow.fields.Bool(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.OrderStateTransitionMessagePayload(**data)


class OrderUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderUpdateAction(**data)


class OrderUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addDelivery": "commercetools.schemas.OrderAddDeliveryActionSchema",
                "addItemShippingAddress": "commercetools.schemas.OrderAddItemShippingAddressActionSchema",
                "addParcelToDelivery": "commercetools.schemas.OrderAddParcelToDeliveryActionSchema",
                "addPayment": "commercetools.schemas.OrderAddPaymentActionSchema",
                "addReturnInfo": "commercetools.schemas.OrderAddReturnInfoActionSchema",
                "changeOrderState": "commercetools.schemas.OrderChangeOrderStateActionSchema",
                "changePaymentState": "commercetools.schemas.OrderChangePaymentStateActionSchema",
                "changeShipmentState": "commercetools.schemas.OrderChangeShipmentStateActionSchema",
                "importCustomLineItemState": "commercetools.schemas.OrderImportCustomLineItemStateActionSchema",
                "importLineItemState": "commercetools.schemas.OrderImportLineItemStateActionSchema",
                "removeDelivery": "commercetools.schemas.OrderRemoveDeliveryActionSchema",
                "removeItemShippingAddress": "commercetools.schemas.OrderRemoveItemShippingAddressActionSchema",
                "removeParcelFromDelivery": "commercetools.schemas.OrderRemoveParcelFromDeliveryActionSchema",
                "removePayment": "commercetools.schemas.OrderRemovePaymentActionSchema",
                "setBillingAddress": "commercetools.schemas.OrderSetBillingAddressActionSchema",
                "setCustomField": "commercetools.schemas.OrderSetCustomFieldActionSchema",
                "setCustomLineItemCustomField": "commercetools.schemas.OrderSetCustomLineItemCustomFieldActionSchema",
                "setCustomLineItemCustomType": "commercetools.schemas.OrderSetCustomLineItemCustomTypeActionSchema",
                "setCustomLineItemShippingDetails": "commercetools.schemas.OrderSetCustomLineItemShippingDetailsActionSchema",
                "setCustomType": "commercetools.schemas.OrderSetCustomTypeActionSchema",
                "setCustomerEmail": "commercetools.schemas.OrderSetCustomerEmailActionSchema",
                "setCustomerId": "commercetools.schemas.OrderSetCustomerIdActionSchema",
                "setDeliveryAddress": "commercetools.schemas.OrderSetDeliveryAddressActionSchema",
                "setDeliveryItems": "commercetools.schemas.OrderSetDeliveryItemsActionSchema",
                "setLineItemCustomField": "commercetools.schemas.OrderSetLineItemCustomFieldActionSchema",
                "setLineItemCustomType": "commercetools.schemas.OrderSetLineItemCustomTypeActionSchema",
                "setLineItemShippingDetails": "commercetools.schemas.OrderSetLineItemShippingDetailsActionSchema",
                "setLocale": "commercetools.schemas.OrderSetLocaleActionSchema",
                "setOrderNumber": "commercetools.schemas.OrderSetOrderNumberActionSchema",
                "setParcelItems": "commercetools.schemas.OrderSetParcelItemsActionSchema",
                "setParcelMeasurements": "commercetools.schemas.OrderSetParcelMeasurementsActionSchema",
                "setParcelTrackingData": "commercetools.schemas.OrderSetParcelTrackingDataActionSchema",
                "setReturnPaymentState": "commercetools.schemas.OrderSetReturnPaymentStateActionSchema",
                "setReturnShipmentState": "commercetools.schemas.OrderSetReturnShipmentStateActionSchema",
                "setShippingAddress": "commercetools.schemas.OrderSetShippingAddressActionSchema",
                "transitionCustomLineItemState": "commercetools.schemas.OrderTransitionCustomLineItemStateActionSchema",
                "transitionLineItemState": "commercetools.schemas.OrderTransitionLineItemStateActionSchema",
                "transitionState": "commercetools.schemas.OrderTransitionStateActionSchema",
                "updateItemShippingAddress": "commercetools.schemas.OrderUpdateItemShippingAddressActionSchema",
                "updateSyncInfo": "commercetools.schemas.OrderUpdateSyncInfoActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderUpdate(**data)


class OutOfStockErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.OutOfStockError`."
    line_items = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True), data_key="lineItems"
    )
    skus = marshmallow.fields.List(marshmallow.fields.String(allow_none=True))

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.OutOfStockError(**data)


class ParcelAddedToDeliveryMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ParcelAddedToDeliveryMessagePayload`."
    delivery = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliverySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    parcel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ParcelAddedToDeliveryMessagePayload(**data)


class ParcelItemsUpdatedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ParcelItemsUpdatedMessagePayload`."
    parcel_id = marshmallow.fields.String(allow_none=True, data_key="parcelId")
    delivery_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="deliveryId"
    )
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    old_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="oldItems",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ParcelItemsUpdatedMessagePayload(**data)


class ParcelMeasurementsUpdatedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ParcelMeasurementsUpdatedMessagePayload`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    parcel_id = marshmallow.fields.String(allow_none=True, data_key="parcelId")
    measurements = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelMeasurementsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ParcelMeasurementsUpdatedMessagePayload(**data)


class ParcelRemovedFromDeliveryMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ParcelRemovedFromDeliveryMessagePayload`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    parcel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ParcelRemovedFromDeliveryMessagePayload(**data)


class ParcelTrackingDataUpdatedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ParcelTrackingDataUpdatedMessagePayload`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    parcel_id = marshmallow.fields.String(allow_none=True, data_key="parcelId")
    tracking_data = marshmallow.fields.Nested(
        nested="commercetools.schemas.TrackingDataSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="trackingData",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ParcelTrackingDataUpdatedMessagePayload(**data)


class PaymentCreatedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentCreatedMessagePayload`."
    payment = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.PaymentCreatedMessagePayload(**data)


class PaymentInteractionAddedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentInteractionAddedMessagePayload`."
    interaction = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.PaymentInteractionAddedMessagePayload(**data)


class PaymentPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PaymentPagedQueryResponse(**data)


class PaymentSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Payment`."
    customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    anonymous_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="anonymousId"
    )
    external_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="externalId"
    )
    interface_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="interfaceId"
    )
    amount_planned = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="amountPlanned",
    )
    amount_authorized = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="amountAuthorized",
    )
    authorized_until = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="authorizedUntil"
    )
    amount_paid = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="amountPaid",
    )
    amount_refunded = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "centPrecision": "commercetools.schemas.CentPrecisionMoneySchema",
            "highPrecision": "commercetools.schemas.HighPrecisionMoneySchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="amountRefunded",
    )
    payment_method_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentMethodInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="paymentMethodInfo",
    )
    payment_status = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentStatusSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="paymentStatus",
    )
    transactions = marshmallow.fields.Nested(
        nested="commercetools.schemas.TransactionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    interface_interactions = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="interfaceInteractions",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Payment(**data)


class PaymentStatusInterfaceCodeSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentStatusInterfaceCodeSetMessagePayload`."
    payment_id = marshmallow.fields.String(allow_none=True, data_key="paymentId")
    interface_code = marshmallow.fields.String(
        allow_none=True, data_key="interfaceCode"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.PaymentStatusInterfaceCodeSetMessagePayload(**data)


class PaymentStatusStateTransitionMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentStatusStateTransitionMessagePayload`."
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    force = marshmallow.fields.Bool(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.PaymentStatusStateTransitionMessagePayload(**data)


class PaymentTransactionAddedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentTransactionAddedMessagePayload`."
    transaction = marshmallow.fields.Nested(
        nested="commercetools.schemas.TransactionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.PaymentTransactionAddedMessagePayload(**data)


class PaymentTransactionStateChangedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentTransactionStateChangedMessagePayload`."
    transaction_id = marshmallow.fields.String(
        allow_none=True, data_key="transactionId"
    )
    state = marshmallow_enum.EnumField(types.TransactionState, by_value=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.PaymentTransactionStateChangedMessagePayload(**data)


class PaymentUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentUpdateAction(**data)


class PaymentUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addInterfaceInteraction": "commercetools.schemas.PaymentAddInterfaceInteractionActionSchema",
                "addTransaction": "commercetools.schemas.PaymentAddTransactionActionSchema",
                "changeAmountPlanned": "commercetools.schemas.PaymentChangeAmountPlannedActionSchema",
                "changeTransactionInteractionId": "commercetools.schemas.PaymentChangeTransactionInteractionIdActionSchema",
                "changeTransactionState": "commercetools.schemas.PaymentChangeTransactionStateActionSchema",
                "changeTransactionTimestamp": "commercetools.schemas.PaymentChangeTransactionTimestampActionSchema",
                "setAmountPaid": "commercetools.schemas.PaymentSetAmountPaidActionSchema",
                "setAmountRefunded": "commercetools.schemas.PaymentSetAmountRefundedActionSchema",
                "setAnonymousId": "commercetools.schemas.PaymentSetAnonymousIdActionSchema",
                "setAuthorization": "commercetools.schemas.PaymentSetAuthorizationActionSchema",
                "setCustomField": "commercetools.schemas.PaymentSetCustomFieldActionSchema",
                "setCustomType": "commercetools.schemas.PaymentSetCustomTypeActionSchema",
                "setCustomer": "commercetools.schemas.PaymentSetCustomerActionSchema",
                "setExternalId": "commercetools.schemas.PaymentSetExternalIdActionSchema",
                "setInterfaceId": "commercetools.schemas.PaymentSetInterfaceIdActionSchema",
                "setKey": "commercetools.schemas.PaymentSetKeyActionSchema",
                "setMethodInfoInterface": "commercetools.schemas.PaymentSetMethodInfoInterfaceActionSchema",
                "setMethodInfoMethod": "commercetools.schemas.PaymentSetMethodInfoMethodActionSchema",
                "setMethodInfoName": "commercetools.schemas.PaymentSetMethodInfoNameActionSchema",
                "setStatusInterfaceCode": "commercetools.schemas.PaymentSetStatusInterfaceCodeActionSchema",
                "setStatusInterfaceText": "commercetools.schemas.PaymentSetStatusInterfaceTextActionSchema",
                "transitionState": "commercetools.schemas.PaymentTransitionStateActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PaymentUpdate(**data)


class PriceChangedErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.PriceChangedError`."
    line_items = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True), data_key="lineItems"
    )
    shipping = marshmallow.fields.Bool(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.PriceChangedError(**data)


class ProductCreatedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductCreatedMessagePayload`."
    product_projection = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductProjectionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="productProjection",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductCreatedMessagePayload(**data)


class ProductDeletedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDeletedMessagePayload`."
    removed_image_urls = marshmallow.fields.List(
        marshmallow.fields.Nested(
            nested="commercetools.schemas.anySchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
        data_key="removedImageUrls",
    )
    current_projection = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductProjectionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="currentProjection",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductDeletedMessagePayload(**data)


class ProductDiscountPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductDiscountSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductDiscountPagedQueryResponse(**data)


class ProductDiscountSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscount`."
    name = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    value = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "absolute": "commercetools.schemas.ProductDiscountValueAbsoluteSchema",
            "external": "commercetools.schemas.ProductDiscountValueExternalSchema",
            "relative": "commercetools.schemas.ProductDiscountValueRelativeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    predicate = marshmallow.fields.String(allow_none=True)
    sort_order = marshmallow.fields.String(allow_none=True, data_key="sortOrder")
    is_active = marshmallow.fields.Bool(allow_none=True, data_key="isActive")
    references = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("typeId", "type_id"),
            discriminator_schemas={
                "cart-discount": "commercetools.schemas.CartDiscountReferenceSchema",
                "cart": "commercetools.schemas.CartReferenceSchema",
                "category": "commercetools.schemas.CategoryReferenceSchema",
                "channel": "commercetools.schemas.ChannelReferenceSchema",
                "key-value-document": "commercetools.schemas.CustomObjectReferenceSchema",
                "customer-group": "commercetools.schemas.CustomerGroupReferenceSchema",
                "customer": "commercetools.schemas.CustomerReferenceSchema",
                "discount-code": "commercetools.schemas.DiscountCodeReferenceSchema",
                "inventory-entry": "commercetools.schemas.InventoryEntryReferenceSchema",
                "order-edit": "commercetools.schemas.OrderEditReferenceSchema",
                "order": "commercetools.schemas.OrderReferenceSchema",
                "payment": "commercetools.schemas.PaymentReferenceSchema",
                "product-discount": "commercetools.schemas.ProductDiscountReferenceSchema",
                "product-type": "commercetools.schemas.ProductTypeReferenceSchema",
                "product": "commercetools.schemas.ProductReferenceSchema",
                "review": "commercetools.schemas.ReviewReferenceSchema",
                "shipping-method": "commercetools.schemas.ShippingMethodReferenceSchema",
                "shopping-list": "commercetools.schemas.ShoppingListReferenceSchema",
                "state": "commercetools.schemas.StateReferenceSchema",
                "tax-category": "commercetools.schemas.TaxCategoryReferenceSchema",
                "type": "commercetools.schemas.TypeReferenceSchema",
                "zone": "commercetools.schemas.ZoneReferenceSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        )
    )
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductDiscount(**data)


class ProductDiscountUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountUpdateAction(**data)


class ProductDiscountUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "changeIsActive": "commercetools.schemas.ProductDiscountChangeIsActiveActionSchema",
                "changeName": "commercetools.schemas.ProductDiscountChangeNameActionSchema",
                "changePredicate": "commercetools.schemas.ProductDiscountChangePredicateActionSchema",
                "changeSortOrder": "commercetools.schemas.ProductDiscountChangeSortOrderActionSchema",
                "changeValue": "commercetools.schemas.ProductDiscountChangeValueActionSchema",
                "setDescription": "commercetools.schemas.ProductDiscountSetDescriptionActionSchema",
                "setValidFrom": "commercetools.schemas.ProductDiscountSetValidFromActionSchema",
                "setValidFromAndUntil": "commercetools.schemas.ProductDiscountSetValidFromAndUntilActionSchema",
                "setValidUntil": "commercetools.schemas.ProductDiscountSetValidUntilActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductDiscountUpdate(**data)


class ProductDiscountValueAbsoluteSchema(ProductDiscountValueSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountValueAbsolute`."
    money = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductDiscountValueAbsolute(**data)


class ProductDiscountValueExternalSchema(ProductDiscountValueSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountValueExternal`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductDiscountValueExternal(**data)


class ProductDiscountValueRelativeSchema(ProductDiscountValueSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountValueRelative`."
    permyriad = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductDiscountValueRelative(**data)


class ProductImageAddedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductImageAddedMessagePayload`."
    variant_id = marshmallow.fields.Integer(allow_none=True, data_key="variantId")
    image = marshmallow.fields.Nested(
        nested="commercetools.schemas.ImageSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    staged = marshmallow.fields.Bool(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductImageAddedMessagePayload(**data)


class ProductPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductPagedQueryResponse(**data)


class ProductProjectionPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductProjectionPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductProjectionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductProjectionPagedQueryResponse(**data)


class ProductProjectionPagedSearchResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductProjectionPagedSearchResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductProjectionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    facets = marshmallow.fields.Nested(
        nested="commercetools.schemas.FacetResultsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductProjectionPagedSearchResponse(**data)


class ProductProjectionSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductProjection`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    product_type = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductTypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="productType",
    )
    name = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    slug = LocalizedStringField(allow_none=True)
    categories = marshmallow.fields.Nested(
        nested="commercetools.schemas.CategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    category_order_hints = CategoryOrderHintsField(
        allow_none=True, missing=None, data_key="categoryOrderHints"
    )
    meta_title = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaTitle"
    )
    meta_description = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaDescription"
    )
    meta_keywords = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaKeywords"
    )
    search_keywords = marshmallow.fields.Nested(
        nested="commercetools.schemas.SearchKeywordsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="searchKeywords",
    )
    has_staged_changes = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="hasStagedChanges"
    )
    published = marshmallow.fields.Bool(allow_none=True, missing=None)
    master_variant = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductVariantSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="masterVariant",
    )
    variants = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductVariantSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    review_rating_statistics = marshmallow.fields.Nested(
        nested="commercetools.schemas.ReviewRatingStatisticsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="reviewRatingStatistics",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductProjection(**data)


class ProductPublishedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductPublishedMessagePayload`."
    removed_image_urls = marshmallow.fields.List(
        marshmallow.fields.Nested(
            nested="commercetools.schemas.anySchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
        data_key="removedImageUrls",
    )
    product_projection = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductProjectionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="productProjection",
    )
    scope = marshmallow_enum.EnumField(types.ProductPublishScope, by_value=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductPublishedMessagePayload(**data)


class ProductRevertedStagedChangesMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRevertedStagedChangesMessagePayload`."
    removed_image_urls = marshmallow.fields.List(
        marshmallow.fields.Nested(
            nested="commercetools.schemas.anySchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
        data_key="removedImageUrls",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductRevertedStagedChangesMessagePayload(**data)


class ProductSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Product`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    product_type = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductTypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="productType",
    )
    master_data = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductCatalogDataSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="masterData",
    )
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    review_rating_statistics = marshmallow.fields.Nested(
        nested="commercetools.schemas.ReviewRatingStatisticsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="reviewRatingStatistics",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Product(**data)


class ProductSlugChangedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSlugChangedMessagePayload`."
    slug = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductSlugChangedMessagePayload(**data)


class ProductStateTransitionMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductStateTransitionMessagePayload`."
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    force = marshmallow.fields.Bool(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductStateTransitionMessagePayload(**data)


class ProductTypePagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypePagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductTypeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductTypePagedQueryResponse(**data)


class ProductTypeSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductType`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    name = marshmallow.fields.String(allow_none=True)
    description = marshmallow.fields.String(allow_none=True)
    attributes = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeDefinitionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductType(**data)


class ProductTypeUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeUpdateAction(**data)


class ProductTypeUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addAttributeDefinition": "commercetools.schemas.ProductTypeAddAttributeDefinitionActionSchema",
                "addLocalizedEnumValue": "commercetools.schemas.ProductTypeAddLocalizedEnumValueActionSchema",
                "addPlainEnumValue": "commercetools.schemas.ProductTypeAddPlainEnumValueActionSchema",
                "changeAttributeConstraint": "commercetools.schemas.ProductTypeChangeAttributeConstraintActionSchema",
                "changeAttributeName": "commercetools.schemas.ProductTypeChangeAttributeNameActionSchema",
                "changeAttributeOrder": "commercetools.schemas.ProductTypeChangeAttributeOrderActionSchema",
                "changeDescription": "commercetools.schemas.ProductTypeChangeDescriptionActionSchema",
                "changeEnumKey": "commercetools.schemas.ProductTypeChangeEnumKeyActionSchema",
                "changeInputHint": "commercetools.schemas.ProductTypeChangeInputHintActionSchema",
                "changeIsSearchable": "commercetools.schemas.ProductTypeChangeIsSearchableActionSchema",
                "changeLabel": "commercetools.schemas.ProductTypeChangeLabelActionSchema",
                "changeLocalizedEnumValueLabel": "commercetools.schemas.ProductTypeChangeLocalizedEnumValueLabelActionSchema",
                "changeLocalizedEnumValueOrder": "commercetools.schemas.ProductTypeChangeLocalizedEnumValueOrderActionSchema",
                "changeName": "commercetools.schemas.ProductTypeChangeNameActionSchema",
                "changePlainEnumValueLabel": "commercetools.schemas.ProductTypeChangePlainEnumValueLabelActionSchema",
                "changePlainEnumValueOrder": "commercetools.schemas.ProductTypeChangePlainEnumValueOrderActionSchema",
                "removeAttributeDefinition": "commercetools.schemas.ProductTypeRemoveAttributeDefinitionActionSchema",
                "removeEnumValues": "commercetools.schemas.ProductTypeRemoveEnumValuesActionSchema",
                "setInputTip": "commercetools.schemas.ProductTypeSetInputTipActionSchema",
                "setKey": "commercetools.schemas.ProductTypeSetKeyActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductTypeUpdate(**data)


class ProductUnpublishedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductUnpublishedMessagePayload`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductUnpublishedMessagePayload(**data)


class ProductUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductUpdateAction(**data)


class ProductUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addAsset": "commercetools.schemas.ProductAddAssetActionSchema",
                "addExternalImage": "commercetools.schemas.ProductAddExternalImageActionSchema",
                "addPrice": "commercetools.schemas.ProductAddPriceActionSchema",
                "addToCategory": "commercetools.schemas.ProductAddToCategoryActionSchema",
                "addVariant": "commercetools.schemas.ProductAddVariantActionSchema",
                "changeAssetName": "commercetools.schemas.ProductChangeAssetNameActionSchema",
                "changeAssetOrder": "commercetools.schemas.ProductChangeAssetOrderActionSchema",
                "changeMasterVariant": "commercetools.schemas.ProductChangeMasterVariantActionSchema",
                "changeName": "commercetools.schemas.ProductChangeNameActionSchema",
                "changePrice": "commercetools.schemas.ProductChangePriceActionSchema",
                "changeSlug": "commercetools.schemas.ProductChangeSlugActionSchema",
                "legacySetSku": "commercetools.schemas.ProductLegacySetSkuActionSchema",
                "moveImageToPosition": "commercetools.schemas.ProductMoveImageToPositionActionSchema",
                "publish": "commercetools.schemas.ProductPublishActionSchema",
                "removeAsset": "commercetools.schemas.ProductRemoveAssetActionSchema",
                "removeFromCategory": "commercetools.schemas.ProductRemoveFromCategoryActionSchema",
                "removeImage": "commercetools.schemas.ProductRemoveImageActionSchema",
                "removePrice": "commercetools.schemas.ProductRemovePriceActionSchema",
                "removeVariant": "commercetools.schemas.ProductRemoveVariantActionSchema",
                "revertStagedChanges": "commercetools.schemas.ProductRevertStagedChangesActionSchema",
                "revertStagedVariantChanges": "commercetools.schemas.ProductRevertStagedVariantChangesActionSchema",
                "setAssetCustomField": "commercetools.schemas.ProductSetAssetCustomFieldActionSchema",
                "setAssetCustomType": "commercetools.schemas.ProductSetAssetCustomTypeActionSchema",
                "setAssetDescription": "commercetools.schemas.ProductSetAssetDescriptionActionSchema",
                "setAssetKey": "commercetools.schemas.ProductSetAssetKeyActionSchema",
                "setAssetSources": "commercetools.schemas.ProductSetAssetSourcesActionSchema",
                "setAssetTags": "commercetools.schemas.ProductSetAssetTagsActionSchema",
                "setAttribute": "commercetools.schemas.ProductSetAttributeActionSchema",
                "setAttributeInAllVariants": "commercetools.schemas.ProductSetAttributeInAllVariantsActionSchema",
                "setCategoryOrderHint": "commercetools.schemas.ProductSetCategoryOrderHintActionSchema",
                "setDescription": "commercetools.schemas.ProductSetDescriptionActionSchema",
                "setDiscountedPrice": "commercetools.schemas.ProductSetDiscountedPriceActionSchema",
                "setImageLabel": "commercetools.schemas.ProductSetImageLabelActionSchema",
                "setKey": "commercetools.schemas.ProductSetKeyActionSchema",
                "setMetaDescription": "commercetools.schemas.ProductSetMetaDescriptionActionSchema",
                "setMetaKeywords": "commercetools.schemas.ProductSetMetaKeywordsActionSchema",
                "setMetaTitle": "commercetools.schemas.ProductSetMetaTitleActionSchema",
                "setPrices": "commercetools.schemas.ProductSetPricesActionSchema",
                "setProductPriceCustomField": "commercetools.schemas.ProductSetProductPriceCustomFieldActionSchema",
                "setProductPriceCustomType": "commercetools.schemas.ProductSetProductPriceCustomTypeActionSchema",
                "setProductVariantKey": "commercetools.schemas.ProductSetProductVariantKeyActionSchema",
                "setSearchKeywords": "commercetools.schemas.ProductSetSearchKeywordsActionSchema",
                "setSku": "commercetools.schemas.ProductSetSkuActionSchema",
                "setTaxCategory": "commercetools.schemas.ProductSetTaxCategoryActionSchema",
                "transitionState": "commercetools.schemas.ProductTransitionStateActionSchema",
                "unpublish": "commercetools.schemas.ProductUnpublishActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductUpdate(**data)


class ProductVariantDeletedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductVariantDeletedMessagePayload`."
    removed_image_urls = marshmallow.fields.List(
        marshmallow.fields.Nested(
            nested="commercetools.schemas.anySchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
        data_key="removedImageUrls",
    )
    variant = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductVariantSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductVariantDeletedMessagePayload(**data)


class ProjectUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProjectUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProjectUpdateAction(**data)


class ProjectUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.ProjectUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "changeCountries": "commercetools.schemas.ProjectChangeCountriesActionSchema",
                "changeCurrencies": "commercetools.schemas.ProjectChangeCurrenciesActionSchema",
                "changeLanguages": "commercetools.schemas.ProjectChangeLanguagesActionSchema",
                "changeMessagesConfiguration": "commercetools.schemas.ProjectChangeMessagesConfigurationActionSchema",
                "changeMessagesEnabled": "commercetools.schemas.ProjectChangeMessagesEnabledActionSchema",
                "changeName": "commercetools.schemas.ProjectChangeNameActionSchema",
                "setShippingRateInputType": "commercetools.schemas.ProjectSetShippingRateInputTypeActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProjectUpdate(**data)


class RangeFacetResultSchema(FacetResultSchema):
    "Marshmallow schema for :class:`commercetools.types.RangeFacetResult`."
    ranges = marshmallow.fields.Nested(
        nested="commercetools.schemas.FacetResultRangeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.RangeFacetResult(**data)


class ReferenceExistsErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.ReferenceExistsError`."
    referenced_by = marshmallow_enum.EnumField(
        types.ReferenceTypeId, by_value=True, missing=None, data_key="referencedBy"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.ReferenceExistsError(**data)


class ReferenceSchema(ResourceIdentifierSchema):
    "Marshmallow schema for :class:`commercetools.types.Reference`."
    type_id = marshmallow_enum.EnumField(
        types.ReferenceTypeId, by_value=True, missing=None, data_key="typeId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.Reference(**data)


class RequiredFieldErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.RequiredFieldError`."
    field = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.RequiredFieldError(**data)


class ResourceCreatedDeliverySchema(SubscriptionDeliverySchema):
    "Marshmallow schema for :class:`commercetools.types.ResourceCreatedDelivery`."
    version = marshmallow.fields.Integer(allow_none=True)
    modified_at = marshmallow.fields.DateTime(allow_none=True, data_key="modifiedAt")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["notification_type"]
        return types.ResourceCreatedDelivery(**data)


class ResourceDeletedDeliverySchema(SubscriptionDeliverySchema):
    "Marshmallow schema for :class:`commercetools.types.ResourceDeletedDelivery`."
    version = marshmallow.fields.Integer(allow_none=True)
    modified_at = marshmallow.fields.DateTime(allow_none=True, data_key="modifiedAt")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["notification_type"]
        return types.ResourceDeletedDelivery(**data)


class ResourceNotFoundErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.ResourceNotFoundError`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.ResourceNotFoundError(**data)


class ResourceUpdatedDeliverySchema(SubscriptionDeliverySchema):
    "Marshmallow schema for :class:`commercetools.types.ResourceUpdatedDelivery`."
    version = marshmallow.fields.Integer(allow_none=True)
    old_version = marshmallow.fields.Integer(allow_none=True, data_key="oldVersion")
    modified_at = marshmallow.fields.DateTime(allow_none=True, data_key="modifiedAt")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["notification_type"]
        return types.ResourceUpdatedDelivery(**data)


class ReviewCreatedMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewCreatedMessagePayload`."
    review = marshmallow.fields.Nested(
        nested="commercetools.schemas.ReviewSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ReviewCreatedMessagePayload(**data)


class ReviewPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.ReviewSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ReviewPagedQueryResponse(**data)


class ReviewRatingSetMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewRatingSetMessagePayload`."
    old_rating = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="oldRating"
    )
    new_rating = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="newRating"
    )
    included_in_statistics = marshmallow.fields.Bool(
        allow_none=True, data_key="includedInStatistics"
    )
    target = helpers.Discriminator(
        discriminator_field=("typeId", "type_id"),
        discriminator_schemas={
            "cart-discount": "commercetools.schemas.CartDiscountReferenceSchema",
            "cart": "commercetools.schemas.CartReferenceSchema",
            "category": "commercetools.schemas.CategoryReferenceSchema",
            "channel": "commercetools.schemas.ChannelReferenceSchema",
            "key-value-document": "commercetools.schemas.CustomObjectReferenceSchema",
            "customer-group": "commercetools.schemas.CustomerGroupReferenceSchema",
            "customer": "commercetools.schemas.CustomerReferenceSchema",
            "discount-code": "commercetools.schemas.DiscountCodeReferenceSchema",
            "inventory-entry": "commercetools.schemas.InventoryEntryReferenceSchema",
            "order-edit": "commercetools.schemas.OrderEditReferenceSchema",
            "order": "commercetools.schemas.OrderReferenceSchema",
            "payment": "commercetools.schemas.PaymentReferenceSchema",
            "product-discount": "commercetools.schemas.ProductDiscountReferenceSchema",
            "product-type": "commercetools.schemas.ProductTypeReferenceSchema",
            "product": "commercetools.schemas.ProductReferenceSchema",
            "review": "commercetools.schemas.ReviewReferenceSchema",
            "shipping-method": "commercetools.schemas.ShippingMethodReferenceSchema",
            "shopping-list": "commercetools.schemas.ShoppingListReferenceSchema",
            "state": "commercetools.schemas.StateReferenceSchema",
            "tax-category": "commercetools.schemas.TaxCategoryReferenceSchema",
            "type": "commercetools.schemas.TypeReferenceSchema",
            "zone": "commercetools.schemas.ZoneReferenceSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ReviewRatingSetMessagePayload(**data)


class ReviewSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Review`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    uniqueness_value = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="uniquenessValue"
    )
    locale = marshmallow.fields.String(allow_none=True, missing=None)
    author_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="authorName"
    )
    title = marshmallow.fields.String(allow_none=True, missing=None)
    text = marshmallow.fields.String(allow_none=True, missing=None)
    target = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    included_in_statistics = marshmallow.fields.Bool(
        allow_none=True, data_key="includedInStatistics"
    )
    rating = marshmallow.fields.Float(allow_none=True, missing=None)
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Review(**data)


class ReviewStateTransitionMessagePayloadSchema(MessagePayloadSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewStateTransitionMessagePayload`."
    old_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="oldState",
    )
    new_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="newState",
    )
    old_included_in_statistics = marshmallow.fields.Bool(
        allow_none=True, data_key="oldIncludedInStatistics"
    )
    new_included_in_statistics = marshmallow.fields.Bool(
        allow_none=True, data_key="newIncludedInStatistics"
    )
    target = helpers.Discriminator(
        discriminator_field=("typeId", "type_id"),
        discriminator_schemas={
            "cart-discount": "commercetools.schemas.CartDiscountReferenceSchema",
            "cart": "commercetools.schemas.CartReferenceSchema",
            "category": "commercetools.schemas.CategoryReferenceSchema",
            "channel": "commercetools.schemas.ChannelReferenceSchema",
            "key-value-document": "commercetools.schemas.CustomObjectReferenceSchema",
            "customer-group": "commercetools.schemas.CustomerGroupReferenceSchema",
            "customer": "commercetools.schemas.CustomerReferenceSchema",
            "discount-code": "commercetools.schemas.DiscountCodeReferenceSchema",
            "inventory-entry": "commercetools.schemas.InventoryEntryReferenceSchema",
            "order-edit": "commercetools.schemas.OrderEditReferenceSchema",
            "order": "commercetools.schemas.OrderReferenceSchema",
            "payment": "commercetools.schemas.PaymentReferenceSchema",
            "product-discount": "commercetools.schemas.ProductDiscountReferenceSchema",
            "product-type": "commercetools.schemas.ProductTypeReferenceSchema",
            "product": "commercetools.schemas.ProductReferenceSchema",
            "review": "commercetools.schemas.ReviewReferenceSchema",
            "shipping-method": "commercetools.schemas.ShippingMethodReferenceSchema",
            "shopping-list": "commercetools.schemas.ShoppingListReferenceSchema",
            "state": "commercetools.schemas.StateReferenceSchema",
            "tax-category": "commercetools.schemas.TaxCategoryReferenceSchema",
            "type": "commercetools.schemas.TypeReferenceSchema",
            "zone": "commercetools.schemas.ZoneReferenceSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    force = marshmallow.fields.Bool(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ReviewStateTransitionMessagePayload(**data)


class ReviewUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ReviewUpdateAction(**data)


class ReviewUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "setAuthorName": "commercetools.schemas.ReviewSetAuthorNameActionSchema",
                "setCustomField": "commercetools.schemas.ReviewSetCustomFieldActionSchema",
                "setCustomType": "commercetools.schemas.ReviewSetCustomTypeActionSchema",
                "setCustomer": "commercetools.schemas.ReviewSetCustomerActionSchema",
                "setKey": "commercetools.schemas.ReviewSetKeyActionSchema",
                "setLocale": "commercetools.schemas.ReviewSetLocaleActionSchema",
                "setRating": "commercetools.schemas.ReviewSetRatingActionSchema",
                "setTarget": "commercetools.schemas.ReviewSetTargetActionSchema",
                "setText": "commercetools.schemas.ReviewSetTextActionSchema",
                "setTitle": "commercetools.schemas.ReviewSetTitleActionSchema",
                "transitionState": "commercetools.schemas.ReviewTransitionStateActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ReviewUpdate(**data)


class ScoreShippingRateInputDraftSchema(ShippingRateInputDraftSchema):
    "Marshmallow schema for :class:`commercetools.types.ScoreShippingRateInputDraft`."
    score = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ScoreShippingRateInputDraft(**data)


class ScoreShippingRateInputSchema(ShippingRateInputSchema):
    "Marshmallow schema for :class:`commercetools.types.ScoreShippingRateInput`."
    score = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ScoreShippingRateInput(**data)


class ShippingMethodDoesNotMatchCartErrorSchema(ErrorObjectSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodDoesNotMatchCartError`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["code"]
        return types.ShippingMethodDoesNotMatchCartError(**data)


class ShippingMethodPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingMethodSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ShippingMethodPagedQueryResponse(**data)


class ShippingMethodSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethod`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    name = marshmallow.fields.String(allow_none=True)
    description = marshmallow.fields.String(allow_none=True, missing=None)
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="taxCategory",
    )
    zone_rates = marshmallow.fields.Nested(
        nested="commercetools.schemas.ZoneRateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="zoneRates",
    )
    is_default = marshmallow.fields.Bool(allow_none=True, data_key="isDefault")
    predicate = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ShippingMethod(**data)


class ShippingMethodUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShippingMethodUpdateAction(**data)


class ShippingMethodUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addShippingRate": "commercetools.schemas.ShippingMethodAddShippingRateActionSchema",
                "addZone": "commercetools.schemas.ShippingMethodAddZoneActionSchema",
                "changeIsDefault": "commercetools.schemas.ShippingMethodChangeIsDefaultActionSchema",
                "changeName": "commercetools.schemas.ShippingMethodChangeNameActionSchema",
                "changeTaxCategory": "commercetools.schemas.ShippingMethodChangeTaxCategoryActionSchema",
                "removeShippingRate": "commercetools.schemas.ShippingMethodRemoveShippingRateActionSchema",
                "removeZone": "commercetools.schemas.ShippingMethodRemoveZoneActionSchema",
                "setDescription": "commercetools.schemas.ShippingMethodSetDescriptionActionSchema",
                "setKey": "commercetools.schemas.ShippingMethodSetKeyActionSchema",
                "setPredicate": "commercetools.schemas.ShippingMethodSetPredicateActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ShippingMethodUpdate(**data)


class ShoppingListPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShoppingListSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ShoppingListPagedQueryResponse(**data)


class ShoppingListSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingList`."
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    delete_days_after_last_modification = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="deleteDaysAfterLastModification"
    )
    description = LocalizedStringField(allow_none=True, missing=None)
    key = marshmallow.fields.String(allow_none=True, missing=None)
    line_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShoppingListLineItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="lineItems",
    )
    name = LocalizedStringField(allow_none=True)
    slug = LocalizedStringField(allow_none=True, missing=None)
    text_line_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.TextLineItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="textLineItems",
    )
    anonymous_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="anonymousId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ShoppingList(**data)


class ShoppingListUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListUpdateAction(**data)


class ShoppingListUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addLineItem": "commercetools.schemas.ShoppingListAddLineItemActionSchema",
                "addTextLineItem": "commercetools.schemas.ShoppingListAddTextLineItemActionSchema",
                "changeLineItemQuantity": "commercetools.schemas.ShoppingListChangeLineItemQuantityActionSchema",
                "changeLineItemsOrder": "commercetools.schemas.ShoppingListChangeLineItemsOrderActionSchema",
                "changeName": "commercetools.schemas.ShoppingListChangeNameActionSchema",
                "changeTextLineItemName": "commercetools.schemas.ShoppingListChangeTextLineItemNameActionSchema",
                "changeTextLineItemQuantity": "commercetools.schemas.ShoppingListChangeTextLineItemQuantityActionSchema",
                "changeTextLineItemsOrder": "commercetools.schemas.ShoppingListChangeTextLineItemsOrderActionSchema",
                "removeLineItem": "commercetools.schemas.ShoppingListRemoveLineItemActionSchema",
                "removeTextLineItem": "commercetools.schemas.ShoppingListRemoveTextLineItemActionSchema",
                "setAnonymousId": "commercetools.schemas.ShoppingListSetAnonymousIdActionSchema",
                "setCustomField": "commercetools.schemas.ShoppingListSetCustomFieldActionSchema",
                "setCustomType": "commercetools.schemas.ShoppingListSetCustomTypeActionSchema",
                "setCustomer": "commercetools.schemas.ShoppingListSetCustomerActionSchema",
                "setDeleteDaysAfterLastModification": "commercetools.schemas.ShoppingListSetDeleteDaysAfterLastModificationActionSchema",
                "setDescription": "commercetools.schemas.ShoppingListSetDescriptionActionSchema",
                "setKey": "commercetools.schemas.ShoppingListSetKeyActionSchema",
                "setLineItemCustomField": "commercetools.schemas.ShoppingListSetLineItemCustomFieldActionSchema",
                "setLineItemCustomType": "commercetools.schemas.ShoppingListSetLineItemCustomTypeActionSchema",
                "setSlug": "commercetools.schemas.ShoppingListSetSlugActionSchema",
                "setTextLineItemCustomField": "commercetools.schemas.ShoppingListSetTextLineItemCustomFieldActionSchema",
                "setTextLineItemCustomType": "commercetools.schemas.ShoppingListSetTextLineItemCustomTypeActionSchema",
                "setTextLineItemDescription": "commercetools.schemas.ShoppingListSetTextLineItemDescriptionActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ShoppingListUpdate(**data)


class SnsDestinationSchema(DestinationSchema):
    "Marshmallow schema for :class:`commercetools.types.SnsDestination`."
    access_key = marshmallow.fields.String(allow_none=True, data_key="accessKey")
    access_secret = marshmallow.fields.String(allow_none=True, data_key="accessSecret")
    topic_arn = marshmallow.fields.String(allow_none=True, data_key="topicArn")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.SnsDestination(**data)


class SqsDestinationSchema(DestinationSchema):
    "Marshmallow schema for :class:`commercetools.types.SqsDestination`."
    access_key = marshmallow.fields.String(allow_none=True, data_key="accessKey")
    access_secret = marshmallow.fields.String(allow_none=True, data_key="accessSecret")
    queue_url = marshmallow.fields.String(allow_none=True, data_key="queueUrl")
    region = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.SqsDestination(**data)


class StagedOrderAddCustomLineItemActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderAddCustomLineItemAction`."
    money = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    name = LocalizedStringField(allow_none=True)
    quantity = marshmallow.fields.Integer(allow_none=True, missing=None)
    slug = marshmallow.fields.String(allow_none=True)
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderAddCustomLineItemAction(**data)


class StagedOrderAddDeliveryActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderAddDeliveryAction`."
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    parcels = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderAddDeliveryAction(**data)


class StagedOrderAddDiscountCodeActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderAddDiscountCodeAction`."
    code = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderAddDiscountCodeAction(**data)


class StagedOrderAddItemShippingAddressActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderAddItemShippingAddressAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderAddItemShippingAddressAction(**data)


class StagedOrderAddLineItemActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderAddLineItemAction`."
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    distribution_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="distributionChannel",
    )
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )
    product_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="productId"
    )
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    quantity = marshmallow.fields.Integer(allow_none=True, missing=None)
    supply_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="supplyChannel",
    )
    external_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalPrice",
    )
    external_total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalLineItemTotalPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTotalPrice",
    )
    shipping_details = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetails",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderAddLineItemAction(**data)


class StagedOrderAddParcelToDeliveryActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderAddParcelToDeliveryAction`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    measurements = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelMeasurementsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    tracking_data = marshmallow.fields.Nested(
        nested="commercetools.schemas.TrackingDataSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="trackingData",
    )
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderAddParcelToDeliveryAction(**data)


class StagedOrderAddPaymentActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderAddPaymentAction`."
    payment = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderAddPaymentAction(**data)


class StagedOrderAddReturnInfoActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderAddReturnInfoAction`."
    return_tracking_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="returnTrackingId"
    )
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.ReturnItemDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    return_date = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="returnDate"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderAddReturnInfoAction(**data)


class StagedOrderAddShoppingListActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderAddShoppingListAction`."
    shopping_list = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShoppingListReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="shoppingList",
    )
    supply_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="supplyChannel",
    )
    distribution_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="distributionChannel",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderAddShoppingListAction(**data)


class StagedOrderChangeCustomLineItemMoneyActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderChangeCustomLineItemMoneyAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    money = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderChangeCustomLineItemMoneyAction(**data)


class StagedOrderChangeCustomLineItemQuantityActionSchema(
    StagedOrderUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderChangeCustomLineItemQuantityAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    quantity = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderChangeCustomLineItemQuantityAction(**data)


class StagedOrderChangeLineItemQuantityActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderChangeLineItemQuantityAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    quantity = marshmallow.fields.Integer(allow_none=True)
    external_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalPrice",
    )
    external_total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalLineItemTotalPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTotalPrice",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderChangeLineItemQuantityAction(**data)


class StagedOrderChangeOrderStateActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderChangeOrderStateAction`."
    order_state = marshmallow_enum.EnumField(
        types.OrderState, by_value=True, data_key="orderState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderChangeOrderStateAction(**data)


class StagedOrderChangePaymentStateActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderChangePaymentStateAction`."
    payment_state = marshmallow_enum.EnumField(
        types.PaymentState, by_value=True, missing=None, data_key="paymentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderChangePaymentStateAction(**data)


class StagedOrderChangeShipmentStateActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderChangeShipmentStateAction`."
    shipment_state = marshmallow_enum.EnumField(
        types.ShipmentState, by_value=True, missing=None, data_key="shipmentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderChangeShipmentStateAction(**data)


class StagedOrderChangeTaxCalculationModeActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderChangeTaxCalculationModeAction`."
    tax_calculation_mode = marshmallow_enum.EnumField(
        types.TaxCalculationMode, by_value=True, data_key="taxCalculationMode"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderChangeTaxCalculationModeAction(**data)


class StagedOrderChangeTaxModeActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderChangeTaxModeAction`."
    tax_mode = marshmallow_enum.EnumField(
        types.TaxMode, by_value=True, data_key="taxMode"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderChangeTaxModeAction(**data)


class StagedOrderChangeTaxRoundingModeActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderChangeTaxRoundingModeAction`."
    tax_rounding_mode = marshmallow_enum.EnumField(
        types.RoundingMode, by_value=True, data_key="taxRoundingMode"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderChangeTaxRoundingModeAction(**data)


class StagedOrderImportCustomLineItemStateActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderImportCustomLineItemStateAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemStateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderImportCustomLineItemStateAction(**data)


class StagedOrderImportLineItemStateActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderImportLineItemStateAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemStateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderImportLineItemStateAction(**data)


class StagedOrderRemoveCustomLineItemActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderRemoveCustomLineItemAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderRemoveCustomLineItemAction(**data)


class StagedOrderRemoveDeliveryActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderRemoveDeliveryAction`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderRemoveDeliveryAction(**data)


class StagedOrderRemoveDiscountCodeActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderRemoveDiscountCodeAction`."
    discount_code = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountCodeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="discountCode",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderRemoveDiscountCodeAction(**data)


class StagedOrderRemoveItemShippingAddressActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderRemoveItemShippingAddressAction`."
    address_key = marshmallow.fields.String(allow_none=True, data_key="addressKey")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderRemoveItemShippingAddressAction(**data)


class StagedOrderRemoveLineItemActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderRemoveLineItemAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    quantity = marshmallow.fields.Integer(allow_none=True, missing=None)
    external_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalPrice",
    )
    external_total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalLineItemTotalPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTotalPrice",
    )
    shipping_details_to_remove = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetailsToRemove",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderRemoveLineItemAction(**data)


class StagedOrderRemoveParcelFromDeliveryActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderRemoveParcelFromDeliveryAction`."
    parcel_id = marshmallow.fields.String(allow_none=True, data_key="parcelId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderRemoveParcelFromDeliveryAction(**data)


class StagedOrderRemovePaymentActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderRemovePaymentAction`."
    payment = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderRemovePaymentAction(**data)


class StagedOrderSetBillingAddressActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetBillingAddressAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetBillingAddressAction(**data)


class StagedOrderSetCountryActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetCountryAction`."
    country = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetCountryAction(**data)


class StagedOrderSetCustomFieldActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetCustomFieldAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetCustomFieldAction(**data)


class StagedOrderSetCustomLineItemCustomFieldActionSchema(
    StagedOrderUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetCustomLineItemCustomFieldAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetCustomLineItemCustomFieldAction(**data)


class StagedOrderSetCustomLineItemCustomTypeActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetCustomLineItemCustomTypeAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetCustomLineItemCustomTypeAction(**data)


class StagedOrderSetCustomLineItemShippingDetailsActionSchema(
    StagedOrderUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetCustomLineItemShippingDetailsAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    shipping_details = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetails",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetCustomLineItemShippingDetailsAction(**data)


class StagedOrderSetCustomLineItemTaxAmountActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetCustomLineItemTaxAmountAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    external_tax_amount = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxAmountDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxAmount",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetCustomLineItemTaxAmountAction(**data)


class StagedOrderSetCustomLineItemTaxRateActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetCustomLineItemTaxRateAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetCustomLineItemTaxRateAction(**data)


class StagedOrderSetCustomShippingMethodActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetCustomShippingMethodAction`."
    shipping_method_name = marshmallow.fields.String(
        allow_none=True, data_key="shippingMethodName"
    )
    shipping_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="shippingRate",
    )
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetCustomShippingMethodAction(**data)


class StagedOrderSetCustomTypeActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetCustomTypeAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetCustomTypeAction(**data)


class StagedOrderSetCustomerEmailActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetCustomerEmailAction`."
    email = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetCustomerEmailAction(**data)


class StagedOrderSetCustomerGroupActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetCustomerGroupAction`."
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="customerGroup",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetCustomerGroupAction(**data)


class StagedOrderSetCustomerIdActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetCustomerIdAction`."
    customer_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetCustomerIdAction(**data)


class StagedOrderSetDeliveryAddressActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetDeliveryAddressAction`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetDeliveryAddressAction(**data)


class StagedOrderSetDeliveryItemsActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetDeliveryItemsAction`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetDeliveryItemsAction(**data)


class StagedOrderSetLineItemCustomFieldActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetLineItemCustomFieldAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetLineItemCustomFieldAction(**data)


class StagedOrderSetLineItemCustomTypeActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetLineItemCustomTypeAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetLineItemCustomTypeAction(**data)


class StagedOrderSetLineItemPriceActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetLineItemPriceAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    external_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalPrice",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetLineItemPriceAction(**data)


class StagedOrderSetLineItemShippingDetailsActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetLineItemShippingDetailsAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    shipping_details = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetails",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetLineItemShippingDetailsAction(**data)


class StagedOrderSetLineItemTaxAmountActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetLineItemTaxAmountAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    external_tax_amount = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxAmountDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxAmount",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetLineItemTaxAmountAction(**data)


class StagedOrderSetLineItemTaxRateActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetLineItemTaxRateAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetLineItemTaxRateAction(**data)


class StagedOrderSetLineItemTotalPriceActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetLineItemTotalPriceAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    external_total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalLineItemTotalPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTotalPrice",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetLineItemTotalPriceAction(**data)


class StagedOrderSetLocaleActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetLocaleAction`."
    locale = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetLocaleAction(**data)


class StagedOrderSetOrderNumberActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetOrderNumberAction`."
    order_number = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="orderNumber"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetOrderNumberAction(**data)


class StagedOrderSetOrderTotalTaxActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetOrderTotalTaxAction`."
    external_total_gross = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="externalTotalGross",
    )
    external_tax_portions = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxPortionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="externalTaxPortions",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetOrderTotalTaxAction(**data)


class StagedOrderSetParcelItemsActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetParcelItemsAction`."
    parcel_id = marshmallow.fields.String(allow_none=True, data_key="parcelId")
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetParcelItemsAction(**data)


class StagedOrderSetParcelMeasurementsActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetParcelMeasurementsAction`."
    parcel_id = marshmallow.fields.String(allow_none=True, data_key="parcelId")
    measurements = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelMeasurementsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetParcelMeasurementsAction(**data)


class StagedOrderSetParcelTrackingDataActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetParcelTrackingDataAction`."
    parcel_id = marshmallow.fields.String(allow_none=True, data_key="parcelId")
    tracking_data = marshmallow.fields.Nested(
        nested="commercetools.schemas.TrackingDataSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="trackingData",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetParcelTrackingDataAction(**data)


class StagedOrderSetReturnPaymentStateActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetReturnPaymentStateAction`."
    return_item_id = marshmallow.fields.String(allow_none=True, data_key="returnItemId")
    payment_state = marshmallow_enum.EnumField(
        types.ReturnPaymentState, by_value=True, data_key="paymentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetReturnPaymentStateAction(**data)


class StagedOrderSetReturnShipmentStateActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetReturnShipmentStateAction`."
    return_item_id = marshmallow.fields.String(allow_none=True, data_key="returnItemId")
    shipment_state = marshmallow_enum.EnumField(
        types.ReturnShipmentState, by_value=True, data_key="shipmentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetReturnShipmentStateAction(**data)


class StagedOrderSetShippingAddressActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetShippingAddressAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetShippingAddressAction(**data)


class StagedOrderSetShippingAddressAndCustomShippingMethodActionSchema(
    StagedOrderUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetShippingAddressAndCustomShippingMethodAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    shipping_method_name = marshmallow.fields.String(
        allow_none=True, data_key="shippingMethodName"
    )
    shipping_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="shippingRate",
    )
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetShippingAddressAndCustomShippingMethodAction(**data)


class StagedOrderSetShippingAddressAndShippingMethodActionSchema(
    StagedOrderUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetShippingAddressAndShippingMethodAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    shipping_method = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingMethodReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingMethod",
    )
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetShippingAddressAndShippingMethodAction(**data)


class StagedOrderSetShippingMethodActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetShippingMethodAction`."
    shipping_method = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingMethod",
    )
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetShippingMethodAction(**data)


class StagedOrderSetShippingMethodTaxAmountActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetShippingMethodTaxAmountAction`."
    external_tax_amount = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxAmountDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxAmount",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetShippingMethodTaxAmountAction(**data)


class StagedOrderSetShippingMethodTaxRateActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetShippingMethodTaxRateAction`."
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetShippingMethodTaxRateAction(**data)


class StagedOrderSetShippingRateInputActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderSetShippingRateInputAction`."
    shipping_rate_input = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "Classification": "commercetools.schemas.ClassificationShippingRateInputDraftSchema",
            "Score": "commercetools.schemas.ScoreShippingRateInputDraftSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingRateInput",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderSetShippingRateInputAction(**data)


class StagedOrderTransitionCustomLineItemStateActionSchema(
    StagedOrderUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderTransitionCustomLineItemStateAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    quantity = marshmallow.fields.Integer(allow_none=True)
    from_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="fromState",
    )
    to_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="toState",
    )
    actual_transition_date = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="actualTransitionDate"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderTransitionCustomLineItemStateAction(**data)


class StagedOrderTransitionLineItemStateActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderTransitionLineItemStateAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    quantity = marshmallow.fields.Integer(allow_none=True)
    from_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="fromState",
    )
    to_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="toState",
    )
    actual_transition_date = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="actualTransitionDate"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderTransitionLineItemStateAction(**data)


class StagedOrderTransitionStateActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderTransitionStateAction`."
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    force = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderTransitionStateAction(**data)


class StagedOrderUpdateItemShippingAddressActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderUpdateItemShippingAddressAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderUpdateItemShippingAddressAction(**data)


class StagedOrderUpdateSyncInfoActionSchema(StagedOrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrderUpdateSyncInfoAction`."
    channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    external_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="externalId"
    )
    synced_at = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="syncedAt"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StagedOrderUpdateSyncInfoAction(**data)


class StatePagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.StatePagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.StatePagedQueryResponse(**data)


class StateSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.State`."
    key = marshmallow.fields.String(allow_none=True)
    type = marshmallow_enum.EnumField(types.StateTypeEnum, by_value=True)
    name = LocalizedStringField(allow_none=True, missing=None)
    description = LocalizedStringField(allow_none=True, missing=None)
    initial = marshmallow.fields.Bool(allow_none=True)
    built_in = marshmallow.fields.Bool(allow_none=True, data_key="builtIn")
    roles = marshmallow.fields.List(
        marshmallow_enum.EnumField(types.StateRoleEnum, by_value=True), missing=None
    )
    transitions = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.State(**data)


class StateUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StateUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StateUpdateAction(**data)


class StateUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.StateUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addRoles": "commercetools.schemas.StateAddRolesActionSchema",
                "changeInitial": "commercetools.schemas.StateChangeInitialActionSchema",
                "changeKey": "commercetools.schemas.StateChangeKeyActionSchema",
                "changeType": "commercetools.schemas.StateChangeTypeActionSchema",
                "removeRoles": "commercetools.schemas.StateRemoveRolesActionSchema",
                "setDescription": "commercetools.schemas.StateSetDescriptionActionSchema",
                "setName": "commercetools.schemas.StateSetNameActionSchema",
                "setRoles": "commercetools.schemas.StateSetRolesActionSchema",
                "setTransitions": "commercetools.schemas.StateSetTransitionsActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.StateUpdate(**data)


class SubscriptionPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.SubscriptionPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.SubscriptionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.SubscriptionPagedQueryResponse(**data)


class SubscriptionSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Subscription`."
    changes = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChangeSubscriptionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    destination = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "EventGrid": "commercetools.schemas.AzureEventGridDestinationSchema",
            "AzureServiceBus": "commercetools.schemas.AzureServiceBusDestinationSchema",
            "GoogleCloudPubSub": "commercetools.schemas.GoogleCloudPubSubDestinationSchema",
            "IronMQ": "commercetools.schemas.IronMqDestinationSchema",
            "SNS": "commercetools.schemas.SnsDestinationSchema",
            "SQS": "commercetools.schemas.SqsDestinationSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    key = marshmallow.fields.String(allow_none=True, missing=None)
    messages = marshmallow.fields.Nested(
        nested="commercetools.schemas.MessageSubscriptionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    format = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "CloudEvents": "commercetools.schemas.DeliveryCloudEventsFormatSchema",
            "Platform": "commercetools.schemas.DeliveryPlatformFormatSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Subscription(**data)


class SubscriptionUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.SubscriptionUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.SubscriptionUpdateAction(**data)


class SubscriptionUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.SubscriptionUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "changeDestination": "commercetools.schemas.SubscriptionChangeDestinationActionSchema",
                "setChanges": "commercetools.schemas.SubscriptionSetChangesActionSchema",
                "setKey": "commercetools.schemas.SubscriptionSetKeyActionSchema",
                "setMessages": "commercetools.schemas.SubscriptionSetMessagesActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.SubscriptionUpdate(**data)


class TaxCategoryPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.TaxCategoryPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategorySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TaxCategoryPagedQueryResponse(**data)


class TaxCategorySchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.TaxCategory`."
    name = marshmallow.fields.String(allow_none=True)
    description = marshmallow.fields.String(allow_none=True, missing=None)
    rates = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxRateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TaxCategory(**data)


class TaxCategoryUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TaxCategoryUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TaxCategoryUpdateAction(**data)


class TaxCategoryUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.TaxCategoryUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addTaxRate": "commercetools.schemas.TaxCategoryAddTaxRateActionSchema",
                "changeName": "commercetools.schemas.TaxCategoryChangeNameActionSchema",
                "removeTaxRate": "commercetools.schemas.TaxCategoryRemoveTaxRateActionSchema",
                "replaceTaxRate": "commercetools.schemas.TaxCategoryReplaceTaxRateActionSchema",
                "setDescription": "commercetools.schemas.TaxCategorySetDescriptionActionSchema",
                "setKey": "commercetools.schemas.TaxCategorySetKeyActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TaxCategoryUpdate(**data)


class TermFacetResultSchema(FacetResultSchema):
    "Marshmallow schema for :class:`commercetools.types.TermFacetResult`."
    data_type = marshmallow_enum.EnumField(
        types.TermFacetResultType, by_value=True, data_key="dataType"
    )
    missing = marshmallow.fields.Integer(allow_none=True)
    total = marshmallow.fields.Integer(allow_none=True)
    other = marshmallow.fields.Integer(allow_none=True)
    terms = marshmallow.fields.Nested(
        nested="commercetools.schemas.FacetResultTermSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.TermFacetResult(**data)


class TypePagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.TypePagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TypePagedQueryResponse(**data)


class TypeSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Type`."
    key = marshmallow.fields.String(allow_none=True)
    name = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    resource_type_ids = marshmallow.fields.List(
        marshmallow_enum.EnumField(types.ResourceTypeId, by_value=True),
        data_key="resourceTypeIds",
    )
    field_definitions = marshmallow.fields.Nested(
        nested="commercetools.schemas.FieldDefinitionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="fieldDefinitions",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Type(**data)


class TypeUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TypeUpdateAction(**data)


class TypeUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addEnumValue": "commercetools.schemas.TypeAddEnumValueActionSchema",
                "addFieldDefinition": "commercetools.schemas.TypeAddFieldDefinitionActionSchema",
                "addLocalizedEnumValue": "commercetools.schemas.TypeAddLocalizedEnumValueActionSchema",
                "changeEnumValueOrder": "commercetools.schemas.TypeChangeEnumValueOrderActionSchema",
                "changeFieldDefinitionLabel": "commercetools.schemas.TypeChangeFieldDefinitionLabelActionSchema",
                "changeFieldDefinitionOrder": "commercetools.schemas.TypeChangeFieldDefinitionOrderActionSchema",
                "changeKey": "commercetools.schemas.TypeChangeKeyActionSchema",
                "changeLabel": "commercetools.schemas.TypeChangeLabelActionSchema",
                "changeLocalizedEnumValueOrder": "commercetools.schemas.TypeChangeLocalizedEnumValueOrderActionSchema",
                "changeName": "commercetools.schemas.TypeChangeNameActionSchema",
                "removeFieldDefinition": "commercetools.schemas.TypeRemoveFieldDefinitionActionSchema",
                "setDescription": "commercetools.schemas.TypeSetDescriptionActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.TypeUpdate(**data)


class TypedMoneySchema(MoneySchema):
    "Marshmallow schema for :class:`commercetools.types.TypedMoney`."
    type = marshmallow_enum.EnumField(types.MoneyType, by_value=True)
    fraction_digits = marshmallow.fields.Integer(
        allow_none=True, data_key="fractionDigits"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.TypedMoney(**data)


class WhitespaceTokenizerSchema(SuggestTokenizerSchema):
    "Marshmallow schema for :class:`commercetools.types.WhitespaceTokenizer`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.WhitespaceTokenizer(**data)


class ZonePagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ZonePagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas.ZoneSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ZonePagedQueryResponse(**data)


class ZoneSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Zone`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    name = marshmallow.fields.String(allow_none=True)
    description = marshmallow.fields.String(allow_none=True, missing=None)
    locations = marshmallow.fields.Nested(
        nested="commercetools.schemas.LocationSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Zone(**data)


class ZoneUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ZoneUpdateAction(**data)


class ZoneUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addLocation": "commercetools.schemas.ZoneAddLocationActionSchema",
                "changeName": "commercetools.schemas.ZoneChangeNameActionSchema",
                "removeLocation": "commercetools.schemas.ZoneRemoveLocationActionSchema",
                "setDescription": "commercetools.schemas.ZoneSetDescriptionActionSchema",
                "setKey": "commercetools.schemas.ZoneSetKeyActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ZoneUpdate(**data)


class CartAddCustomLineItemActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartAddCustomLineItemAction`."
    money = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    name = LocalizedStringField(allow_none=True)
    quantity = marshmallow.fields.Integer(allow_none=True)
    slug = marshmallow.fields.String(allow_none=True)
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartAddCustomLineItemAction(**data)


class CartAddDiscountCodeActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartAddDiscountCodeAction`."
    code = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartAddDiscountCodeAction(**data)


class CartAddItemShippingAddressActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartAddItemShippingAddressAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartAddItemShippingAddressAction(**data)


class CartAddLineItemActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartAddLineItemAction`."
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    distribution_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="distributionChannel",
    )
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )
    product_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="productId"
    )
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    quantity = marshmallow.fields.Integer(allow_none=True, missing=None)
    supply_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="supplyChannel",
    )
    external_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalPrice",
    )
    external_total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalLineItemTotalPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTotalPrice",
    )
    shipping_details = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetails",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartAddLineItemAction(**data)


class CartAddPaymentActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartAddPaymentAction`."
    payment = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartAddPaymentAction(**data)


class CartAddShoppingListActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartAddShoppingListAction`."
    shopping_list = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShoppingListReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="shoppingList",
    )
    supply_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="supplyChannel",
    )
    distribution_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="distributionChannel",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartAddShoppingListAction(**data)


class CartApplyDeltaToCustomLineItemShippingDetailsTargetsActionSchema(
    CartUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.CartApplyDeltaToCustomLineItemShippingDetailsTargetsAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    targets_delta = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingTargetSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="targetsDelta",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartApplyDeltaToCustomLineItemShippingDetailsTargetsAction(**data)


class CartApplyDeltaToLineItemShippingDetailsTargetsActionSchema(
    CartUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.CartApplyDeltaToLineItemShippingDetailsTargetsAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    targets_delta = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingTargetSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="targetsDelta",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartApplyDeltaToLineItemShippingDetailsTargetsAction(**data)


class CartChangeCustomLineItemMoneyActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartChangeCustomLineItemMoneyAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    money = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartChangeCustomLineItemMoneyAction(**data)


class CartChangeCustomLineItemQuantityActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartChangeCustomLineItemQuantityAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    quantity = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartChangeCustomLineItemQuantityAction(**data)


class CartChangeLineItemQuantityActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartChangeLineItemQuantityAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    quantity = marshmallow.fields.Integer(allow_none=True)
    external_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalPrice",
    )
    external_total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalLineItemTotalPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTotalPrice",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartChangeLineItemQuantityAction(**data)


class CartChangeTaxCalculationModeActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartChangeTaxCalculationModeAction`."
    tax_calculation_mode = marshmallow_enum.EnumField(
        types.TaxCalculationMode, by_value=True, data_key="taxCalculationMode"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartChangeTaxCalculationModeAction(**data)


class CartChangeTaxModeActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartChangeTaxModeAction`."
    tax_mode = marshmallow_enum.EnumField(
        types.TaxMode, by_value=True, data_key="taxMode"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartChangeTaxModeAction(**data)


class CartChangeTaxRoundingModeActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartChangeTaxRoundingModeAction`."
    tax_rounding_mode = marshmallow_enum.EnumField(
        types.RoundingMode, by_value=True, data_key="taxRoundingMode"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartChangeTaxRoundingModeAction(**data)


class CartDiscountChangeCartPredicateActionSchema(CartDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountChangeCartPredicateAction`."
    cart_predicate = marshmallow.fields.String(
        allow_none=True, data_key="cartPredicate"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountChangeCartPredicateAction(**data)


class CartDiscountChangeIsActiveActionSchema(CartDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountChangeIsActiveAction`."
    is_active = marshmallow.fields.Bool(allow_none=True, data_key="isActive")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountChangeIsActiveAction(**data)


class CartDiscountChangeNameActionSchema(CartDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountChangeNameAction`."
    name = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountChangeNameAction(**data)


class CartDiscountChangeRequiresDiscountCodeActionSchema(
    CartDiscountUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountChangeRequiresDiscountCodeAction`."
    requires_discount_code = marshmallow.fields.Bool(
        allow_none=True, data_key="requiresDiscountCode"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountChangeRequiresDiscountCodeAction(**data)


class CartDiscountChangeSortOrderActionSchema(CartDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountChangeSortOrderAction`."
    sort_order = marshmallow.fields.String(allow_none=True, data_key="sortOrder")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountChangeSortOrderAction(**data)


class CartDiscountChangeStackingModeActionSchema(CartDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountChangeStackingModeAction`."
    stacking_mode = marshmallow_enum.EnumField(
        types.StackingMode, by_value=True, data_key="stackingMode"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountChangeStackingModeAction(**data)


class CartDiscountChangeTargetActionSchema(CartDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountChangeTargetAction`."
    target = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "customLineItems": "commercetools.schemas.CartDiscountCustomLineItemsTargetSchema",
            "lineItems": "commercetools.schemas.CartDiscountLineItemsTargetSchema",
            "shipping": "commercetools.schemas.CartDiscountShippingCostTargetSchema",
            "multiBuyCustomLineItems": "commercetools.schemas.MultiBuyCustomLineItemsTargetSchema",
            "multiBuyLineItems": "commercetools.schemas.MultiBuyLineItemsTargetSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountChangeTargetAction(**data)


class CartDiscountChangeValueActionSchema(CartDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountChangeValueAction`."
    value = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "absolute": "commercetools.schemas.CartDiscountValueAbsoluteSchema",
            "giftLineItem": "commercetools.schemas.CartDiscountValueGiftLineItemSchema",
            "relative": "commercetools.schemas.CartDiscountValueRelativeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountChangeValueAction(**data)


class CartDiscountReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.CartDiscountSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.CartDiscountReference(**data)


class CartDiscountSetCustomFieldActionSchema(CartDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountSetCustomFieldAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountSetCustomFieldAction(**data)


class CartDiscountSetCustomTypeActionSchema(CartDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountSetCustomTypeAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = marshmallow.fields.Dict(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountSetCustomTypeAction(**data)


class CartDiscountSetDescriptionActionSchema(CartDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountSetDescriptionAction`."
    description = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountSetDescriptionAction(**data)


class CartDiscountSetValidFromActionSchema(CartDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountSetValidFromAction`."
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountSetValidFromAction(**data)


class CartDiscountSetValidFromAndUntilActionSchema(CartDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountSetValidFromAndUntilAction`."
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountSetValidFromAndUntilAction(**data)


class CartDiscountSetValidUntilActionSchema(CartDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartDiscountSetValidUntilAction`."
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartDiscountSetValidUntilAction(**data)


class CartRecalculateActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartRecalculateAction`."
    update_product_data = marshmallow.fields.Bool(
        allow_none=True, missing=None, data_key="updateProductData"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartRecalculateAction(**data)


class CartReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.CartReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.CartSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.CartReference(**data)


class CartRemoveCustomLineItemActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartRemoveCustomLineItemAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartRemoveCustomLineItemAction(**data)


class CartRemoveDiscountCodeActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartRemoveDiscountCodeAction`."
    discount_code = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountCodeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="discountCode",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartRemoveDiscountCodeAction(**data)


class CartRemoveItemShippingAddressActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartRemoveItemShippingAddressAction`."
    address_key = marshmallow.fields.String(allow_none=True, data_key="addressKey")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartRemoveItemShippingAddressAction(**data)


class CartRemoveLineItemActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartRemoveLineItemAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    quantity = marshmallow.fields.Integer(allow_none=True, missing=None)
    external_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalPrice",
    )
    external_total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalLineItemTotalPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTotalPrice",
    )
    shipping_details_to_remove = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetailsToRemove",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartRemoveLineItemAction(**data)


class CartRemovePaymentActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartRemovePaymentAction`."
    payment = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartRemovePaymentAction(**data)


class CartSetAnonymousIdActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetAnonymousIdAction`."
    anonymous_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="anonymousId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetAnonymousIdAction(**data)


class CartSetBillingAddressActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetBillingAddressAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetBillingAddressAction(**data)


class CartSetCartTotalTaxActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetCartTotalTaxAction`."
    external_total_gross = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="externalTotalGross",
    )
    external_tax_portions = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxPortionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
        data_key="externalTaxPortions",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetCartTotalTaxAction(**data)


class CartSetCountryActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetCountryAction`."
    country = marshmallow.fields.String(missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetCountryAction(**data)


class CartSetCustomFieldActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetCustomFieldAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetCustomFieldAction(**data)


class CartSetCustomLineItemCustomFieldActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetCustomLineItemCustomFieldAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetCustomLineItemCustomFieldAction(**data)


class CartSetCustomLineItemCustomTypeActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetCustomLineItemCustomTypeAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetCustomLineItemCustomTypeAction(**data)


class CartSetCustomLineItemShippingDetailsActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetCustomLineItemShippingDetailsAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    shipping_details = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetails",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetCustomLineItemShippingDetailsAction(**data)


class CartSetCustomLineItemTaxAmountActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetCustomLineItemTaxAmountAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    external_tax_amount = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxAmountDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxAmount",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetCustomLineItemTaxAmountAction(**data)


class CartSetCustomLineItemTaxRateActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetCustomLineItemTaxRateAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetCustomLineItemTaxRateAction(**data)


class CartSetCustomShippingMethodActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetCustomShippingMethodAction`."
    shipping_method_name = marshmallow.fields.String(
        allow_none=True, data_key="shippingMethodName"
    )
    shipping_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="shippingRate",
    )
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetCustomShippingMethodAction(**data)


class CartSetCustomTypeActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetCustomTypeAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetCustomTypeAction(**data)


class CartSetCustomerEmailActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetCustomerEmailAction`."
    email = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetCustomerEmailAction(**data)


class CartSetCustomerGroupActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetCustomerGroupAction`."
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="customerGroup",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetCustomerGroupAction(**data)


class CartSetCustomerIdActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetCustomerIdAction`."
    customer_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetCustomerIdAction(**data)


class CartSetDeleteDaysAfterLastModificationActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetDeleteDaysAfterLastModificationAction`."
    delete_days_after_last_modification = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="deleteDaysAfterLastModification"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetDeleteDaysAfterLastModificationAction(**data)


class CartSetLineItemCustomFieldActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetLineItemCustomFieldAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetLineItemCustomFieldAction(**data)


class CartSetLineItemCustomTypeActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetLineItemCustomTypeAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetLineItemCustomTypeAction(**data)


class CartSetLineItemPriceActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetLineItemPriceAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    external_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalPrice",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetLineItemPriceAction(**data)


class CartSetLineItemShippingDetailsActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetLineItemShippingDetailsAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    shipping_details = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetails",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetLineItemShippingDetailsAction(**data)


class CartSetLineItemTaxAmountActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetLineItemTaxAmountAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    external_tax_amount = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxAmountDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxAmount",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetLineItemTaxAmountAction(**data)


class CartSetLineItemTaxRateActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetLineItemTaxRateAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetLineItemTaxRateAction(**data)


class CartSetLineItemTotalPriceActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetLineItemTotalPriceAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    external_total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalLineItemTotalPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTotalPrice",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetLineItemTotalPriceAction(**data)


class CartSetLocaleActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetLocaleAction`."
    locale = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetLocaleAction(**data)


class CartSetShippingAddressActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetShippingAddressAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetShippingAddressAction(**data)


class CartSetShippingMethodActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetShippingMethodAction`."
    shipping_method = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingMethod",
    )
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetShippingMethodAction(**data)


class CartSetShippingMethodTaxAmountActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetShippingMethodTaxAmountAction`."
    external_tax_amount = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxAmountDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxAmount",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetShippingMethodTaxAmountAction(**data)


class CartSetShippingMethodTaxRateActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetShippingMethodTaxRateAction`."
    external_tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExternalTaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="externalTaxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetShippingMethodTaxRateAction(**data)


class CartSetShippingRateInputActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartSetShippingRateInputAction`."
    shipping_rate_input = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "Classification": "commercetools.schemas.ClassificationShippingRateInputDraftSchema",
            "Score": "commercetools.schemas.ScoreShippingRateInputDraftSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingRateInput",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartSetShippingRateInputAction(**data)


class CartUpdateItemShippingAddressActionSchema(CartUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CartUpdateItemShippingAddressAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CartUpdateItemShippingAddressAction(**data)


class CategoryAddAssetActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategoryAddAssetAction`."
    asset = marshmallow.fields.Nested(
        nested="commercetools.schemas.AssetDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    position = marshmallow.fields.Integer(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategoryAddAssetAction(**data)


class CategoryChangeAssetNameActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategoryChangeAssetNameAction`."
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    name = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategoryChangeAssetNameAction(**data)


class CategoryChangeAssetOrderActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategoryChangeAssetOrderAction`."
    asset_order = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True), data_key="assetOrder"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategoryChangeAssetOrderAction(**data)


class CategoryChangeNameActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategoryChangeNameAction`."
    name = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategoryChangeNameAction(**data)


class CategoryChangeOrderHintActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategoryChangeOrderHintAction`."
    order_hint = marshmallow.fields.String(allow_none=True, data_key="orderHint")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategoryChangeOrderHintAction(**data)


class CategoryChangeParentActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategoryChangeParentAction`."
    parent = marshmallow.fields.Nested(
        nested="commercetools.schemas.CategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategoryChangeParentAction(**data)


class CategoryChangeSlugActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategoryChangeSlugAction`."
    slug = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategoryChangeSlugAction(**data)


class CategoryCreatedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.CategoryCreatedMessage`."
    category = marshmallow.fields.Nested(
        nested="commercetools.schemas.CategorySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CategoryCreatedMessage(**data)


class CategoryReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.CategoryReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.CategorySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.CategoryReference(**data)


class CategoryRemoveAssetActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategoryRemoveAssetAction`."
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategoryRemoveAssetAction(**data)


class CategorySetAssetCustomFieldActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySetAssetCustomFieldAction`."
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategorySetAssetCustomFieldAction(**data)


class CategorySetAssetCustomTypeActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySetAssetCustomTypeAction`."
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = marshmallow.fields.Dict(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategorySetAssetCustomTypeAction(**data)


class CategorySetAssetDescriptionActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySetAssetDescriptionAction`."
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    description = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategorySetAssetDescriptionAction(**data)


class CategorySetAssetKeyActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySetAssetKeyAction`."
    asset_id = marshmallow.fields.String(allow_none=True, data_key="assetId")
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategorySetAssetKeyAction(**data)


class CategorySetAssetSourcesActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySetAssetSourcesAction`."
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    sources = marshmallow.fields.Nested(
        nested="commercetools.schemas.AssetSourceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategorySetAssetSourcesAction(**data)


class CategorySetAssetTagsActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySetAssetTagsAction`."
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    tags = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True), missing=None
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategorySetAssetTagsAction(**data)


class CategorySetCustomFieldActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySetCustomFieldAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategorySetCustomFieldAction(**data)


class CategorySetCustomTypeActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySetCustomTypeAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategorySetCustomTypeAction(**data)


class CategorySetDescriptionActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySetDescriptionAction`."
    description = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategorySetDescriptionAction(**data)


class CategorySetExternalIdActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySetExternalIdAction`."
    external_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="externalId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategorySetExternalIdAction(**data)


class CategorySetKeyActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategorySetKeyAction(**data)


class CategorySetMetaDescriptionActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySetMetaDescriptionAction`."
    meta_description = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaDescription"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategorySetMetaDescriptionAction(**data)


class CategorySetMetaKeywordsActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySetMetaKeywordsAction`."
    meta_keywords = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaKeywords"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategorySetMetaKeywordsAction(**data)


class CategorySetMetaTitleActionSchema(CategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySetMetaTitleAction`."
    meta_title = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaTitle"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CategorySetMetaTitleAction(**data)


class CategorySlugChangedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.CategorySlugChangedMessage`."
    slug = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CategorySlugChangedMessage(**data)


class CentPrecisionMoneySchema(TypedMoneySchema):
    "Marshmallow schema for :class:`commercetools.types.CentPrecisionMoney`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.CentPrecisionMoney(**data)


class ChannelAddRolesActionSchema(ChannelUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ChannelAddRolesAction`."
    roles = marshmallow.fields.List(
        marshmallow_enum.EnumField(types.ChannelRoleEnum, by_value=True)
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ChannelAddRolesAction(**data)


class ChannelChangeDescriptionActionSchema(ChannelUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ChannelChangeDescriptionAction`."
    description = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ChannelChangeDescriptionAction(**data)


class ChannelChangeKeyActionSchema(ChannelUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ChannelChangeKeyAction`."
    key = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ChannelChangeKeyAction(**data)


class ChannelChangeNameActionSchema(ChannelUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ChannelChangeNameAction`."
    name = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ChannelChangeNameAction(**data)


class ChannelReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.ChannelReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.ChannelReference(**data)


class ChannelRemoveRolesActionSchema(ChannelUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ChannelRemoveRolesAction`."
    roles = marshmallow.fields.List(
        marshmallow_enum.EnumField(types.ChannelRoleEnum, by_value=True)
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ChannelRemoveRolesAction(**data)


class ChannelSetAddressActionSchema(ChannelUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ChannelSetAddressAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ChannelSetAddressAction(**data)


class ChannelSetCustomFieldActionSchema(ChannelUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ChannelSetCustomFieldAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ChannelSetCustomFieldAction(**data)


class ChannelSetCustomTypeActionSchema(ChannelUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ChannelSetCustomTypeAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ChannelSetCustomTypeAction(**data)


class ChannelSetGeoLocationActionSchema(ChannelUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ChannelSetGeoLocationAction`."
    geo_location = marshmallow.fields.Nested(
        nested="commercetools.schemas.GeoJsonPointSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="geoLocation",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ChannelSetGeoLocationAction(**data)


class ChannelSetRolesActionSchema(ChannelUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ChannelSetRolesAction`."
    roles = marshmallow.fields.List(
        marshmallow_enum.EnumField(types.ChannelRoleEnum, by_value=True)
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ChannelSetRolesAction(**data)


class CustomLineItemStateTransitionMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomLineItemStateTransitionMessage`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    transition_date = marshmallow.fields.DateTime(
        allow_none=True, data_key="transitionDate"
    )
    quantity = marshmallow.fields.Integer(allow_none=True)
    from_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="fromState",
    )
    to_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="toState",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomLineItemStateTransitionMessage(**data)


class CustomObjectReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomObjectReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomObjectSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.CustomObjectReference(**data)


class CustomerAddAddressActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerAddAddressAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerAddAddressAction(**data)


class CustomerAddBillingAddressIdActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerAddBillingAddressIdAction`."
    address_id = marshmallow.fields.String(allow_none=True, data_key="addressId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerAddBillingAddressIdAction(**data)


class CustomerAddShippingAddressIdActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerAddShippingAddressIdAction`."
    address_id = marshmallow.fields.String(allow_none=True, data_key="addressId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerAddShippingAddressIdAction(**data)


class CustomerAddressAddedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerAddressAddedMessage`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerAddressAddedMessage(**data)


class CustomerAddressChangedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerAddressChangedMessage`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerAddressChangedMessage(**data)


class CustomerAddressRemovedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerAddressRemovedMessage`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerAddressRemovedMessage(**data)


class CustomerChangeAddressActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerChangeAddressAction`."
    address_id = marshmallow.fields.String(allow_none=True, data_key="addressId")
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerChangeAddressAction(**data)


class CustomerChangeEmailActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerChangeEmailAction`."
    email = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerChangeEmailAction(**data)


class CustomerCompanyNameSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerCompanyNameSetMessage`."
    company_name = marshmallow.fields.String(allow_none=True, data_key="companyName")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerCompanyNameSetMessage(**data)


class CustomerCreatedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerCreatedMessage`."
    customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerCreatedMessage(**data)


class CustomerDateOfBirthSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerDateOfBirthSetMessage`."
    date_of_birth = marshmallow.fields.Date(allow_none=True, data_key="dateOfBirth")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerDateOfBirthSetMessage(**data)


class CustomerEmailChangedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerEmailChangedMessage`."
    email = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerEmailChangedMessage(**data)


class CustomerEmailVerifiedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerEmailVerifiedMessage`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerEmailVerifiedMessage(**data)


class CustomerGroupChangeNameActionSchema(CustomerGroupUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerGroupChangeNameAction`."
    name = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerGroupChangeNameAction(**data)


class CustomerGroupReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerGroupReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.CustomerGroupReference(**data)


class CustomerGroupSetCustomFieldActionSchema(CustomerGroupUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerGroupSetCustomFieldAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerGroupSetCustomFieldAction(**data)


class CustomerGroupSetCustomTypeActionSchema(CustomerGroupUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerGroupSetCustomTypeAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerGroupSetCustomTypeAction(**data)


class CustomerGroupSetKeyActionSchema(CustomerGroupUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerGroupSetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerGroupSetKeyAction(**data)


class CustomerGroupSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerGroupSetMessage`."
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="customerGroup",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.CustomerGroupSetMessage(**data)


class CustomerReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.CustomerReference(**data)


class CustomerRemoveAddressActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerRemoveAddressAction`."
    address_id = marshmallow.fields.String(allow_none=True, data_key="addressId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerRemoveAddressAction(**data)


class CustomerRemoveBillingAddressIdActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerRemoveBillingAddressIdAction`."
    address_id = marshmallow.fields.String(allow_none=True, data_key="addressId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerRemoveBillingAddressIdAction(**data)


class CustomerRemoveShippingAddressIdActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerRemoveShippingAddressIdAction`."
    address_id = marshmallow.fields.String(allow_none=True, data_key="addressId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerRemoveShippingAddressIdAction(**data)


class CustomerSetCompanyNameActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetCompanyNameAction`."
    company_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="companyName"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetCompanyNameAction(**data)


class CustomerSetCustomFieldActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetCustomFieldAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetCustomFieldAction(**data)


class CustomerSetCustomTypeActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetCustomTypeAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetCustomTypeAction(**data)


class CustomerSetCustomerGroupActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetCustomerGroupAction`."
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="customerGroup",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetCustomerGroupAction(**data)


class CustomerSetCustomerNumberActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetCustomerNumberAction`."
    customer_number = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerNumber"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetCustomerNumberAction(**data)


class CustomerSetDateOfBirthActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetDateOfBirthAction`."
    date_of_birth = marshmallow.fields.Date(
        allow_none=True, missing=None, data_key="dateOfBirth"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetDateOfBirthAction(**data)


class CustomerSetDefaultBillingAddressActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetDefaultBillingAddressAction`."
    address_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="addressId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetDefaultBillingAddressAction(**data)


class CustomerSetDefaultShippingAddressActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetDefaultShippingAddressAction`."
    address_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="addressId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetDefaultShippingAddressAction(**data)


class CustomerSetExternalIdActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetExternalIdAction`."
    external_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="externalId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetExternalIdAction(**data)


class CustomerSetFirstNameActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetFirstNameAction`."
    first_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="firstName"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetFirstNameAction(**data)


class CustomerSetKeyActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetKeyAction(**data)


class CustomerSetLastNameActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetLastNameAction`."
    last_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="lastName"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetLastNameAction(**data)


class CustomerSetLocaleActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetLocaleAction`."
    locale = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetLocaleAction(**data)


class CustomerSetMiddleNameActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetMiddleNameAction`."
    middle_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="middleName"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetMiddleNameAction(**data)


class CustomerSetSalutationActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetSalutationAction`."
    salutation = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetSalutationAction(**data)


class CustomerSetTitleActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetTitleAction`."
    title = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetTitleAction(**data)


class CustomerSetVatIdActionSchema(CustomerUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.CustomerSetVatIdAction`."
    vat_id = marshmallow.fields.String(allow_none=True, missing=None, data_key="vatId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.CustomerSetVatIdAction(**data)


class DeliveryAddedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.DeliveryAddedMessage`."
    delivery = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliverySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DeliveryAddedMessage(**data)


class DeliveryAddressSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.DeliveryAddressSetMessage`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    old_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="oldAddress",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DeliveryAddressSetMessage(**data)


class DeliveryItemsUpdatedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.DeliveryItemsUpdatedMessage`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    old_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="oldItems",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DeliveryItemsUpdatedMessage(**data)


class DeliveryRemovedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.DeliveryRemovedMessage`."
    delivery = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliverySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.DeliveryRemovedMessage(**data)


class DiscountCodeChangeCartDiscountsActionSchema(DiscountCodeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeChangeCartDiscountsAction`."
    cart_discounts = marshmallow.fields.Nested(
        nested="commercetools.schemas.CartDiscountReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="cartDiscounts",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.DiscountCodeChangeCartDiscountsAction(**data)


class DiscountCodeChangeGroupsActionSchema(DiscountCodeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeChangeGroupsAction`."
    groups = marshmallow.fields.List(marshmallow.fields.String(allow_none=True))

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.DiscountCodeChangeGroupsAction(**data)


class DiscountCodeChangeIsActiveActionSchema(DiscountCodeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeChangeIsActiveAction`."
    is_active = marshmallow.fields.Bool(allow_none=True, data_key="isActive")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.DiscountCodeChangeIsActiveAction(**data)


class DiscountCodeReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountCodeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.DiscountCodeReference(**data)


class DiscountCodeSetCartPredicateActionSchema(DiscountCodeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeSetCartPredicateAction`."
    cart_predicate = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="cartPredicate"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.DiscountCodeSetCartPredicateAction(**data)


class DiscountCodeSetCustomFieldActionSchema(DiscountCodeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeSetCustomFieldAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.DiscountCodeSetCustomFieldAction(**data)


class DiscountCodeSetCustomTypeActionSchema(DiscountCodeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeSetCustomTypeAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.DiscountCodeSetCustomTypeAction(**data)


class DiscountCodeSetDescriptionActionSchema(DiscountCodeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeSetDescriptionAction`."
    description = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.DiscountCodeSetDescriptionAction(**data)


class DiscountCodeSetMaxApplicationsActionSchema(DiscountCodeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeSetMaxApplicationsAction`."
    max_applications = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="maxApplications"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.DiscountCodeSetMaxApplicationsAction(**data)


class DiscountCodeSetMaxApplicationsPerCustomerActionSchema(
    DiscountCodeUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeSetMaxApplicationsPerCustomerAction`."
    max_applications_per_customer = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="maxApplicationsPerCustomer"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.DiscountCodeSetMaxApplicationsPerCustomerAction(**data)


class DiscountCodeSetNameActionSchema(DiscountCodeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeSetNameAction`."
    name = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.DiscountCodeSetNameAction(**data)


class DiscountCodeSetValidFromActionSchema(DiscountCodeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeSetValidFromAction`."
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.DiscountCodeSetValidFromAction(**data)


class DiscountCodeSetValidFromAndUntilActionSchema(DiscountCodeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeSetValidFromAndUntilAction`."
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.DiscountCodeSetValidFromAndUntilAction(**data)


class DiscountCodeSetValidUntilActionSchema(DiscountCodeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.DiscountCodeSetValidUntilAction`."
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.DiscountCodeSetValidUntilAction(**data)


class ExtensionChangeDestinationActionSchema(ExtensionUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ExtensionChangeDestinationAction`."
    destination = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "AWSLambda": "commercetools.schemas.ExtensionAWSLambdaDestinationSchema",
            "HTTP": "commercetools.schemas.ExtensionHttpDestinationSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ExtensionChangeDestinationAction(**data)


class ExtensionChangeTriggersActionSchema(ExtensionUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ExtensionChangeTriggersAction`."
    triggers = marshmallow.fields.Nested(
        nested="commercetools.schemas.ExtensionTriggerSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ExtensionChangeTriggersAction(**data)


class ExtensionSetKeyActionSchema(ExtensionUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ExtensionSetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ExtensionSetKeyAction(**data)


class HighPrecisionMoneySchema(TypedMoneySchema):
    "Marshmallow schema for :class:`commercetools.types.HighPrecisionMoney`."
    precise_amount = marshmallow.fields.Integer(
        allow_none=True, data_key="preciseAmount"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.HighPrecisionMoney(**data)


class InventoryAddQuantityActionSchema(InventoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.InventoryAddQuantityAction`."
    quantity = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.InventoryAddQuantityAction(**data)


class InventoryChangeQuantityActionSchema(InventoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.InventoryChangeQuantityAction`."
    quantity = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.InventoryChangeQuantityAction(**data)


class InventoryEntryDeletedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.InventoryEntryDeletedMessage`."
    sku = marshmallow.fields.String(allow_none=True)
    supply_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="supplyChannel",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.InventoryEntryDeletedMessage(**data)


class InventoryEntryReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.InventoryEntryReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.InventoryEntrySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.InventoryEntryReference(**data)


class InventoryRemoveQuantityActionSchema(InventoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.InventoryRemoveQuantityAction`."
    quantity = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.InventoryRemoveQuantityAction(**data)


class InventorySetCustomFieldActionSchema(InventoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.InventorySetCustomFieldAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.InventorySetCustomFieldAction(**data)


class InventorySetCustomTypeActionSchema(InventoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.InventorySetCustomTypeAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.InventorySetCustomTypeAction(**data)


class InventorySetExpectedDeliveryActionSchema(InventoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.InventorySetExpectedDeliveryAction`."
    expected_delivery = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="expectedDelivery"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.InventorySetExpectedDeliveryAction(**data)


class InventorySetRestockableInDaysActionSchema(InventoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.InventorySetRestockableInDaysAction`."
    restockable_in_days = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="restockableInDays"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.InventorySetRestockableInDaysAction(**data)


class InventorySetSupplyChannelActionSchema(InventoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.InventorySetSupplyChannelAction`."
    supply_channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="supplyChannel",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.InventorySetSupplyChannelAction(**data)


class LineItemStateTransitionMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.LineItemStateTransitionMessage`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    transition_date = marshmallow.fields.DateTime(
        allow_none=True, data_key="transitionDate"
    )
    quantity = marshmallow.fields.Integer(allow_none=True)
    from_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="fromState",
    )
    to_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="toState",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.LineItemStateTransitionMessage(**data)


class OrderAddDeliveryActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderAddDeliveryAction`."
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    parcels = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderAddDeliveryAction(**data)


class OrderAddItemShippingAddressActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderAddItemShippingAddressAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderAddItemShippingAddressAction(**data)


class OrderAddParcelToDeliveryActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderAddParcelToDeliveryAction`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    measurements = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelMeasurementsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    tracking_data = marshmallow.fields.Nested(
        nested="commercetools.schemas.TrackingDataSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="trackingData",
    )
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderAddParcelToDeliveryAction(**data)


class OrderAddPaymentActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderAddPaymentAction`."
    payment = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderAddPaymentAction(**data)


class OrderAddReturnInfoActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderAddReturnInfoAction`."
    return_tracking_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="returnTrackingId"
    )
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.ReturnItemDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    return_date = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="returnDate"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderAddReturnInfoAction(**data)


class OrderBillingAddressSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderBillingAddressSetMessage`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    old_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="oldAddress",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderBillingAddressSetMessage(**data)


class OrderChangeOrderStateActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderChangeOrderStateAction`."
    order_state = marshmallow_enum.EnumField(
        types.OrderState, by_value=True, data_key="orderState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderChangeOrderStateAction(**data)


class OrderChangePaymentStateActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderChangePaymentStateAction`."
    payment_state = marshmallow_enum.EnumField(
        types.PaymentState, by_value=True, missing=None, data_key="paymentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderChangePaymentStateAction(**data)


class OrderChangeShipmentStateActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderChangeShipmentStateAction`."
    shipment_state = marshmallow_enum.EnumField(
        types.ShipmentState, by_value=True, missing=None, data_key="shipmentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderChangeShipmentStateAction(**data)


class OrderCreatedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderCreatedMessage`."
    order = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderCreatedMessage(**data)


class OrderCustomLineItemDiscountSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderCustomLineItemDiscountSetMessage`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    discounted_price_per_quantity = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountedLineItemPriceForQuantitySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="discountedPricePerQuantity",
    )
    taxed_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxedItemPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxedPrice",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderCustomLineItemDiscountSetMessage(**data)


class OrderCustomerEmailSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderCustomerEmailSetMessage`."
    email = marshmallow.fields.String(allow_none=True, missing=None)
    old_email = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="oldEmail"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderCustomerEmailSetMessage(**data)


class OrderCustomerSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderCustomerSetMessage`."
    customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="customerGroup",
    )
    old_customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="oldCustomer",
    )
    old_customer_group = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerGroupReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="oldCustomerGroup",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderCustomerSetMessage(**data)


class OrderDeletedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderDeletedMessage`."
    order = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderDeletedMessage(**data)


class OrderDiscountCodeAddedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderDiscountCodeAddedMessage`."
    discount_code = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountCodeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="discountCode",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderDiscountCodeAddedMessage(**data)


class OrderDiscountCodeRemovedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderDiscountCodeRemovedMessage`."
    discount_code = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountCodeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="discountCode",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderDiscountCodeRemovedMessage(**data)


class OrderDiscountCodeStateSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderDiscountCodeStateSetMessage`."
    discount_code = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountCodeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="discountCode",
    )
    state = marshmallow_enum.EnumField(types.DiscountCodeState, by_value=True)
    old_state = marshmallow_enum.EnumField(
        types.DiscountCodeState, by_value=True, missing=None, data_key="oldState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderDiscountCodeStateSetMessage(**data)


class OrderEditAddStagedActionActionSchema(OrderEditUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditAddStagedActionAction`."
    staged_action = helpers.Discriminator(
        discriminator_field=("action", "action"),
        discriminator_schemas={
            "addCustomLineItem": "commercetools.schemas.StagedOrderAddCustomLineItemActionSchema",
            "addDelivery": "commercetools.schemas.StagedOrderAddDeliveryActionSchema",
            "addDiscountCode": "commercetools.schemas.StagedOrderAddDiscountCodeActionSchema",
            "addItemShippingAddress": "commercetools.schemas.StagedOrderAddItemShippingAddressActionSchema",
            "addLineItem": "commercetools.schemas.StagedOrderAddLineItemActionSchema",
            "addParcelToDelivery": "commercetools.schemas.StagedOrderAddParcelToDeliveryActionSchema",
            "addPayment": "commercetools.schemas.StagedOrderAddPaymentActionSchema",
            "addReturnInfo": "commercetools.schemas.StagedOrderAddReturnInfoActionSchema",
            "addShoppingList": "commercetools.schemas.StagedOrderAddShoppingListActionSchema",
            "changeCustomLineItemMoney": "commercetools.schemas.StagedOrderChangeCustomLineItemMoneyActionSchema",
            "changeCustomLineItemQuantity": "commercetools.schemas.StagedOrderChangeCustomLineItemQuantityActionSchema",
            "changeLineItemQuantity": "commercetools.schemas.StagedOrderChangeLineItemQuantityActionSchema",
            "changeOrderState": "commercetools.schemas.StagedOrderChangeOrderStateActionSchema",
            "changePaymentState": "commercetools.schemas.StagedOrderChangePaymentStateActionSchema",
            "changeShipmentState": "commercetools.schemas.StagedOrderChangeShipmentStateActionSchema",
            "changeTaxCalculationMode": "commercetools.schemas.StagedOrderChangeTaxCalculationModeActionSchema",
            "changeTaxMode": "commercetools.schemas.StagedOrderChangeTaxModeActionSchema",
            "changeTaxRoundingMode": "commercetools.schemas.StagedOrderChangeTaxRoundingModeActionSchema",
            "importCustomLineItemState": "commercetools.schemas.StagedOrderImportCustomLineItemStateActionSchema",
            "importLineItemState": "commercetools.schemas.StagedOrderImportLineItemStateActionSchema",
            "removeCustomLineItem": "commercetools.schemas.StagedOrderRemoveCustomLineItemActionSchema",
            "removeDelivery": "commercetools.schemas.StagedOrderRemoveDeliveryActionSchema",
            "removeDiscountCode": "commercetools.schemas.StagedOrderRemoveDiscountCodeActionSchema",
            "removeItemShippingAddress": "commercetools.schemas.StagedOrderRemoveItemShippingAddressActionSchema",
            "removeLineItem": "commercetools.schemas.StagedOrderRemoveLineItemActionSchema",
            "removeParcelFromDelivery": "commercetools.schemas.StagedOrderRemoveParcelFromDeliveryActionSchema",
            "removePayment": "commercetools.schemas.StagedOrderRemovePaymentActionSchema",
            "setBillingAddress": "commercetools.schemas.StagedOrderSetBillingAddressActionSchema",
            "setCountry": "commercetools.schemas.StagedOrderSetCountryActionSchema",
            "setCustomField": "commercetools.schemas.StagedOrderSetCustomFieldActionSchema",
            "setCustomLineItemCustomField": "commercetools.schemas.StagedOrderSetCustomLineItemCustomFieldActionSchema",
            "setCustomLineItemCustomType": "commercetools.schemas.StagedOrderSetCustomLineItemCustomTypeActionSchema",
            "setCustomLineItemShippingDetails": "commercetools.schemas.StagedOrderSetCustomLineItemShippingDetailsActionSchema",
            "setCustomLineItemTaxAmount": "commercetools.schemas.StagedOrderSetCustomLineItemTaxAmountActionSchema",
            "setCustomLineItemTaxRate": "commercetools.schemas.StagedOrderSetCustomLineItemTaxRateActionSchema",
            "setCustomShippingMethod": "commercetools.schemas.StagedOrderSetCustomShippingMethodActionSchema",
            "setCustomType": "commercetools.schemas.StagedOrderSetCustomTypeActionSchema",
            "setCustomerEmail": "commercetools.schemas.StagedOrderSetCustomerEmailActionSchema",
            "setCustomerGroup": "commercetools.schemas.StagedOrderSetCustomerGroupActionSchema",
            "setCustomerId": "commercetools.schemas.StagedOrderSetCustomerIdActionSchema",
            "setDeliveryAddress": "commercetools.schemas.StagedOrderSetDeliveryAddressActionSchema",
            "setDeliveryItems": "commercetools.schemas.StagedOrderSetDeliveryItemsActionSchema",
            "setLineItemCustomField": "commercetools.schemas.StagedOrderSetLineItemCustomFieldActionSchema",
            "setLineItemCustomType": "commercetools.schemas.StagedOrderSetLineItemCustomTypeActionSchema",
            "setLineItemPrice": "commercetools.schemas.StagedOrderSetLineItemPriceActionSchema",
            "setLineItemShippingDetails": "commercetools.schemas.StagedOrderSetLineItemShippingDetailsActionSchema",
            "setLineItemTaxAmount": "commercetools.schemas.StagedOrderSetLineItemTaxAmountActionSchema",
            "setLineItemTaxRate": "commercetools.schemas.StagedOrderSetLineItemTaxRateActionSchema",
            "setLineItemTotalPrice": "commercetools.schemas.StagedOrderSetLineItemTotalPriceActionSchema",
            "setLocale": "commercetools.schemas.StagedOrderSetLocaleActionSchema",
            "setOrderNumber": "commercetools.schemas.StagedOrderSetOrderNumberActionSchema",
            "setOrderTotalTax": "commercetools.schemas.StagedOrderSetOrderTotalTaxActionSchema",
            "setParcelItems": "commercetools.schemas.StagedOrderSetParcelItemsActionSchema",
            "setParcelMeasurements": "commercetools.schemas.StagedOrderSetParcelMeasurementsActionSchema",
            "setParcelTrackingData": "commercetools.schemas.StagedOrderSetParcelTrackingDataActionSchema",
            "setReturnPaymentState": "commercetools.schemas.StagedOrderSetReturnPaymentStateActionSchema",
            "setReturnShipmentState": "commercetools.schemas.StagedOrderSetReturnShipmentStateActionSchema",
            "setShippingAddress": "commercetools.schemas.StagedOrderSetShippingAddressActionSchema",
            "setShippingAddressAndCustomShippingMethod": "commercetools.schemas.StagedOrderSetShippingAddressAndCustomShippingMethodActionSchema",
            "setShippingAddressAndShippingMethod": "commercetools.schemas.StagedOrderSetShippingAddressAndShippingMethodActionSchema",
            "setShippingMethod": "commercetools.schemas.StagedOrderSetShippingMethodActionSchema",
            "setShippingMethodTaxAmount": "commercetools.schemas.StagedOrderSetShippingMethodTaxAmountActionSchema",
            "setShippingMethodTaxRate": "commercetools.schemas.StagedOrderSetShippingMethodTaxRateActionSchema",
            "setShippingRateInput": "commercetools.schemas.StagedOrderSetShippingRateInputActionSchema",
            "transitionCustomLineItemState": "commercetools.schemas.StagedOrderTransitionCustomLineItemStateActionSchema",
            "transitionLineItemState": "commercetools.schemas.StagedOrderTransitionLineItemStateActionSchema",
            "transitionState": "commercetools.schemas.StagedOrderTransitionStateActionSchema",
            "updateItemShippingAddress": "commercetools.schemas.StagedOrderUpdateItemShippingAddressActionSchema",
            "updateSyncInfo": "commercetools.schemas.StagedOrderUpdateSyncInfoActionSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="stagedAction",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderEditAddStagedActionAction(**data)


class OrderEditAppliedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditAppliedMessage`."
    edit = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderEditReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    result = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderEditAppliedSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderEditAppliedMessage(**data)


class OrderEditReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderEditSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.OrderEditReference(**data)


class OrderEditSetCommentActionSchema(OrderEditUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditSetCommentAction`."
    comment = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderEditSetCommentAction(**data)


class OrderEditSetCustomFieldActionSchema(OrderEditUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditSetCustomFieldAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderEditSetCustomFieldAction(**data)


class OrderEditSetCustomTypeActionSchema(OrderEditUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditSetCustomTypeAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = marshmallow.fields.Dict(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderEditSetCustomTypeAction(**data)


class OrderEditSetKeyActionSchema(OrderEditUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditSetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderEditSetKeyAction(**data)


class OrderEditSetStagedActionsActionSchema(OrderEditUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderEditSetStagedActionsAction`."
    staged_actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addCustomLineItem": "commercetools.schemas.StagedOrderAddCustomLineItemActionSchema",
                "addDelivery": "commercetools.schemas.StagedOrderAddDeliveryActionSchema",
                "addDiscountCode": "commercetools.schemas.StagedOrderAddDiscountCodeActionSchema",
                "addItemShippingAddress": "commercetools.schemas.StagedOrderAddItemShippingAddressActionSchema",
                "addLineItem": "commercetools.schemas.StagedOrderAddLineItemActionSchema",
                "addParcelToDelivery": "commercetools.schemas.StagedOrderAddParcelToDeliveryActionSchema",
                "addPayment": "commercetools.schemas.StagedOrderAddPaymentActionSchema",
                "addReturnInfo": "commercetools.schemas.StagedOrderAddReturnInfoActionSchema",
                "addShoppingList": "commercetools.schemas.StagedOrderAddShoppingListActionSchema",
                "changeCustomLineItemMoney": "commercetools.schemas.StagedOrderChangeCustomLineItemMoneyActionSchema",
                "changeCustomLineItemQuantity": "commercetools.schemas.StagedOrderChangeCustomLineItemQuantityActionSchema",
                "changeLineItemQuantity": "commercetools.schemas.StagedOrderChangeLineItemQuantityActionSchema",
                "changeOrderState": "commercetools.schemas.StagedOrderChangeOrderStateActionSchema",
                "changePaymentState": "commercetools.schemas.StagedOrderChangePaymentStateActionSchema",
                "changeShipmentState": "commercetools.schemas.StagedOrderChangeShipmentStateActionSchema",
                "changeTaxCalculationMode": "commercetools.schemas.StagedOrderChangeTaxCalculationModeActionSchema",
                "changeTaxMode": "commercetools.schemas.StagedOrderChangeTaxModeActionSchema",
                "changeTaxRoundingMode": "commercetools.schemas.StagedOrderChangeTaxRoundingModeActionSchema",
                "importCustomLineItemState": "commercetools.schemas.StagedOrderImportCustomLineItemStateActionSchema",
                "importLineItemState": "commercetools.schemas.StagedOrderImportLineItemStateActionSchema",
                "removeCustomLineItem": "commercetools.schemas.StagedOrderRemoveCustomLineItemActionSchema",
                "removeDelivery": "commercetools.schemas.StagedOrderRemoveDeliveryActionSchema",
                "removeDiscountCode": "commercetools.schemas.StagedOrderRemoveDiscountCodeActionSchema",
                "removeItemShippingAddress": "commercetools.schemas.StagedOrderRemoveItemShippingAddressActionSchema",
                "removeLineItem": "commercetools.schemas.StagedOrderRemoveLineItemActionSchema",
                "removeParcelFromDelivery": "commercetools.schemas.StagedOrderRemoveParcelFromDeliveryActionSchema",
                "removePayment": "commercetools.schemas.StagedOrderRemovePaymentActionSchema",
                "setBillingAddress": "commercetools.schemas.StagedOrderSetBillingAddressActionSchema",
                "setCountry": "commercetools.schemas.StagedOrderSetCountryActionSchema",
                "setCustomField": "commercetools.schemas.StagedOrderSetCustomFieldActionSchema",
                "setCustomLineItemCustomField": "commercetools.schemas.StagedOrderSetCustomLineItemCustomFieldActionSchema",
                "setCustomLineItemCustomType": "commercetools.schemas.StagedOrderSetCustomLineItemCustomTypeActionSchema",
                "setCustomLineItemShippingDetails": "commercetools.schemas.StagedOrderSetCustomLineItemShippingDetailsActionSchema",
                "setCustomLineItemTaxAmount": "commercetools.schemas.StagedOrderSetCustomLineItemTaxAmountActionSchema",
                "setCustomLineItemTaxRate": "commercetools.schemas.StagedOrderSetCustomLineItemTaxRateActionSchema",
                "setCustomShippingMethod": "commercetools.schemas.StagedOrderSetCustomShippingMethodActionSchema",
                "setCustomType": "commercetools.schemas.StagedOrderSetCustomTypeActionSchema",
                "setCustomerEmail": "commercetools.schemas.StagedOrderSetCustomerEmailActionSchema",
                "setCustomerGroup": "commercetools.schemas.StagedOrderSetCustomerGroupActionSchema",
                "setCustomerId": "commercetools.schemas.StagedOrderSetCustomerIdActionSchema",
                "setDeliveryAddress": "commercetools.schemas.StagedOrderSetDeliveryAddressActionSchema",
                "setDeliveryItems": "commercetools.schemas.StagedOrderSetDeliveryItemsActionSchema",
                "setLineItemCustomField": "commercetools.schemas.StagedOrderSetLineItemCustomFieldActionSchema",
                "setLineItemCustomType": "commercetools.schemas.StagedOrderSetLineItemCustomTypeActionSchema",
                "setLineItemPrice": "commercetools.schemas.StagedOrderSetLineItemPriceActionSchema",
                "setLineItemShippingDetails": "commercetools.schemas.StagedOrderSetLineItemShippingDetailsActionSchema",
                "setLineItemTaxAmount": "commercetools.schemas.StagedOrderSetLineItemTaxAmountActionSchema",
                "setLineItemTaxRate": "commercetools.schemas.StagedOrderSetLineItemTaxRateActionSchema",
                "setLineItemTotalPrice": "commercetools.schemas.StagedOrderSetLineItemTotalPriceActionSchema",
                "setLocale": "commercetools.schemas.StagedOrderSetLocaleActionSchema",
                "setOrderNumber": "commercetools.schemas.StagedOrderSetOrderNumberActionSchema",
                "setOrderTotalTax": "commercetools.schemas.StagedOrderSetOrderTotalTaxActionSchema",
                "setParcelItems": "commercetools.schemas.StagedOrderSetParcelItemsActionSchema",
                "setParcelMeasurements": "commercetools.schemas.StagedOrderSetParcelMeasurementsActionSchema",
                "setParcelTrackingData": "commercetools.schemas.StagedOrderSetParcelTrackingDataActionSchema",
                "setReturnPaymentState": "commercetools.schemas.StagedOrderSetReturnPaymentStateActionSchema",
                "setReturnShipmentState": "commercetools.schemas.StagedOrderSetReturnShipmentStateActionSchema",
                "setShippingAddress": "commercetools.schemas.StagedOrderSetShippingAddressActionSchema",
                "setShippingAddressAndCustomShippingMethod": "commercetools.schemas.StagedOrderSetShippingAddressAndCustomShippingMethodActionSchema",
                "setShippingAddressAndShippingMethod": "commercetools.schemas.StagedOrderSetShippingAddressAndShippingMethodActionSchema",
                "setShippingMethod": "commercetools.schemas.StagedOrderSetShippingMethodActionSchema",
                "setShippingMethodTaxAmount": "commercetools.schemas.StagedOrderSetShippingMethodTaxAmountActionSchema",
                "setShippingMethodTaxRate": "commercetools.schemas.StagedOrderSetShippingMethodTaxRateActionSchema",
                "setShippingRateInput": "commercetools.schemas.StagedOrderSetShippingRateInputActionSchema",
                "transitionCustomLineItemState": "commercetools.schemas.StagedOrderTransitionCustomLineItemStateActionSchema",
                "transitionLineItemState": "commercetools.schemas.StagedOrderTransitionLineItemStateActionSchema",
                "transitionState": "commercetools.schemas.StagedOrderTransitionStateActionSchema",
                "updateItemShippingAddress": "commercetools.schemas.StagedOrderUpdateItemShippingAddressActionSchema",
                "updateSyncInfo": "commercetools.schemas.StagedOrderUpdateSyncInfoActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        data_key="stagedActions",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderEditSetStagedActionsAction(**data)


class OrderImportCustomLineItemStateActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderImportCustomLineItemStateAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemStateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderImportCustomLineItemStateAction(**data)


class OrderImportLineItemStateActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderImportLineItemStateAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemStateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderImportLineItemStateAction(**data)


class OrderImportedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderImportedMessage`."
    order = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderImportedMessage(**data)


class OrderLineItemDiscountSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderLineItemDiscountSetMessage`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    discounted_price_per_quantity = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountedLineItemPriceForQuantitySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="discountedPricePerQuantity",
    )
    total_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="totalPrice",
    )
    taxed_price = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxedItemPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxedPrice",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderLineItemDiscountSetMessage(**data)


class OrderPaymentStateChangedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderPaymentStateChangedMessage`."
    payment_state = marshmallow_enum.EnumField(
        types.PaymentState, by_value=True, data_key="paymentState"
    )
    old_payment_state = marshmallow_enum.EnumField(
        types.PaymentState, by_value=True, data_key="oldPaymentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderPaymentStateChangedMessage(**data)


class OrderReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.OrderSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.OrderReference(**data)


class OrderRemoveDeliveryActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderRemoveDeliveryAction`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderRemoveDeliveryAction(**data)


class OrderRemoveItemShippingAddressActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderRemoveItemShippingAddressAction`."
    address_key = marshmallow.fields.String(allow_none=True, data_key="addressKey")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderRemoveItemShippingAddressAction(**data)


class OrderRemoveParcelFromDeliveryActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderRemoveParcelFromDeliveryAction`."
    parcel_id = marshmallow.fields.String(allow_none=True, data_key="parcelId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderRemoveParcelFromDeliveryAction(**data)


class OrderRemovePaymentActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderRemovePaymentAction`."
    payment = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderRemovePaymentAction(**data)


class OrderReturnInfoAddedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderReturnInfoAddedMessage`."
    return_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.ReturnInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="returnInfo",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderReturnInfoAddedMessage(**data)


class OrderReturnShipmentStateChangedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderReturnShipmentStateChangedMessage`."
    return_item_id = marshmallow.fields.String(allow_none=True, data_key="returnItemId")
    return_shipment_state = marshmallow_enum.EnumField(
        types.ReturnShipmentState, by_value=True, data_key="returnShipmentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderReturnShipmentStateChangedMessage(**data)


class OrderSetBillingAddressActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetBillingAddressAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetBillingAddressAction(**data)


class OrderSetCustomFieldActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetCustomFieldAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetCustomFieldAction(**data)


class OrderSetCustomLineItemCustomFieldActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetCustomLineItemCustomFieldAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetCustomLineItemCustomFieldAction(**data)


class OrderSetCustomLineItemCustomTypeActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetCustomLineItemCustomTypeAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetCustomLineItemCustomTypeAction(**data)


class OrderSetCustomLineItemShippingDetailsActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetCustomLineItemShippingDetailsAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    shipping_details = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetails",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetCustomLineItemShippingDetailsAction(**data)


class OrderSetCustomTypeActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetCustomTypeAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetCustomTypeAction(**data)


class OrderSetCustomerEmailActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetCustomerEmailAction`."
    email = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetCustomerEmailAction(**data)


class OrderSetCustomerIdActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetCustomerIdAction`."
    customer_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="customerId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetCustomerIdAction(**data)


class OrderSetDeliveryAddressActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetDeliveryAddressAction`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetDeliveryAddressAction(**data)


class OrderSetDeliveryItemsActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetDeliveryItemsAction`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetDeliveryItemsAction(**data)


class OrderSetLineItemCustomFieldActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetLineItemCustomFieldAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetLineItemCustomFieldAction(**data)


class OrderSetLineItemCustomTypeActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetLineItemCustomTypeAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetLineItemCustomTypeAction(**data)


class OrderSetLineItemShippingDetailsActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetLineItemShippingDetailsAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    shipping_details = marshmallow.fields.Nested(
        nested="commercetools.schemas.ItemShippingDetailsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingDetails",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetLineItemShippingDetailsAction(**data)


class OrderSetLocaleActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetLocaleAction`."
    locale = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetLocaleAction(**data)


class OrderSetOrderNumberActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetOrderNumberAction`."
    order_number = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="orderNumber"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetOrderNumberAction(**data)


class OrderSetParcelItemsActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetParcelItemsAction`."
    parcel_id = marshmallow.fields.String(allow_none=True, data_key="parcelId")
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetParcelItemsAction(**data)


class OrderSetParcelMeasurementsActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetParcelMeasurementsAction`."
    parcel_id = marshmallow.fields.String(allow_none=True, data_key="parcelId")
    measurements = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelMeasurementsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetParcelMeasurementsAction(**data)


class OrderSetParcelTrackingDataActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetParcelTrackingDataAction`."
    parcel_id = marshmallow.fields.String(allow_none=True, data_key="parcelId")
    tracking_data = marshmallow.fields.Nested(
        nested="commercetools.schemas.TrackingDataSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="trackingData",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetParcelTrackingDataAction(**data)


class OrderSetReturnPaymentStateActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetReturnPaymentStateAction`."
    return_item_id = marshmallow.fields.String(allow_none=True, data_key="returnItemId")
    payment_state = marshmallow_enum.EnumField(
        types.ReturnPaymentState, by_value=True, data_key="paymentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetReturnPaymentStateAction(**data)


class OrderSetReturnShipmentStateActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetReturnShipmentStateAction`."
    return_item_id = marshmallow.fields.String(allow_none=True, data_key="returnItemId")
    shipment_state = marshmallow_enum.EnumField(
        types.ReturnShipmentState, by_value=True, data_key="shipmentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetReturnShipmentStateAction(**data)


class OrderSetShippingAddressActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderSetShippingAddressAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderSetShippingAddressAction(**data)


class OrderShipmentStateChangedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderShipmentStateChangedMessage`."
    shipment_state = marshmallow_enum.EnumField(
        types.ShipmentState, by_value=True, data_key="shipmentState"
    )
    old_shipment_state = marshmallow_enum.EnumField(
        types.ShipmentState, by_value=True, data_key="oldShipmentState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderShipmentStateChangedMessage(**data)


class OrderShippingAddressSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderShippingAddressSetMessage`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    old_address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="oldAddress",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderShippingAddressSetMessage(**data)


class OrderShippingInfoSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderShippingInfoSetMessage`."
    shipping_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingInfo",
    )
    old_shipping_info = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingInfoSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="oldShippingInfo",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderShippingInfoSetMessage(**data)


class OrderShippingRateInputSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderShippingRateInputSetMessage`."
    shipping_rate_input = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "Classification": "commercetools.schemas.ClassificationShippingRateInputSchema",
            "Score": "commercetools.schemas.ScoreShippingRateInputSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingRateInput",
    )
    old_shipping_rate_input = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "Classification": "commercetools.schemas.ClassificationShippingRateInputSchema",
            "Score": "commercetools.schemas.ScoreShippingRateInputSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="oldShippingRateInput",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderShippingRateInputSetMessage(**data)


class OrderStateChangedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderStateChangedMessage`."
    order_state = marshmallow_enum.EnumField(
        types.OrderState, by_value=True, data_key="orderState"
    )
    old_order_state = marshmallow_enum.EnumField(
        types.OrderState, by_value=True, data_key="oldOrderState"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderStateChangedMessage(**data)


class OrderStateTransitionMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderStateTransitionMessage`."
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    force = marshmallow.fields.Bool(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.OrderStateTransitionMessage(**data)


class OrderTransitionCustomLineItemStateActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderTransitionCustomLineItemStateAction`."
    custom_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="customLineItemId"
    )
    quantity = marshmallow.fields.Integer(allow_none=True)
    from_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="fromState",
    )
    to_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="toState",
    )
    actual_transition_date = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="actualTransitionDate"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderTransitionCustomLineItemStateAction(**data)


class OrderTransitionLineItemStateActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderTransitionLineItemStateAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    quantity = marshmallow.fields.Integer(allow_none=True)
    from_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="fromState",
    )
    to_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="toState",
    )
    actual_transition_date = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="actualTransitionDate"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderTransitionLineItemStateAction(**data)


class OrderTransitionStateActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderTransitionStateAction`."
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    force = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderTransitionStateAction(**data)


class OrderUpdateItemShippingAddressActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderUpdateItemShippingAddressAction`."
    address = marshmallow.fields.Nested(
        nested="commercetools.schemas.AddressSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderUpdateItemShippingAddressAction(**data)


class OrderUpdateSyncInfoActionSchema(OrderUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.OrderUpdateSyncInfoAction`."
    channel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChannelReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    external_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="externalId"
    )
    synced_at = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="syncedAt"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.OrderUpdateSyncInfoAction(**data)


class ParcelAddedToDeliveryMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ParcelAddedToDeliveryMessage`."
    delivery = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliverySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    parcel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ParcelAddedToDeliveryMessage(**data)


class ParcelItemsUpdatedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ParcelItemsUpdatedMessage`."
    parcel_id = marshmallow.fields.String(allow_none=True, data_key="parcelId")
    delivery_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="deliveryId"
    )
    items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    old_items = marshmallow.fields.Nested(
        nested="commercetools.schemas.DeliveryItemSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        data_key="oldItems",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ParcelItemsUpdatedMessage(**data)


class ParcelMeasurementsUpdatedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ParcelMeasurementsUpdatedMessage`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    parcel_id = marshmallow.fields.String(allow_none=True, data_key="parcelId")
    measurements = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelMeasurementsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ParcelMeasurementsUpdatedMessage(**data)


class ParcelRemovedFromDeliveryMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ParcelRemovedFromDeliveryMessage`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    parcel = marshmallow.fields.Nested(
        nested="commercetools.schemas.ParcelSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ParcelRemovedFromDeliveryMessage(**data)


class ParcelTrackingDataUpdatedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ParcelTrackingDataUpdatedMessage`."
    delivery_id = marshmallow.fields.String(allow_none=True, data_key="deliveryId")
    parcel_id = marshmallow.fields.String(allow_none=True, data_key="parcelId")
    tracking_data = marshmallow.fields.Nested(
        nested="commercetools.schemas.TrackingDataSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="trackingData",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ParcelTrackingDataUpdatedMessage(**data)


class PaymentAddInterfaceInteractionActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentAddInterfaceInteractionAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentAddInterfaceInteractionAction(**data)


class PaymentAddTransactionActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentAddTransactionAction`."
    transaction = marshmallow.fields.Nested(
        nested="commercetools.schemas.TransactionDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentAddTransactionAction(**data)


class PaymentChangeAmountPlannedActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentChangeAmountPlannedAction`."
    amount = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentChangeAmountPlannedAction(**data)


class PaymentChangeTransactionInteractionIdActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentChangeTransactionInteractionIdAction`."
    transaction_id = marshmallow.fields.String(
        allow_none=True, data_key="transactionId"
    )
    interaction_id = marshmallow.fields.String(
        allow_none=True, data_key="interactionId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentChangeTransactionInteractionIdAction(**data)


class PaymentChangeTransactionStateActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentChangeTransactionStateAction`."
    transaction_id = marshmallow.fields.String(
        allow_none=True, data_key="transactionId"
    )
    state = marshmallow_enum.EnumField(types.TransactionState, by_value=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentChangeTransactionStateAction(**data)


class PaymentChangeTransactionTimestampActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentChangeTransactionTimestampAction`."
    transaction_id = marshmallow.fields.String(
        allow_none=True, data_key="transactionId"
    )
    timestamp = marshmallow.fields.DateTime(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentChangeTransactionTimestampAction(**data)


class PaymentCreatedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentCreatedMessage`."
    payment = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PaymentCreatedMessage(**data)


class PaymentInteractionAddedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentInteractionAddedMessage`."
    interaction = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PaymentInteractionAddedMessage(**data)


class PaymentReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.PaymentSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.PaymentReference(**data)


class PaymentSetAmountPaidActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetAmountPaidAction`."
    amount = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetAmountPaidAction(**data)


class PaymentSetAmountRefundedActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetAmountRefundedAction`."
    amount = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetAmountRefundedAction(**data)


class PaymentSetAnonymousIdActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetAnonymousIdAction`."
    anonymous_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="anonymousId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetAnonymousIdAction(**data)


class PaymentSetAuthorizationActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetAuthorizationAction`."
    amount = marshmallow.fields.Nested(
        nested="commercetools.schemas.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    until = marshmallow.fields.DateTime(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetAuthorizationAction(**data)


class PaymentSetCustomFieldActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetCustomFieldAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetCustomFieldAction(**data)


class PaymentSetCustomTypeActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetCustomTypeAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetCustomTypeAction(**data)


class PaymentSetCustomerActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetCustomerAction`."
    customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetCustomerAction(**data)


class PaymentSetExternalIdActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetExternalIdAction`."
    external_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="externalId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetExternalIdAction(**data)


class PaymentSetInterfaceIdActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetInterfaceIdAction`."
    interface_id = marshmallow.fields.String(allow_none=True, data_key="interfaceId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetInterfaceIdAction(**data)


class PaymentSetKeyActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetKeyAction(**data)


class PaymentSetMethodInfoInterfaceActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetMethodInfoInterfaceAction`."
    interface = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetMethodInfoInterfaceAction(**data)


class PaymentSetMethodInfoMethodActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetMethodInfoMethodAction`."
    method = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetMethodInfoMethodAction(**data)


class PaymentSetMethodInfoNameActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetMethodInfoNameAction`."
    name = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetMethodInfoNameAction(**data)


class PaymentSetStatusInterfaceCodeActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetStatusInterfaceCodeAction`."
    interface_code = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="interfaceCode"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetStatusInterfaceCodeAction(**data)


class PaymentSetStatusInterfaceTextActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentSetStatusInterfaceTextAction`."
    interface_text = marshmallow.fields.String(
        allow_none=True, data_key="interfaceText"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentSetStatusInterfaceTextAction(**data)


class PaymentStatusInterfaceCodeSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentStatusInterfaceCodeSetMessage`."
    payment_id = marshmallow.fields.String(allow_none=True, data_key="paymentId")
    interface_code = marshmallow.fields.String(
        allow_none=True, data_key="interfaceCode"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PaymentStatusInterfaceCodeSetMessage(**data)


class PaymentStatusStateTransitionMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentStatusStateTransitionMessage`."
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    force = marshmallow.fields.Bool(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PaymentStatusStateTransitionMessage(**data)


class PaymentTransactionAddedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentTransactionAddedMessage`."
    transaction = marshmallow.fields.Nested(
        nested="commercetools.schemas.TransactionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PaymentTransactionAddedMessage(**data)


class PaymentTransactionStateChangedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentTransactionStateChangedMessage`."
    transaction_id = marshmallow.fields.String(
        allow_none=True, data_key="transactionId"
    )
    state = marshmallow_enum.EnumField(types.TransactionState, by_value=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.PaymentTransactionStateChangedMessage(**data)


class PaymentTransitionStateActionSchema(PaymentUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.PaymentTransitionStateAction`."
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    force = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.PaymentTransitionStateAction(**data)


class ProductAddAssetActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductAddAssetAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset = marshmallow.fields.Nested(
        nested="commercetools.schemas.AssetDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    position = marshmallow.fields.Integer(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductAddAssetAction(**data)


class ProductAddExternalImageActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductAddExternalImageAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    image = marshmallow.fields.Nested(
        nested="commercetools.schemas.ImageSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductAddExternalImageAction(**data)


class ProductAddPriceActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductAddPriceAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductAddPriceAction(**data)


class ProductAddToCategoryActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductAddToCategoryAction`."
    category = marshmallow.fields.Nested(
        nested="commercetools.schemas.CategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    order_hint = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="orderHint"
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductAddToCategoryAction(**data)


class ProductAddVariantActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductAddVariantAction`."
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    key = marshmallow.fields.String(allow_none=True, missing=None)
    prices = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    images = marshmallow.fields.Nested(
        nested="commercetools.schemas.ImageSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    attributes = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductAddVariantAction(**data)


class ProductChangeAssetNameActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductChangeAssetNameAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    name = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductChangeAssetNameAction(**data)


class ProductChangeAssetOrderActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductChangeAssetOrderAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_order = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True), data_key="assetOrder"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductChangeAssetOrderAction(**data)


class ProductChangeMasterVariantActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductChangeMasterVariantAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductChangeMasterVariantAction(**data)


class ProductChangeNameActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductChangeNameAction`."
    name = LocalizedStringField(allow_none=True)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductChangeNameAction(**data)


class ProductChangePriceActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductChangePriceAction`."
    price_id = marshmallow.fields.String(allow_none=True, data_key="priceId")
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductChangePriceAction(**data)


class ProductChangeSlugActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductChangeSlugAction`."
    slug = LocalizedStringField(allow_none=True)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductChangeSlugAction(**data)


class ProductCreatedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductCreatedMessage`."
    product_projection = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductProjectionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="productProjection",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductCreatedMessage(**data)


class ProductDeletedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDeletedMessage`."
    removed_image_urls = marshmallow.fields.List(
        marshmallow.fields.Nested(
            nested="commercetools.schemas.anySchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
        data_key="removedImageUrls",
    )
    current_projection = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductProjectionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="currentProjection",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductDeletedMessage(**data)


class ProductDiscountChangeIsActiveActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountChangeIsActiveAction`."
    is_active = marshmallow.fields.Bool(allow_none=True, data_key="isActive")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountChangeIsActiveAction(**data)


class ProductDiscountChangeNameActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountChangeNameAction`."
    name = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountChangeNameAction(**data)


class ProductDiscountChangePredicateActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountChangePredicateAction`."
    predicate = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountChangePredicateAction(**data)


class ProductDiscountChangeSortOrderActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountChangeSortOrderAction`."
    sort_order = marshmallow.fields.String(allow_none=True, data_key="sortOrder")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountChangeSortOrderAction(**data)


class ProductDiscountChangeValueActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountChangeValueAction`."
    value = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "absolute": "commercetools.schemas.ProductDiscountValueAbsoluteSchema",
            "external": "commercetools.schemas.ProductDiscountValueExternalSchema",
            "relative": "commercetools.schemas.ProductDiscountValueRelativeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountChangeValueAction(**data)


class ProductDiscountReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductDiscountSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.ProductDiscountReference(**data)


class ProductDiscountSetDescriptionActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountSetDescriptionAction`."
    description = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountSetDescriptionAction(**data)


class ProductDiscountSetValidFromActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountSetValidFromAction`."
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountSetValidFromAction(**data)


class ProductDiscountSetValidFromAndUntilActionSchema(
    ProductDiscountUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountSetValidFromAndUntilAction`."
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountSetValidFromAndUntilAction(**data)


class ProductDiscountSetValidUntilActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountSetValidUntilAction`."
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountSetValidUntilAction(**data)


class ProductImageAddedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductImageAddedMessage`."
    variant_id = marshmallow.fields.Integer(allow_none=True, data_key="variantId")
    image = marshmallow.fields.Nested(
        nested="commercetools.schemas.ImageSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    staged = marshmallow.fields.Bool(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductImageAddedMessage(**data)


class ProductLegacySetSkuActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductLegacySetSkuAction`."
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    variant_id = marshmallow.fields.Integer(allow_none=True, data_key="variantId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductLegacySetSkuAction(**data)


class ProductMoveImageToPositionActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductMoveImageToPositionAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    image_url = marshmallow.fields.String(allow_none=True, data_key="imageUrl")
    position = marshmallow.fields.Integer(allow_none=True)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductMoveImageToPositionAction(**data)


class ProductPublishActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductPublishAction`."
    scope = marshmallow_enum.EnumField(
        types.ProductPublishScope, by_value=True, missing=None
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductPublishAction(**data)


class ProductPublishedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductPublishedMessage`."
    removed_image_urls = marshmallow.fields.List(
        marshmallow.fields.Nested(
            nested="commercetools.schemas.anySchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
        data_key="removedImageUrls",
    )
    product_projection = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductProjectionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="productProjection",
    )
    scope = marshmallow_enum.EnumField(types.ProductPublishScope, by_value=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductPublishedMessage(**data)


class ProductReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.ProductReference(**data)


class ProductRemoveAssetActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRemoveAssetAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductRemoveAssetAction(**data)


class ProductRemoveFromCategoryActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRemoveFromCategoryAction`."
    category = marshmallow.fields.Nested(
        nested="commercetools.schemas.CategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductRemoveFromCategoryAction(**data)


class ProductRemoveImageActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRemoveImageAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    image_url = marshmallow.fields.String(allow_none=True, data_key="imageUrl")
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductRemoveImageAction(**data)


class ProductRemovePriceActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRemovePriceAction`."
    price_id = marshmallow.fields.String(allow_none=True, data_key="priceId")
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductRemovePriceAction(**data)


class ProductRemoveVariantActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRemoveVariantAction`."
    id = marshmallow.fields.Integer(allow_none=True, missing=None)
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductRemoveVariantAction(**data)


class ProductRevertStagedChangesActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRevertStagedChangesAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductRevertStagedChangesAction(**data)


class ProductRevertStagedVariantChangesActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRevertStagedVariantChangesAction`."
    variant_id = marshmallow.fields.Integer(allow_none=True, data_key="variantId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductRevertStagedVariantChangesAction(**data)


class ProductRevertedStagedChangesMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductRevertedStagedChangesMessage`."
    removed_image_urls = marshmallow.fields.List(
        marshmallow.fields.Nested(
            nested="commercetools.schemas.anySchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
        data_key="removedImageUrls",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductRevertedStagedChangesMessage(**data)


class ProductSetAssetCustomFieldActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAssetCustomFieldAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAssetCustomFieldAction(**data)


class ProductSetAssetCustomTypeActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAssetCustomTypeAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = marshmallow.fields.Dict(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAssetCustomTypeAction(**data)


class ProductSetAssetDescriptionActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAssetDescriptionAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    description = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAssetDescriptionAction(**data)


class ProductSetAssetKeyActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAssetKeyAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(allow_none=True, data_key="assetId")
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAssetKeyAction(**data)


class ProductSetAssetSourcesActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAssetSourcesAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    sources = marshmallow.fields.Nested(
        nested="commercetools.schemas.AssetSourceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAssetSourcesAction(**data)


class ProductSetAssetTagsActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAssetTagsAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    asset_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetId"
    )
    asset_key = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="assetKey"
    )
    tags = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True), missing=None
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAssetTagsAction(**data)


class ProductSetAttributeActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAttributeAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAttributeAction(**data)


class ProductSetAttributeInAllVariantsActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetAttributeInAllVariantsAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetAttributeInAllVariantsAction(**data)


class ProductSetCategoryOrderHintActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetCategoryOrderHintAction`."
    category_id = marshmallow.fields.String(allow_none=True, data_key="categoryId")
    order_hint = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="orderHint"
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetCategoryOrderHintAction(**data)


class ProductSetDescriptionActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetDescriptionAction`."
    description = LocalizedStringField(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetDescriptionAction(**data)


class ProductSetDiscountedPriceActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetDiscountedPriceAction`."
    price_id = marshmallow.fields.String(allow_none=True, data_key="priceId")
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    discounted = marshmallow.fields.Nested(
        nested="commercetools.schemas.DiscountedPriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetDiscountedPriceAction(**data)


class ProductSetImageLabelActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetImageLabelAction`."
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    image_url = marshmallow.fields.String(allow_none=True, data_key="imageUrl")
    label = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetImageLabelAction(**data)


class ProductSetKeyActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetKeyAction(**data)


class ProductSetMetaDescriptionActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetMetaDescriptionAction`."
    meta_description = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaDescription"
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetMetaDescriptionAction(**data)


class ProductSetMetaKeywordsActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetMetaKeywordsAction`."
    meta_keywords = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaKeywords"
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetMetaKeywordsAction(**data)


class ProductSetMetaTitleActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetMetaTitleAction`."
    meta_title = LocalizedStringField(
        allow_none=True, missing=None, data_key="metaTitle"
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetMetaTitleAction(**data)


class ProductSetPricesActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetPricesAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    prices = marshmallow.fields.Nested(
        nested="commercetools.schemas.PriceDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetPricesAction(**data)


class ProductSetProductPriceCustomFieldActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetProductPriceCustomFieldAction`."
    price_id = marshmallow.fields.String(allow_none=True, data_key="priceId")
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetProductPriceCustomFieldAction(**data)


class ProductSetProductPriceCustomTypeActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetProductPriceCustomTypeAction`."
    price_id = marshmallow.fields.String(allow_none=True, data_key="priceId")
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetProductPriceCustomTypeAction(**data)


class ProductSetProductVariantKeyActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetProductVariantKeyAction`."
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    key = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetProductVariantKeyAction(**data)


class ProductSetSearchKeywordsActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetSearchKeywordsAction`."
    search_keywords = marshmallow.fields.Nested(
        nested="commercetools.schemas.SearchKeywordsSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="searchKeywords",
    )
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetSearchKeywordsAction(**data)


class ProductSetSkuActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetSkuAction`."
    variant_id = marshmallow.fields.Integer(allow_none=True, data_key="variantId")
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    staged = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetSkuAction(**data)


class ProductSetTaxCategoryActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSetTaxCategoryAction`."
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="taxCategory",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductSetTaxCategoryAction(**data)


class ProductSlugChangedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductSlugChangedMessage`."
    slug = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductSlugChangedMessage(**data)


class ProductStateTransitionMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductStateTransitionMessage`."
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    force = marshmallow.fields.Bool(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductStateTransitionMessage(**data)


class ProductTransitionStateActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTransitionStateAction`."
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    force = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTransitionStateAction(**data)


class ProductTypeAddAttributeDefinitionActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeAddAttributeDefinitionAction`."
    attribute = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeDefinitionDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeAddAttributeDefinitionAction(**data)


class ProductTypeAddLocalizedEnumValueActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeAddLocalizedEnumValueAction`."
    attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="attributeName"
    )
    value = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeLocalizedEnumValueSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeAddLocalizedEnumValueAction(**data)


class ProductTypeAddPlainEnumValueActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeAddPlainEnumValueAction`."
    attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="attributeName"
    )
    value = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributePlainEnumValueSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeAddPlainEnumValueAction(**data)


class ProductTypeChangeAttributeConstraintActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeChangeAttributeConstraintAction`."
    attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="attributeName"
    )
    new_value = marshmallow_enum.EnumField(
        types.AttributeConstraintEnumDraft, by_value=True, data_key="newValue"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeChangeAttributeConstraintAction(**data)


class ProductTypeChangeAttributeNameActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeChangeAttributeNameAction`."
    attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="attributeName"
    )
    new_attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="newAttributeName"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeChangeAttributeNameAction(**data)


class ProductTypeChangeAttributeOrderActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeChangeAttributeOrderAction`."
    attributes = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeDefinitionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeChangeAttributeOrderAction(**data)


class ProductTypeChangeDescriptionActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeChangeDescriptionAction`."
    description = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeChangeDescriptionAction(**data)


class ProductTypeChangeEnumKeyActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeChangeEnumKeyAction`."
    attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="attributeName"
    )
    key = marshmallow.fields.String(allow_none=True)
    new_key = marshmallow.fields.String(allow_none=True, data_key="newKey")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeChangeEnumKeyAction(**data)


class ProductTypeChangeInputHintActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeChangeInputHintAction`."
    attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="attributeName"
    )
    new_value = marshmallow_enum.EnumField(
        types.TextInputHint, by_value=True, data_key="newValue"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeChangeInputHintAction(**data)


class ProductTypeChangeIsSearchableActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeChangeIsSearchableAction`."
    attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="attributeName"
    )
    is_searchable = marshmallow.fields.Bool(allow_none=True, data_key="isSearchable")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeChangeIsSearchableAction(**data)


class ProductTypeChangeLabelActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeChangeLabelAction`."
    attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="attributeName"
    )
    label = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeChangeLabelAction(**data)


class ProductTypeChangeLocalizedEnumValueLabelActionSchema(
    ProductTypeUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeChangeLocalizedEnumValueLabelAction`."
    attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="attributeName"
    )
    new_value = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeLocalizedEnumValueSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="newValue",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeChangeLocalizedEnumValueLabelAction(**data)


class ProductTypeChangeLocalizedEnumValueOrderActionSchema(
    ProductTypeUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeChangeLocalizedEnumValueOrderAction`."
    attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="attributeName"
    )
    values = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributeLocalizedEnumValueSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeChangeLocalizedEnumValueOrderAction(**data)


class ProductTypeChangeNameActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeChangeNameAction`."
    name = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeChangeNameAction(**data)


class ProductTypeChangePlainEnumValueLabelActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeChangePlainEnumValueLabelAction`."
    attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="attributeName"
    )
    new_value = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributePlainEnumValueSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="newValue",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeChangePlainEnumValueLabelAction(**data)


class ProductTypeChangePlainEnumValueOrderActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeChangePlainEnumValueOrderAction`."
    attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="attributeName"
    )
    values = marshmallow.fields.Nested(
        nested="commercetools.schemas.AttributePlainEnumValueSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeChangePlainEnumValueOrderAction(**data)


class ProductTypeReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductTypeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.ProductTypeReference(**data)


class ProductTypeRemoveAttributeDefinitionActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeRemoveAttributeDefinitionAction`."
    name = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeRemoveAttributeDefinitionAction(**data)


class ProductTypeRemoveEnumValuesActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeRemoveEnumValuesAction`."
    attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="attributeName"
    )
    keys = marshmallow.fields.List(marshmallow.fields.String(allow_none=True))

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeRemoveEnumValuesAction(**data)


class ProductTypeSetInputTipActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeSetInputTipAction`."
    attribute_name = marshmallow.fields.String(
        allow_none=True, data_key="attributeName"
    )
    input_tip = LocalizedStringField(allow_none=True, missing=None, data_key="inputTip")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeSetInputTipAction(**data)


class ProductTypeSetKeyActionSchema(ProductTypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductTypeSetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductTypeSetKeyAction(**data)


class ProductUnpublishActionSchema(ProductUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductUnpublishAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductUnpublishAction(**data)


class ProductUnpublishedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductUnpublishedMessage`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductUnpublishedMessage(**data)


class ProductVariantDeletedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductVariantDeletedMessage`."
    removed_image_urls = marshmallow.fields.List(
        marshmallow.fields.Nested(
            nested="commercetools.schemas.anySchema",
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
        data_key="removedImageUrls",
    )
    variant = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductVariantSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductVariantDeletedMessage(**data)


class ProjectChangeCountriesActionSchema(ProjectUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProjectChangeCountriesAction`."
    countries = marshmallow.fields.List(marshmallow.fields.String())

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProjectChangeCountriesAction(**data)


class ProjectChangeCurrenciesActionSchema(ProjectUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProjectChangeCurrenciesAction`."
    currencies = marshmallow.fields.List(marshmallow.fields.String())

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProjectChangeCurrenciesAction(**data)


class ProjectChangeLanguagesActionSchema(ProjectUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProjectChangeLanguagesAction`."
    languages = marshmallow.fields.List(marshmallow.fields.String())

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProjectChangeLanguagesAction(**data)


class ProjectChangeMessagesConfigurationActionSchema(ProjectUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProjectChangeMessagesConfigurationAction`."
    messages_configuration = marshmallow.fields.Nested(
        nested="commercetools.schemas.MessageConfigurationDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="messagesConfiguration",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProjectChangeMessagesConfigurationAction(**data)


class ProjectChangeMessagesEnabledActionSchema(ProjectUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProjectChangeMessagesEnabledAction`."
    messages_enabled = marshmallow.fields.Bool(
        allow_none=True, data_key="messagesEnabled"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProjectChangeMessagesEnabledAction(**data)


class ProjectChangeNameActionSchema(ProjectUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProjectChangeNameAction`."
    name = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProjectChangeNameAction(**data)


class ProjectSetShippingRateInputTypeActionSchema(ProjectUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProjectSetShippingRateInputTypeAction`."
    shipping_rate_input_type = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "CartClassification": "commercetools.schemas.CartClassificationTypeSchema",
            "CartScore": "commercetools.schemas.CartScoreTypeSchema",
            "CartValue": "commercetools.schemas.CartValueTypeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
        data_key="shippingRateInputType",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProjectSetShippingRateInputTypeAction(**data)


class ReviewCreatedMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewCreatedMessage`."
    review = marshmallow.fields.Nested(
        nested="commercetools.schemas.ReviewSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ReviewCreatedMessage(**data)


class ReviewRatingSetMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewRatingSetMessage`."
    old_rating = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="oldRating"
    )
    new_rating = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="newRating"
    )
    included_in_statistics = marshmallow.fields.Bool(
        allow_none=True, data_key="includedInStatistics"
    )
    target = helpers.Discriminator(
        discriminator_field=("typeId", "type_id"),
        discriminator_schemas={
            "cart-discount": "commercetools.schemas.CartDiscountReferenceSchema",
            "cart": "commercetools.schemas.CartReferenceSchema",
            "category": "commercetools.schemas.CategoryReferenceSchema",
            "channel": "commercetools.schemas.ChannelReferenceSchema",
            "key-value-document": "commercetools.schemas.CustomObjectReferenceSchema",
            "customer-group": "commercetools.schemas.CustomerGroupReferenceSchema",
            "customer": "commercetools.schemas.CustomerReferenceSchema",
            "discount-code": "commercetools.schemas.DiscountCodeReferenceSchema",
            "inventory-entry": "commercetools.schemas.InventoryEntryReferenceSchema",
            "order-edit": "commercetools.schemas.OrderEditReferenceSchema",
            "order": "commercetools.schemas.OrderReferenceSchema",
            "payment": "commercetools.schemas.PaymentReferenceSchema",
            "product-discount": "commercetools.schemas.ProductDiscountReferenceSchema",
            "product-type": "commercetools.schemas.ProductTypeReferenceSchema",
            "product": "commercetools.schemas.ProductReferenceSchema",
            "review": "commercetools.schemas.ReviewReferenceSchema",
            "shipping-method": "commercetools.schemas.ShippingMethodReferenceSchema",
            "shopping-list": "commercetools.schemas.ShoppingListReferenceSchema",
            "state": "commercetools.schemas.StateReferenceSchema",
            "tax-category": "commercetools.schemas.TaxCategoryReferenceSchema",
            "type": "commercetools.schemas.TypeReferenceSchema",
            "zone": "commercetools.schemas.ZoneReferenceSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ReviewRatingSetMessage(**data)


class ReviewReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.ReviewSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.ReviewReference(**data)


class ReviewSetAuthorNameActionSchema(ReviewUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewSetAuthorNameAction`."
    author_name = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="authorName"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ReviewSetAuthorNameAction(**data)


class ReviewSetCustomFieldActionSchema(ReviewUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewSetCustomFieldAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ReviewSetCustomFieldAction(**data)


class ReviewSetCustomTypeActionSchema(ReviewUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewSetCustomTypeAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ReviewSetCustomTypeAction(**data)


class ReviewSetCustomerActionSchema(ReviewUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewSetCustomerAction`."
    customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ReviewSetCustomerAction(**data)


class ReviewSetKeyActionSchema(ReviewUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewSetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ReviewSetKeyAction(**data)


class ReviewSetLocaleActionSchema(ReviewUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewSetLocaleAction`."
    locale = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ReviewSetLocaleAction(**data)


class ReviewSetRatingActionSchema(ReviewUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewSetRatingAction`."
    rating = marshmallow.fields.Integer(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ReviewSetRatingAction(**data)


class ReviewSetTargetActionSchema(ReviewUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewSetTargetAction`."
    target = marshmallow.fields.Nested(
        nested="commercetools.schemas.ProductReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ReviewSetTargetAction(**data)


class ReviewSetTextActionSchema(ReviewUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewSetTextAction`."
    text = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ReviewSetTextAction(**data)


class ReviewSetTitleActionSchema(ReviewUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewSetTitleAction`."
    title = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ReviewSetTitleAction(**data)


class ReviewStateTransitionMessageSchema(MessageSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewStateTransitionMessage`."
    old_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="oldState",
    )
    new_state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="newState",
    )
    old_included_in_statistics = marshmallow.fields.Bool(
        allow_none=True, data_key="oldIncludedInStatistics"
    )
    new_included_in_statistics = marshmallow.fields.Bool(
        allow_none=True, data_key="newIncludedInStatistics"
    )
    target = helpers.Discriminator(
        discriminator_field=("typeId", "type_id"),
        discriminator_schemas={
            "cart-discount": "commercetools.schemas.CartDiscountReferenceSchema",
            "cart": "commercetools.schemas.CartReferenceSchema",
            "category": "commercetools.schemas.CategoryReferenceSchema",
            "channel": "commercetools.schemas.ChannelReferenceSchema",
            "key-value-document": "commercetools.schemas.CustomObjectReferenceSchema",
            "customer-group": "commercetools.schemas.CustomerGroupReferenceSchema",
            "customer": "commercetools.schemas.CustomerReferenceSchema",
            "discount-code": "commercetools.schemas.DiscountCodeReferenceSchema",
            "inventory-entry": "commercetools.schemas.InventoryEntryReferenceSchema",
            "order-edit": "commercetools.schemas.OrderEditReferenceSchema",
            "order": "commercetools.schemas.OrderReferenceSchema",
            "payment": "commercetools.schemas.PaymentReferenceSchema",
            "product-discount": "commercetools.schemas.ProductDiscountReferenceSchema",
            "product-type": "commercetools.schemas.ProductTypeReferenceSchema",
            "product": "commercetools.schemas.ProductReferenceSchema",
            "review": "commercetools.schemas.ReviewReferenceSchema",
            "shipping-method": "commercetools.schemas.ShippingMethodReferenceSchema",
            "shopping-list": "commercetools.schemas.ShoppingListReferenceSchema",
            "state": "commercetools.schemas.StateReferenceSchema",
            "tax-category": "commercetools.schemas.TaxCategoryReferenceSchema",
            "type": "commercetools.schemas.TypeReferenceSchema",
            "zone": "commercetools.schemas.ZoneReferenceSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    force = marshmallow.fields.Bool(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ReviewStateTransitionMessage(**data)


class ReviewTransitionStateActionSchema(ReviewUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ReviewTransitionStateAction`."
    state = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    force = marshmallow.fields.Bool(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ReviewTransitionStateAction(**data)


class ShippingMethodAddShippingRateActionSchema(ShippingMethodUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodAddShippingRateAction`."
    zone = marshmallow.fields.Nested(
        nested="commercetools.schemas.ZoneReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    shipping_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="shippingRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShippingMethodAddShippingRateAction(**data)


class ShippingMethodAddZoneActionSchema(ShippingMethodUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodAddZoneAction`."
    zone = marshmallow.fields.Nested(
        nested="commercetools.schemas.ZoneReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShippingMethodAddZoneAction(**data)


class ShippingMethodChangeIsDefaultActionSchema(ShippingMethodUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodChangeIsDefaultAction`."
    is_default = marshmallow.fields.Bool(allow_none=True, data_key="isDefault")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShippingMethodChangeIsDefaultAction(**data)


class ShippingMethodChangeNameActionSchema(ShippingMethodUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodChangeNameAction`."
    name = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShippingMethodChangeNameAction(**data)


class ShippingMethodChangeTaxCategoryActionSchema(ShippingMethodUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodChangeTaxCategoryAction`."
    tax_category = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategoryReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="taxCategory",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShippingMethodChangeTaxCategoryAction(**data)


class ShippingMethodReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingMethodSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.ShippingMethodReference(**data)


class ShippingMethodRemoveShippingRateActionSchema(ShippingMethodUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodRemoveShippingRateAction`."
    zone = marshmallow.fields.Nested(
        nested="commercetools.schemas.ZoneReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    shipping_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShippingRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="shippingRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShippingMethodRemoveShippingRateAction(**data)


class ShippingMethodRemoveZoneActionSchema(ShippingMethodUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodRemoveZoneAction`."
    zone = marshmallow.fields.Nested(
        nested="commercetools.schemas.ZoneReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShippingMethodRemoveZoneAction(**data)


class ShippingMethodSetDescriptionActionSchema(ShippingMethodUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodSetDescriptionAction`."
    description = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShippingMethodSetDescriptionAction(**data)


class ShippingMethodSetKeyActionSchema(ShippingMethodUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodSetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShippingMethodSetKeyAction(**data)


class ShippingMethodSetPredicateActionSchema(ShippingMethodUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShippingMethodSetPredicateAction`."
    predicate = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShippingMethodSetPredicateAction(**data)


class ShoppingListAddLineItemActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListAddLineItemAction`."
    sku = marshmallow.fields.String(allow_none=True, missing=None)
    product_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="productId"
    )
    variant_id = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="variantId"
    )
    quantity = marshmallow.fields.Integer(allow_none=True, missing=None)
    added_at = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="addedAt"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListAddLineItemAction(**data)


class ShoppingListAddTextLineItemActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListAddTextLineItemAction`."
    name = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    quantity = marshmallow.fields.Integer(allow_none=True, missing=None)
    added_at = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="addedAt"
    )
    custom = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldsDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListAddTextLineItemAction(**data)


class ShoppingListChangeLineItemQuantityActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListChangeLineItemQuantityAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    quantity = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListChangeLineItemQuantityAction(**data)


class ShoppingListChangeLineItemsOrderActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListChangeLineItemsOrderAction`."
    line_item_order = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True), data_key="lineItemOrder"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListChangeLineItemsOrderAction(**data)


class ShoppingListChangeNameActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListChangeNameAction`."
    name = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListChangeNameAction(**data)


class ShoppingListChangeTextLineItemNameActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListChangeTextLineItemNameAction`."
    text_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="textLineItemId"
    )
    name = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListChangeTextLineItemNameAction(**data)


class ShoppingListChangeTextLineItemQuantityActionSchema(
    ShoppingListUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListChangeTextLineItemQuantityAction`."
    text_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="textLineItemId"
    )
    quantity = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListChangeTextLineItemQuantityAction(**data)


class ShoppingListChangeTextLineItemsOrderActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListChangeTextLineItemsOrderAction`."
    text_line_item_order = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True), data_key="textLineItemOrder"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListChangeTextLineItemsOrderAction(**data)


class ShoppingListReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.ShoppingListSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.ShoppingListReference(**data)


class ShoppingListRemoveLineItemActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListRemoveLineItemAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    quantity = marshmallow.fields.Integer(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListRemoveLineItemAction(**data)


class ShoppingListRemoveTextLineItemActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListRemoveTextLineItemAction`."
    text_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="textLineItemId"
    )
    quantity = marshmallow.fields.Integer(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListRemoveTextLineItemAction(**data)


class ShoppingListSetAnonymousIdActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListSetAnonymousIdAction`."
    anonymous_id = marshmallow.fields.String(
        allow_none=True, missing=None, data_key="anonymousId"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListSetAnonymousIdAction(**data)


class ShoppingListSetCustomFieldActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListSetCustomFieldAction`."
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListSetCustomFieldAction(**data)


class ShoppingListSetCustomTypeActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListSetCustomTypeAction`."
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListSetCustomTypeAction(**data)


class ShoppingListSetCustomerActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListSetCustomerAction`."
    customer = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomerReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListSetCustomerAction(**data)


class ShoppingListSetDeleteDaysAfterLastModificationActionSchema(
    ShoppingListUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListSetDeleteDaysAfterLastModificationAction`."
    delete_days_after_last_modification = marshmallow.fields.Integer(
        allow_none=True, missing=None, data_key="deleteDaysAfterLastModification"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListSetDeleteDaysAfterLastModificationAction(**data)


class ShoppingListSetDescriptionActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListSetDescriptionAction`."
    description = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListSetDescriptionAction(**data)


class ShoppingListSetKeyActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListSetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListSetKeyAction(**data)


class ShoppingListSetLineItemCustomFieldActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListSetLineItemCustomFieldAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListSetLineItemCustomFieldAction(**data)


class ShoppingListSetLineItemCustomTypeActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListSetLineItemCustomTypeAction`."
    line_item_id = marshmallow.fields.String(allow_none=True, data_key="lineItemId")
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListSetLineItemCustomTypeAction(**data)


class ShoppingListSetSlugActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListSetSlugAction`."
    slug = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListSetSlugAction(**data)


class ShoppingListSetTextLineItemCustomFieldActionSchema(
    ShoppingListUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListSetTextLineItemCustomFieldAction`."
    text_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="textLineItemId"
    )
    name = marshmallow.fields.String(allow_none=True)
    value = marshmallow.fields.Raw(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListSetTextLineItemCustomFieldAction(**data)


class ShoppingListSetTextLineItemCustomTypeActionSchema(ShoppingListUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListSetTextLineItemCustomTypeAction`."
    text_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="textLineItemId"
    )
    type = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )
    fields = FieldContainerField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListSetTextLineItemCustomTypeAction(**data)


class ShoppingListSetTextLineItemDescriptionActionSchema(
    ShoppingListUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.ShoppingListSetTextLineItemDescriptionAction`."
    text_line_item_id = marshmallow.fields.String(
        allow_none=True, data_key="textLineItemId"
    )
    description = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ShoppingListSetTextLineItemDescriptionAction(**data)


class StagedOrderSchema(OrderSchema):
    "Marshmallow schema for :class:`commercetools.types.StagedOrder`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.StagedOrder(**data)


class StateAddRolesActionSchema(StateUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StateAddRolesAction`."
    roles = marshmallow.fields.List(
        marshmallow_enum.EnumField(types.StateRoleEnum, by_value=True)
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StateAddRolesAction(**data)


class StateChangeInitialActionSchema(StateUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StateChangeInitialAction`."
    initial = marshmallow.fields.Bool(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StateChangeInitialAction(**data)


class StateChangeKeyActionSchema(StateUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StateChangeKeyAction`."
    key = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StateChangeKeyAction(**data)


class StateChangeTypeActionSchema(StateUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StateChangeTypeAction`."
    type = marshmallow_enum.EnumField(types.StateTypeEnum, by_value=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StateChangeTypeAction(**data)


class StateReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.StateReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.StateReference(**data)


class StateRemoveRolesActionSchema(StateUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StateRemoveRolesAction`."
    roles = marshmallow.fields.List(
        marshmallow_enum.EnumField(types.StateRoleEnum, by_value=True)
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StateRemoveRolesAction(**data)


class StateSetDescriptionActionSchema(StateUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StateSetDescriptionAction`."
    description = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StateSetDescriptionAction(**data)


class StateSetNameActionSchema(StateUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StateSetNameAction`."
    name = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StateSetNameAction(**data)


class StateSetRolesActionSchema(StateUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StateSetRolesAction`."
    roles = marshmallow.fields.List(
        marshmallow_enum.EnumField(types.StateRoleEnum, by_value=True)
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StateSetRolesAction(**data)


class StateSetTransitionsActionSchema(StateUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.StateSetTransitionsAction`."
    transitions = marshmallow.fields.Nested(
        nested="commercetools.schemas.StateReferenceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.StateSetTransitionsAction(**data)


class SubscriptionChangeDestinationActionSchema(SubscriptionUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.SubscriptionChangeDestinationAction`."
    destination = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "EventGrid": "commercetools.schemas.AzureEventGridDestinationSchema",
            "AzureServiceBus": "commercetools.schemas.AzureServiceBusDestinationSchema",
            "GoogleCloudPubSub": "commercetools.schemas.GoogleCloudPubSubDestinationSchema",
            "IronMQ": "commercetools.schemas.IronMqDestinationSchema",
            "SNS": "commercetools.schemas.SnsDestinationSchema",
            "SQS": "commercetools.schemas.SqsDestinationSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.SubscriptionChangeDestinationAction(**data)


class SubscriptionSetChangesActionSchema(SubscriptionUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.SubscriptionSetChangesAction`."
    changes = marshmallow.fields.Nested(
        nested="commercetools.schemas.ChangeSubscriptionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.SubscriptionSetChangesAction(**data)


class SubscriptionSetKeyActionSchema(SubscriptionUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.SubscriptionSetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.SubscriptionSetKeyAction(**data)


class SubscriptionSetMessagesActionSchema(SubscriptionUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.SubscriptionSetMessagesAction`."
    messages = marshmallow.fields.Nested(
        nested="commercetools.schemas.MessageSubscriptionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.SubscriptionSetMessagesAction(**data)


class TaxCategoryAddTaxRateActionSchema(TaxCategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TaxCategoryAddTaxRateAction`."
    tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="taxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TaxCategoryAddTaxRateAction(**data)


class TaxCategoryChangeNameActionSchema(TaxCategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TaxCategoryChangeNameAction`."
    name = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TaxCategoryChangeNameAction(**data)


class TaxCategoryReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.TaxCategoryReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxCategorySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.TaxCategoryReference(**data)


class TaxCategoryRemoveTaxRateActionSchema(TaxCategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TaxCategoryRemoveTaxRateAction`."
    tax_rate_id = marshmallow.fields.String(allow_none=True, data_key="taxRateId")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TaxCategoryRemoveTaxRateAction(**data)


class TaxCategoryReplaceTaxRateActionSchema(TaxCategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TaxCategoryReplaceTaxRateAction`."
    tax_rate_id = marshmallow.fields.String(allow_none=True, data_key="taxRateId")
    tax_rate = marshmallow.fields.Nested(
        nested="commercetools.schemas.TaxRateDraftSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="taxRate",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TaxCategoryReplaceTaxRateAction(**data)


class TaxCategorySetDescriptionActionSchema(TaxCategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TaxCategorySetDescriptionAction`."
    description = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TaxCategorySetDescriptionAction(**data)


class TaxCategorySetKeyActionSchema(TaxCategoryUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TaxCategorySetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TaxCategorySetKeyAction(**data)


class TypeAddEnumValueActionSchema(TypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeAddEnumValueAction`."
    field_name = marshmallow.fields.String(allow_none=True, data_key="fieldName")
    value = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldEnumValueSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TypeAddEnumValueAction(**data)


class TypeAddFieldDefinitionActionSchema(TypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeAddFieldDefinitionAction`."
    field_definition = marshmallow.fields.Nested(
        nested="commercetools.schemas.FieldDefinitionSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        data_key="fieldDefinition",
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TypeAddFieldDefinitionAction(**data)


class TypeAddLocalizedEnumValueActionSchema(TypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeAddLocalizedEnumValueAction`."
    field_name = marshmallow.fields.String(allow_none=True, data_key="fieldName")
    value = marshmallow.fields.Nested(
        nested="commercetools.schemas.CustomFieldLocalizedEnumValueSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TypeAddLocalizedEnumValueAction(**data)


class TypeChangeEnumValueOrderActionSchema(TypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeChangeEnumValueOrderAction`."
    field_name = marshmallow.fields.String(allow_none=True, data_key="fieldName")
    keys = marshmallow.fields.List(marshmallow.fields.String(allow_none=True))

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TypeChangeEnumValueOrderAction(**data)


class TypeChangeFieldDefinitionLabelActionSchema(TypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeChangeFieldDefinitionLabelAction`."
    field_name = marshmallow.fields.String(allow_none=True, data_key="fieldName")
    label = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TypeChangeFieldDefinitionLabelAction(**data)


class TypeChangeFieldDefinitionOrderActionSchema(TypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeChangeFieldDefinitionOrderAction`."
    field_names = marshmallow.fields.List(
        marshmallow.fields.String(allow_none=True), data_key="fieldNames"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TypeChangeFieldDefinitionOrderAction(**data)


class TypeChangeKeyActionSchema(TypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeChangeKeyAction`."
    key = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TypeChangeKeyAction(**data)


class TypeChangeLabelActionSchema(TypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeChangeLabelAction`."
    field_name = marshmallow.fields.String(allow_none=True, data_key="fieldName")
    label = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TypeChangeLabelAction(**data)


class TypeChangeLocalizedEnumValueOrderActionSchema(TypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeChangeLocalizedEnumValueOrderAction`."
    field_name = marshmallow.fields.String(allow_none=True, data_key="fieldName")
    keys = marshmallow.fields.List(marshmallow.fields.String(allow_none=True))

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TypeChangeLocalizedEnumValueOrderAction(**data)


class TypeChangeNameActionSchema(TypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeChangeNameAction`."
    name = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TypeChangeNameAction(**data)


class TypeReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.TypeSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.TypeReference(**data)


class TypeRemoveFieldDefinitionActionSchema(TypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeRemoveFieldDefinitionAction`."
    field_name = marshmallow.fields.String(allow_none=True, data_key="fieldName")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TypeRemoveFieldDefinitionAction(**data)


class TypeSetDescriptionActionSchema(TypeUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.TypeSetDescriptionAction`."
    description = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.TypeSetDescriptionAction(**data)


class ZoneAddLocationActionSchema(ZoneUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneAddLocationAction`."
    location = marshmallow.fields.Nested(
        nested="commercetools.schemas.LocationSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ZoneAddLocationAction(**data)


class ZoneChangeNameActionSchema(ZoneUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneChangeNameAction`."
    name = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ZoneChangeNameAction(**data)


class ZoneReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas.ZoneSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.ZoneReference(**data)


class ZoneRemoveLocationActionSchema(ZoneUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneRemoveLocationAction`."
    location = marshmallow.fields.Nested(
        nested="commercetools.schemas.LocationSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ZoneRemoveLocationAction(**data)


class ZoneSetDescriptionActionSchema(ZoneUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneSetDescriptionAction`."
    description = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ZoneSetDescriptionAction(**data)


class ZoneSetKeyActionSchema(ZoneUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneSetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ZoneSetKeyAction(**data)
